

sub cgiAdmExportTAB {

wbExport( 'DEFAULT', 'TAB', $CGI{'fields'} );
wodaExit();
}


sub wbExport {

local ( $sort, $format, $fields ) = @_;
print "Content-type: text/plain\n\n";    ### unless $HTMLFILE;


( $allHits, *records, *fields ) = &recSelect( '', '', $sort, $format, $fields );

print &formatFoundHeader( $format, *fields );
foreach $r (@records) {
print $r;
print "\n" if $format =~ m/^CSV/;

}
print &formatFoundFooter( $format, *fields );
}


sub formatFoundHeader {

local ( $format, *fields ) = @_;
local ( $f, $hd, $ft );

@fields = &visibleFields(@fields);

if ( $format eq 'TABLE' ) {
$hd = '<tr class="DATAH" ><th>&nbsp;</th>' . "\n";
}
else {
$hd = '';
}

foreach $f (@fields) {
if ( $format eq 'TABLE' ) {
$x = &formatFieldName($f);
$hd .= '<th align="left">' . $x . '</th>';
}
elsif ( $format eq 'TAB' ) {
$hd .= "$f\t";
}
elsif ( $format eq 'CSV' ) {
$hd .= "$f,";
}
elsif ( $format eq 'CSVS' ) {
$hd .= "$f;";
}
}

if (   $format eq 'TAB'
|| $format eq 'CSV'
|| $format eq 'CSVS' )
{
chop($hd);
}

if ( $format eq 'TABLE' ) {
$hd .= "</tr>";
}

$hd .= "\n" if $hd ne '';

return $hd;
}


sub formatFoundFooter {
return '';
}
1;
