

sub cgiAdmLogfilePrint {

$lf = $CGI{'logfile'} || &logFile();

if ( $lf =~ m|$DATADIR/_log/| ) {
$lf = $';
}

if ( $lf =~ m/\.\.|\/\// ) {
wbError( "Bad logfile", $lf );
return;
}

$search = $CGI{'search'};

@hnos = ( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 );
@hdrs = ( 'stat', 'time', 'when', 'from', 'user', 'group', 'application', 'method', 'page', 'parameters', 'other' );

if ( $CGI{'refresh'} && $CGI{'refresh'} > 5 ) {
printHead( "Log file: $&", "Refresh: 5\n" );
}
else {
printHead("Log file: $&");
}

@v      = ( 'normal', 'short', 'long', 'count', 'shows', 'searches' );
@n      = @v;
$format = $CGI{'format'};
$field  = $CGI{'field'};
$o      = &wbFormatOptions( *v, *n, $format );
$f      = &wbFormatOptions( *hnos, *hdrs, $field );

@names = ( 'Search:', 'In file:', 'Format:', 'Count field:', 'Refresh after:', 'Show last:', '' );
@vals = (
qq(<input name="search" value="$search" size="40">),
qq(<input name="logfile" value="$lf" size="40"> ... ".*log" for all),
qq(<select name="format">$o</select>),
qq(<select name="field">$f</select> if Format is count),
qq(<input name="refresh" value="$CGI{'refresh'}" size="3"> seconds.),
qq(<input name="last" value="$CGI{'last'}" size="3"> seconds.),
qq(<input class="BUTTON" type="submit" name="action" value="OK">)
);

$in = qq(<form action="$SCRIPT/AdmLogfilePrint">) . &formatNameVal( @names, @vals ) . qq(</form>);

if ( $CGI{'refresh'} ) {
print <<EOM;
<p>
Hits in the last $CGI{'last'} seconds. Screen will refresh every $CGI{'refresh'} seconds.
</p>
EOM
}
else {
print &formatWindow( 'Define log printout settings', $in );
}

print "<p><br CLEAR=ALL><p><br>";

return unless $CGI{'action'} ne '';


open( h, "$DATADIR/_log/robots" );
while ( $x = <h> ) {
$x =~ m/([^\s]*)$/;
$robot{$1} = '1';
}
close(h);

opendir( D, "$DATADIR/_log" );
@f = readdir(D);
closedir(D);

@f = grep( !/^\./, @f );
@f = sort(@f);

if ( $CGI{'format'} eq 'count' ) {
admLogCount();
}
elsif ( $CGI{'format'} eq 'shows' ) {
admLogCount('shows');
}
elsif ( $CGI{'format'} eq 'searches' ) {
admLogCount('searches');
}
else {
admLogShow();
}
}


sub wbFormatOptions {

local ( *v, *t, $default ) = @_;
local ( $nItems, $i );

$nItems = $#v;
$_      = '';
foreach ( $i = 0 ; $i <= $nItems ; $i++ ) {
if ( $default ne '' && $default eq $v[$i] ) {
$_ .= "<option value=\"$v[$i]\" SELECTED>$t[$i]\n";
}
else {
$_ .= "<option value=\"$v[$i]\">$t[$i]\n";
}
}

return $_;
}


sub admLogCount {

local ($what) = @_;

$dPatt = $dPatt2 = '';

if ( $what eq 'shows' ) {
$dAction = 'Show';
$dPatt   = 'id=([^&]*)';    # Show?id=1234
$dPatt2  = '^([^&=]*)';     # Show?1234
print "<h3>Records shown most often</h3>\n";
}
elsif ( $what eq 'searches' ) {
$dAction = 'Search';
$dPatt   = 'search=([^&]*)';
print "<h3>Searches did most often</h3>\n";
}
else {
print "<h3>Log counts</h3>\n";
}

$search = '.' if $search eq '';
$field = $CGI{'field'};

undef %count;

print "<p>In log files:\n";

foreach $f (@f) {
next unless $f =~ m/$lf/;
open( h, "$DATADIR/_log/$f" ) || wbFail("Could not open $f");
print "$f\n";
while (<h>) {
next unless $_ =~ m/$search/;
@x = split( /\t/, $_ );

$rr++;
$r++;
next if $robot{ $x[3] } == 1;

$r--;

if ( $what ne '' ) {

next unless $x[8] =~ m/^$dAction/;
if ( $x[9] =~ m/$dPatt/ ) {
$count{$1}++;
}
if ( $dPatt2 && $x[9] =~ m/$dPatt2/ ) {
$count{$1}++;
}
}
else {
$count{ $x[$field] }++;
}
}
}

@a = keys(%count);
@a = sort { $count{$b} <=> $count{$a} } @a;

print "<br>Ignored $r robot accesses if $rr accesses from IPs in _LOG/robots <pre>";

$i = 1;
foreach $x (@a) {
print "$i\t$count{$x}\t$x\n";
$i++;
}
print "</pre>";
}


sub admLogShow {

print '<h3>Log data</h3>';
print '<table class="DATATABLE" cellspacing="1"><tr class="DATAH" ><th>';

@x = @hdrs;
$x[10] = '' unless $format eq 'long';
$x[1] = $x[5] = $x[6] = $x[7] = $x[9] = $x[10] = '' if $format eq 'short';

print join( '</th><th align="left">', @x );
print "</th></tr>\n";

$i      = 0;
$n      = 0;
$search = '.' if $search eq '';

foreach $f (@f) {
next unless $f =~ m/$lf/;
open( h, "$DATADIR/_log/$f" ) || wbFail("Could not open $f");
while (<h>) {
next unless $_ =~ m/$search/;
@x = split( /\t/, $_ );

if ( $CGI{'last'} && time - $CGI{'last'} > $x[2] ) {
next;
}

$x[2] = &formatDate( $x[2] );
$x[2] =~ s/ /&nbsp;/g;

$x[10] = '' unless $format eq 'long';
$x[1] = $x[5] = $x[6] = $x[7] = $x[9] = $x[10] = ''
if $format eq 'short';

print qq~<tr class="DATA$i" valign="top"><td>\n~;
print join( "</td>\n<td>", @x );
print "</td></tr>\n\n";
$i = $i ? 0 : 1;
$n++;
}
}
print "</table>";
print "<p>$n entries found\n";
}


sub formatNameVal {

local ($v0) = ( $#_ + 1 ) / 2;
local ( $i, $out );

return '&nbsp;' if $v0 == 0;    # empty table kills validation

$out = '<table cellspacing="0">' . "\n";
$v   = $v0;
for ( $i = 0 ; $i < $v0 ; $i++ ) {
$out .= qq(<tr valign="top"><th align="right">$_[$i]</th><td>$_[$v]</td></tr>\n);
$v++;
}

$out .= "</table>\n";

return $out;
}
1;
