

sub cgiAdmMailForm {

return unless &saveFormCan('AdmMailForm');    # sets $SaveFormButton, sets %CGI

printHead("Send serial email");

wbSortFields();
$f = join( '}, $rec{', @IFields );
$f = "\$rec{$f}";

print <<EOM;
$SaveFormForm

<p>HELP: Fill in the fields. Use \$rec{'fieldname'} notation
to denote field data e.g. if the email address is in the 'email'
field, write \$rec{'email'} into the To field. Use normal search syntax
in the search field. Use preprocessing field to define any processing
to be done before a record is composed (e.g. &PIC() to get nicely formatted
values of fields.
<p><b>The fields in this table are:</b>
$f
<form class="FORM" name="searchForm" action="$SCRIPT/AdmMailSend" method="post">
EOM

$me = $CGI{'from'} || $WBB{'managerEmail'};
$em = $CGI{'to'}   || '$rec{\'email\'}';

@prompts = ( 'Search:', 'Preprocessing:', 'From:', 'To:', 'Cc:', 'Subject:', 'Message:', 'Send to:', 'Action:' );
@flds = (
&wbSearchForm( $CGI{'search'}, 'HISTORY' ),
qq(<textarea wrap="PHYSICAL" name="process" rows="5" cols="50">$CGI{'process'}</textarea>),
qq(<input name="from" size="40" value="$me">),
qq(<input name="to" size="40" value="$em">),
qq(<input name="cc" size="40" value="$me">),
qq(<input name="subject" size="40" value="$CGI{'subject'}">),
qq(<textarea wrap=\"PHYSICAL\" name="message" rows="15" cols="50">$CGI{'message'}</textarea>),
qq(<select name="where"><option>SCREEN<option>MAIL<option value="PERL">SCREEN AS PERL CODE</select> Try 'SCREEN' first to check that the right content is sent!),
qq(<input class="BUTTON" type="submit"  value="Send"> <input class="BUTTON" type="reset"  value="reset" > $SaveFormButton )
);

print &formatNameVal( @prompts, @flds );
print "</form>\n";
}


sub saveFormCan {

local ($caller) = @_;


if ( $CGI{'formdata'} ne '' ) {
hashImport( *CGI, $CGI{'formdata'} );
delete $CGI{'_formid'};
delete $CGI{'_formname'};
delete $CGI{'_form'};
}

if ( $CGI{'listall'} ne '' ) {
cgiFormsList($caller);
return 0;
}

$sfa            = 'Save form as';    #UK
$SaveFormButton = <<EOM;
<input type="hidden" name="_form" value="$caller"><input class="BUTTON" type="submit"  name="saveform" value="$sfa">
<input name="_formname" size="15">
EOM


@rows = &hashRead("$DATADIR/_friend/$User.forms");
@rows = grep( /_form.$caller/, @rows );

if ( $#rows >= 0 ) {

$select = '<option value="">';
foreach $row (@rows) {
hashImport( *x, $row );
if ( $x{_formid} eq $CGI{'select'} ) {
%CGI = %x;
$d   = 'SELECTED';
}
else {
$d = '';
}
$x = $x{_formname};
$select .= qq(<option value="$x{_formid}" $d>$x);
}

$SaveFormForm = <<EOM;
<form class="FORM" action="$SCRIPT/$caller">
Archived forms: <select name="select">
$select
</select>
<input class="BUTTON" type="submit"  value="Load">
<input class="BUTTON" type="submit"  name="listall" value="List all">
</form>
EOM

}
else {

$SaveFormForm = '';

}

return 1;
}


sub cgiFormsList {

$dform = $CGI{'form'};

if ($dform) {
printHead("Saved forms of user $User related to $dform");    #UK
}
else {
printHead("All saved forms of user $User");                  #UK
}

@rows = &hashProcess("$DATADIR/_friend/$User.forms");

print <<EOM;
<p>Click on delete icons to delete archived form.
<p>
EOM


print '<table class="DATATABLE" cellspacing="1">', "\n";

foreach $row (@rows) {
undef %hash;
hashImport( *hash, $row );
next if $dform && $hash{_form} ne $dform;
$id   = $hash{_formid};
$form = $hash{_form};
$name = $hash{_formname};
print <<EOM;
<tr class="DATA0"  valign="top">
<td>
<a href="$SCRIPT/FormsList?delete=$id">
<img $SMALLICONPAR src="$ICONURL/del.gif" alt="Delete this form" title="Delete this form"></a>
</td>
<td align="right">
$form
</td>
<td>
<a href="$SCRIPT/$form?select=$id">$name</a>
</td>
<td>
EOM

foreach $key ( sort( keys(%hash) ) ) {
next if $key =~ m/^_formid|^_form|^_formname|^_confirm/;
$val = $hash{$key};
$val = &htQuote($val);
print "<b>$key</b>=$val\n" if $val;
}

print "</td></tr>\n";

}

print "</table>";
}


sub hashProcess {

local ($file) = @_;

@rows = &hashRead($file);
@rows = &hashDelete(@rows);
hashWrite( $file, *rows );

return @rows;
}


sub hashDelete {

local (@rows) = @_;
local (@out);

foreach $row (@rows) {
$row =~ m/_formid.(\d+)/;
next if $CGI{'delete'} eq $1;
push( @out, $row );
}
return @out;
}


sub hashRead {

local ($file) = @_;
local (@rows);
open( h, $file );
while (<h>) {
chop;
push( @rows, $_ );
}
close(h);

return @rows;
}


sub hashWrite {

local ( $file, *rows ) = @_;
open( h, ">$file" );
binmode(h);
foreach $_ (@rows) {
print h $_ . "\n";
}
close(h);
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub formatNameVal {

local ($v0) = ( $#_ + 1 ) / 2;
local ( $i, $out );

return '&nbsp;' if $v0 == 0;    # empty table kills validation

$out = '<table cellspacing="0">' . "\n";
$v   = $v0;
for ( $i = 0 ; $i < $v0 ; $i++ ) {
$out .= qq(<tr valign="top"><th align="right">$_[$i]</th><td>$_[$v]</td></tr>\n);
$v++;
}

$out .= "</table>\n";

return $out;
}
1;
