

sub cgiAdmMailSend {

return unless &saveFormToolbar();

if ( $CGI{'where'} eq 'PERL' ) {
print "Content-type: text/plain\n\n";
print <<EOM;

EOM
foreach $name ( keys(%CGI) ) {
next if $name =~ m/name|where|paint/;
print '$CGI{' . $name . "} = <<'EOM';\n$CGI{$name}\nEOM\n\n";
}
print "do cgiAdmMailForm();";
return;
}

printHead("Sending Serial Mail");

open( h, ">>$DATADIR/_log/serialmails" );
flock( h, 2 );
print h &hashExport(*CGI);
print h "\n";
close(h);

$CGI{'to'}   =~ s/\@/\\\@/;
$CGI{'cc'}   =~ s/\@/\\\@/;
$CGI{'from'} =~ s/\@/\\\@/;

( $x, *smids ) = &recSelect( '', $CGI{'search'}, '', 'TAB', '_id', 0, 99999999 );

print "<p>Sending $x messages.<ol>\n";

foreach $id (@smids) {


recRead($id);


&evalSafe( $CGI{'process'} );
wbError($@) if $@;

$cc      = &evalSafe( '"' . "$CGI{'cc'}" . '"' );
$to      = &evalSafe( '"' . "$CGI{'to'}" . '"' );
$from    = &evalSafe( '"' . "$CGI{'from'}" . '"' );
$subject = &evalSafe( '"' . "$CGI{'subject'}" . '"' );
$message = &evalSafe( '"' . "$CGI{'message'}" . '"' );
$mess    = <<EOM;
From: $from
Reply-to: $from
Cc: $cc
To: $to
Subject: $subject

$message
EOM

if ( $to =~ m/\w\@\w/ ) {

}
else {
print qq(<li><em class="ERROR">Bad destination address 'To:$to'</em></li>\n);
next;
}

if ( $CGI{'where'} eq 'MAIL' ) {
if ( !&sendMail($mess) ) {
print "<li>To: $to\n";
}
else {
print '<li><em class="ERROR">Error sending mesage</em></li>', "\n";
}
}
else {
$mess = &htQuote($mess);
print "<li><pre>$mess</pre><hr></li>\n";
}
}

print "</ol>\n";
}


sub saveFormToolbar {


if ( $CGI{'saveform'} ne '' ) {
delete $CGI{'saveform'};
$CGI{'formdata'} = &hashExport(*CGI);
cgiFormSave();
return 0;    # caller must return too
}


if ( $CGI{'_form'} ) {
$x        = &hashExport(*CGI);
$x        = &htEscape($x);
$Formdata = $x;
push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'FormSave' ) && !$agentFile;
<a href="$SCRIPT/FormSave?formdata=$Formdata"><img $ICONPAR src="$ICONURL/formsave.gif" alt="Save form data" title="Save form data" $TargetParent></a>
EOM
}

return 1;

}


sub cgiFormSave {

printHead("Saving form data");    #UK

$eFormdata = &htQuote( $CGI{'formdata'} );

hashImport( *x, $CGI{'formdata'} );

$x{_formname} = $CGI{'_formname'};

if ( $x{_formname} eq '' ) {

%y = %x;
foreach $key ( keys(%y) ) {
delete $y{$key} if $y{$key} eq '';
}

$h = &formatHash( "Parameters to be saved are:", 1, %y );    #UK

$a = "Define name";                                          #UK
$p = "Save";                                                 #UK
$b = <<EOM;                                                  #UK
<form action="$SCRIPT/FormSave">
Before a form can be saved, it must be named:<br>
<input name="_formname" size="30">
<input type="hidden" name="formdata" value="$eFormdata">
&nbsp;
<input class="BUTTON" type="submit"  value="Save">
</form>
$h
EOM
print &formatWindow( $a, $b );
return;
}
else {
$formdata = &hashExport(*x);


saveFormAppend($formdata);
$dform = $x{_form};

saveFormSavedMessage($dform);
}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}


sub cgiAdmMailForm {

return unless &saveFormCan('AdmMailForm');    # sets $SaveFormButton, sets %CGI

printHead("Send serial email");

wbSortFields();
$f = join( '}, $rec{', @IFields );
$f = "\$rec{$f}";

print <<EOM;
$SaveFormForm

<p>HELP: Fill in the fields. Use \$rec{'fieldname'} notation
to denote field data e.g. if the email address is in the 'email'
field, write \$rec{'email'} into the To field. Use normal search syntax
in the search field. Use preprocessing field to define any processing
to be done before a record is composed (e.g. &PIC() to get nicely formatted
values of fields.
<p><b>The fields in this table are:</b>
$f
<form class="FORM" name="searchForm" action="$SCRIPT/AdmMailSend" method="post">
EOM

$me = $CGI{'from'} || $WBB{'managerEmail'};
$em = $CGI{'to'}   || '$rec{\'email\'}';

@prompts = ( 'Search:', 'Preprocessing:', 'From:', 'To:', 'Cc:', 'Subject:', 'Message:', 'Send to:', 'Action:' );
@flds = (
&wbSearchForm( $CGI{'search'}, 'HISTORY' ),
qq(<textarea wrap="PHYSICAL" name="process" rows="5" cols="50">$CGI{'process'}</textarea>),
qq(<input name="from" size="40" value="$me">),
qq(<input name="to" size="40" value="$em">),
qq(<input name="cc" size="40" value="$me">),
qq(<input name="subject" size="40" value="$CGI{'subject'}">),
qq(<textarea wrap=\"PHYSICAL\" name="message" rows="15" cols="50">$CGI{'message'}</textarea>),
qq(<select name="where"><option>SCREEN<option>MAIL<option value="PERL">SCREEN AS PERL CODE</select> Try 'SCREEN' first to check that the right content is sent!),
qq(<input class="BUTTON" type="submit"  value="Send"> <input class="BUTTON" type="reset"  value="reset" > $SaveFormButton )
);

print &formatNameVal( @prompts, @flds );
print "</form>\n";
}


sub saveFormCan {

local ($caller) = @_;


if ( $CGI{'formdata'} ne '' ) {
hashImport( *CGI, $CGI{'formdata'} );
delete $CGI{'_formid'};
delete $CGI{'_formname'};
delete $CGI{'_form'};
}

if ( $CGI{'listall'} ne '' ) {
cgiFormsList($caller);
return 0;
}

$sfa            = 'Save form as';    #UK
$SaveFormButton = <<EOM;
<input type="hidden" name="_form" value="$caller"><input class="BUTTON" type="submit"  name="saveform" value="$sfa">
<input name="_formname" size="15">
EOM


@rows = &hashRead("$DATADIR/_friend/$User.forms");
@rows = grep( /_form.$caller/, @rows );

if ( $#rows >= 0 ) {

$select = '<option value="">';
foreach $row (@rows) {
hashImport( *x, $row );
if ( $x{_formid} eq $CGI{'select'} ) {
%CGI = %x;
$d   = 'SELECTED';
}
else {
$d = '';
}
$x = $x{_formname};
$select .= qq(<option value="$x{_formid}" $d>$x);
}

$SaveFormForm = <<EOM;
<form class="FORM" action="$SCRIPT/$caller">
Archived forms: <select name="select">
$select
</select>
<input class="BUTTON" type="submit"  value="Load">
<input class="BUTTON" type="submit"  name="listall" value="List all">
</form>
EOM

}
else {

$SaveFormForm = '';

}

return 1;
}


sub cgiFormsList {

$dform = $CGI{'form'};

if ($dform) {
printHead("Saved forms of user $User related to $dform");    #UK
}
else {
printHead("All saved forms of user $User");                  #UK
}

@rows = &hashProcess("$DATADIR/_friend/$User.forms");

print <<EOM;
<p>Click on delete icons to delete archived form.
<p>
EOM


print '<table class="DATATABLE" cellspacing="1">', "\n";

foreach $row (@rows) {
undef %hash;
hashImport( *hash, $row );
next if $dform && $hash{_form} ne $dform;
$id   = $hash{_formid};
$form = $hash{_form};
$name = $hash{_formname};
print <<EOM;
<tr class="DATA0"  valign="top">
<td>
<a href="$SCRIPT/FormsList?delete=$id">
<img $SMALLICONPAR src="$ICONURL/del.gif" alt="Delete this form" title="Delete this form"></a>
</td>
<td align="right">
$form
</td>
<td>
<a href="$SCRIPT/$form?select=$id">$name</a>
</td>
<td>
EOM

foreach $key ( sort( keys(%hash) ) ) {
next if $key =~ m/^_formid|^_form|^_formname|^_confirm/;
$val = $hash{$key};
$val = &htQuote($val);
print "<b>$key</b>=$val\n" if $val;
}

print "</td></tr>\n";

}

print "</table>";
}


sub hashProcess {

local ($file) = @_;

@rows = &hashRead($file);
@rows = &hashDelete(@rows);
hashWrite( $file, *rows );

return @rows;
}


sub hashDelete {

local (@rows) = @_;
local (@out);

foreach $row (@rows) {
$row =~ m/_formid.(\d+)/;
next if $CGI{'delete'} eq $1;
push( @out, $row );
}
return @out;
}


sub hashRead {

local ($file) = @_;
local (@rows);
open( h, $file );
while (<h>) {
chop;
push( @rows, $_ );
}
close(h);

return @rows;
}


sub hashWrite {

local ( $file, *rows ) = @_;
open( h, ">$file" );
binmode(h);
foreach $_ (@rows) {
print h $_ . "\n";
}
close(h);
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub formatNameVal {

local ($v0) = ( $#_ + 1 ) / 2;
local ( $i, $out );

return '&nbsp;' if $v0 == 0;    # empty table kills validation

$out = '<table cellspacing="0">' . "\n";
$v   = $v0;
for ( $i = 0 ; $i < $v0 ; $i++ ) {
$out .= qq(<tr valign="top"><th align="right">$_[$i]</th><td>$_[$v]</td></tr>\n);
$v++;
}

$out .= "</table>\n";

return $out;
}
1;
