

sub cgiAdmManySetForm {

$field = $CGI{'field'};

if ( $field ne '' ) {
printHead("Change field $field in many records");

if ( $field eq 'search' ) {
wbError( 'Field with this name causes problems', 'Editing not allowed' );
}

if ( $CGI{'how'} eq 'input' ) {
$name  = $field . ":";
$input = qq(<input name="$field">);
}
else {
$Help = 1;
wbFormFieldItems($field);
$name  = "Change $Form{$field,'name'}";
$input = "$Form{$field,'prompt'}<br>$Form{$field,'input'}<br>$Form{$field,'help'}";
}

if ( $CGI{'select'} eq 'search' ) {
$ps = "Search for records:";
$fs = &wbSearchForm( $CGI{'search'}, 'HISTORY' );
}
elsif ( $CGI{'select'} eq 'records' ) {
$ps = "Record IDs";
$fs = qq(Enter one per row:<br><textarea wrap="PHYSICAL" name="_records" rows="10" cols="40">$CGI{'process'}</textarea>);
}
else {
readBasket();
$ps = "Records in the basket:";
$fs = join( ', ', @BasketID )
|| '<em class="ERROR">Basket empty!</em>';
}

print <<EOM;

<p>This lets you set a field to <em>the same value</em> in many records.</p>
<form class="FORM" name="searchForm" action="$SCRIPT/AdmManySet" method="post">
EOM

@prompts = ( $ps, "$name", 'Action:' );
@flds = (
$fs,
$input,
qq(
<input name="_field" type="hidden" value="$field">
<input class="BUTTON" type="submit" name="_action" value="Preview">
<input name="_action" class="BUTTON" type="submit" value="Modify them!">
<input class="BUTTON" type="reset" value="Reset">
)
);

print &formatNameVal( @prompts, @flds );
print "</form>\n";

}
else {
printHead("Change one field in many records");

wbSortFields();
$flds = '<select name="field">' . "\n";
foreach $f (@IFields) {
next if $f eq '_id';
$flds .= "<option>$f\n";
}
$flds .= "</select>";

$selects = 'SELECTED' if $CGI{'select'} eq 'search';
$selectr = 'SELECTED' if $CGI{'select'} eq 'records';
$selectb = 'SELECTED' if $CGI{'select'} eq 'basket';

print <<EOM;
<p>Field will be set to the same one value in many records. You need to define:</p>
<form class="FORM" action="$SCRIPT/AdmManySetForm">
<input name="search" type="HIDDEN" value="$CGI{search}">
<table cellspacing="0" width="100%">
<tr>
<td>How to select the records:</td>
<td>
<select name="select">
<option value="search"  $selects >by using a search
<option value="records" $selectr >by entering several record IDs
<option value="basket"  $selectb >by using records from the basket 
</select>
</td>
</tr>
<tr>
<td>Which field to change:</td>
<td>$flds<td>
</tr>
<tr>
<td>How to edit the field:</td>
<td>
<select name="how">
<option value="nice">as in forms
<option value="input">as a plain input field
</select>
</td>
</tr>
<td>&nbsp;</td>
<td>
<input class="BUTTON" type="submit" value="Continue ...">
</td>
</tr>
</table>
</form>
EOM

}
}


sub formatNameVal {

local ($v0) = ( $#_ + 1 ) / 2;
local ( $i, $out );

return '&nbsp;' if $v0 == 0;    # empty table kills validation

$out = '<table cellspacing="0">' . "\n";
$v   = $v0;
for ( $i = 0 ; $i < $v0 ; $i++ ) {
$out .= qq(<tr valign="top"><th align="right">$_[$i]</th><td>$_[$v]</td></tr>\n);
$v++;
}

$out .= "</table>\n";

return $out;
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}
1;
