

sub cgiAdmRegisteredMailSend {

return unless &saveFormToolbar();

printHead("Sending Serial Mail to Registered Friends");
@all = &regSelect( $CGI{'search'} );
$x   = $#all + 1;

print "<p>Sending $x messages.<ol>\n";

foreach $_ (@all) {
chop $_;
( $id, $to, $n ) = split( /\t/, $_, 3 );

$mess = <<EOM;
From: $CGI{'from'}
Cc: $CGI{'from'}
To: $to
Reply-to: $from
Subject: $CGI{'subject'}

$CGI{'message'}
EOM

if ( &isEmail($to) ) {

}
else {
$to = &htQuote($to);
print '<li><em class="ERROR">Bad destination address ', $to, ' </em>', "\n";
next;
}

if ( $CGI{'where'} eq 'MAIL' ) {
if ( !&sendMail($mess) ) {
print "<li>To: $to\n";
}
else {
print '<li><em class="ERROR">Error sending mesage</em>', "\n";
}
}
else {
print "<li><pre>$mess</pre><hr>\n";
}
}

print "</ol>\n";
}


sub regSelect {

local ($filter) = @_;

open( h, "$DATADIR/_cache/register.txt" );
@all = <h>;
close(h);
@all = grep ( /$filter/i, @all );
return @all;
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}


sub saveFormToolbar {


if ( $CGI{'saveform'} ne '' ) {
delete $CGI{'saveform'};
$CGI{'formdata'} = &hashExport(*CGI);
cgiFormSave();
return 0;    # caller must return too
}


if ( $CGI{'_form'} ) {
$x        = &hashExport(*CGI);
$x        = &htEscape($x);
$Formdata = $x;
push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'FormSave' ) && !$agentFile;
<a href="$SCRIPT/FormSave?formdata=$Formdata"><img $ICONPAR src="$ICONURL/formsave.gif" alt="Save form data" title="Save form data" $TargetParent></a>
EOM
}

return 1;

}


sub cgiFormSave {

printHead("Saving form data");    #UK

$eFormdata = &htQuote( $CGI{'formdata'} );

hashImport( *x, $CGI{'formdata'} );

$x{_formname} = $CGI{'_formname'};

if ( $x{_formname} eq '' ) {

%y = %x;
foreach $key ( keys(%y) ) {
delete $y{$key} if $y{$key} eq '';
}

$h = &formatHash( "Parameters to be saved are:", 1, %y );    #UK

$a = "Define name";                                          #UK
$p = "Save";                                                 #UK
$b = <<EOM;                                                  #UK
<form action="$SCRIPT/FormSave">
Before a form can be saved, it must be named:<br>
<input name="_formname" size="30">
<input type="hidden" name="formdata" value="$eFormdata">
&nbsp;
<input class="BUTTON" type="submit"  value="Save">
</form>
$h
EOM
print &formatWindow( $a, $b );
return;
}
else {
$formdata = &hashExport(*x);


saveFormAppend($formdata);
$dform = $x{_form};

saveFormSavedMessage($dform);
}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}
1;
