

sub cgiAdmStatistics {

printHead('Database statistics');
chdir($DATADIR);
print "<h3>Number of Records</h3>\n";
recAll();
$numFiles = ( scalar keys %IDS );
print "<p>$numFiles records</p>\n";
print "<h3>Age of Records</h3>\n";
$now = time;
while ( $id = &recNext() ) {
recRead($id);
$week[ int( ( time - $rec{'_at'} ) / ( 7 * 24 * 3600 ) ) ]++;
}
print '<table border="1"><tr  class="DATAH"><th>week</th><td># records</td></tr>';
for ( $i = 0 ; $i <= $#week ; $i++ ) {
print '<tr><th>', $i + 1, '</th><td>', $week[$i], '</td></tr>';
}
print '<tr><th>total</th><td>' . $numFiles . '</td></tr></table>';
print '<h3>Capacity Used by Attachments</h3>';
$text = $WBB{'quotaText'} || 'not defined';
$bin  = $WBB{'quotaBin'}  || 'not defined';
( $ptext, $pbin ) = &ddQuota();
print <<EOM;
<table border="1">
<tr class="DATAH">
<th>class</th><th>quota</th><th>used</th></tr>
<th>text</th><td>$text</td><td>$ptext</td></tr>
<th>binary</th><td>$bin</td><td>$pbin</td></tr>
</tr>
</table>
EOM

}


sub ddQuota {

local ( $text, $bin ) = ( $WBB{'quotaText'}, $WBB{'quotaBin'} );
local ( $ptext, $pbin );

if ( $text == 0 ) {
$ptext = 0;
}
else {
$ptext = ( -s "$DATADIR/_cache/default.tbl" ) / ( 1024 * 1024 ) / $text;
}

if ( $bin == 0 ) {
$pbin = 0;
}
else {
local (@files);
local ( $size, $file );
$size  = 0;
@files = &glob("$HTMLDIR/att/*");
foreach $file (@files) {
$size += -s "$HTMLDIR/att/$file";
}
$pbin = $size / ( 1024 * 1024 ) / $bin;
}

return ( $ptext, $pbin );
}
1;
