


sub cgiBasketAddOne {

readBasket();
push( @BasketID, $CGI{'_id'} );
push( @BasketNO, $CGI{'num'} || 1 );
writeBasket();
readBasket();
printBasket();
}


sub printBasket {

$TargetDefault = 'target="woda_opener"';

local ($format) = $_[0] || 'DEFAULT';
local ($editable) = $_[1];

$editable = 1 if $editable ne '0';

$n = &readBasket() + 1;

if ( $n <= 0 ) {

wbError( "Nothing is in $WBB{'basketName'}", "Nothing selected" );    #UK

}
else {

( $html, $yh, $yf ) = &printSearchHttpHeader( $format, 1, 1 );

$modify = "Keep only checked items in the basket";                    #UK
$go     = "Reformat list as:";                                        #UK
$eable  = "in editable format";                                       #UK

printMiniHead("$n items in $WBB{'basketName'}") if $html;             #UK
$editable = 0 unless $html;

$formats = &formatFormats( $CGI{'format'} );

$ch = '';
$ch = 'CHECKED' if $editable;

print <<EOM if $editable;
<table><tr><td>
<form class="FORM" action="$SCRIPT/BasketShow" target="_self">
$go
<select name="format">
$formats
</select> $eable
<input name="editable" type="checkbox" $ch>
<input class="BUTTON" type="submit"  value="OK">
</form>
</td></tr>

<tr><td>
EOM

print <<EOM if $editable;
<form action="$SCRIPT/BasketEdit" target="_self">
EOM

wbSortFields();
$PrintingBasket = 1;

for ( $i = 0 ; $i <= $#BasketID ; $i++ ) {
$id = $BasketID[$i];
recRead($id);
if ( $editable && $FORMAT ne 'TABLE' ) {
$ThisRecordBasket = '<input type="checkbox" name="r' . $i . '" CHECKED>';
}
else {
$ThisRecordBasket = '';
}
$ThisRecordNo = $i;
$list[$i] = &formatFoundRec( $format, *PFields );    # Hidden ??
}

$head = &formatFoundHeader( $format, *PFields );         # Hidden ??
formatFoundSeparators( $format, 1 );

print '<div class="RECORDS">' . $t0 . $head if $html;
$i = 0;
foreach $_ (@list) {
print "$t1$_$t2";
$i++;
}
print $t3;
print '</div>' if $html;

$formats = &formatFormats();

print <<EOM if $editable;
<br>
<input class="BUTTON" type="submit"  value="$modify">
</form>
</td></tr>
</table>

EOM
$PrintingBasket = 0;
}


$ic = 'edit';
$tx = 'edit basket';                      #UK
$a  = "$SCRIPT/BasketShow?editable=on";

push( @Toolbar, <<EOM);
<a href="$a" target="_self"><img title="$tx" alt="$tx" $ICONPAR src="$ICONURL/$ic.gif"></a>
EOM


$ic = 'del';
$tx = 'delete from database all records that are in the basket';    #UK
$a  = "$SCRIPT/AdmManyDelForm?select=basket";

push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'AdmManyDelForm' );
<a href="$a" ><img title="$tx" alt="$tx" $ICONPAR src="$ICONURL/$ic.gif"></a>
EOM


$ic = 'editnf';
$tx = 'edit a field in these records';                              #UK
$a  = "$SCRIPT/AdmManySetForm?select=basket";

push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'AdmManySetForm' );
<a href="$a" ><img title="$tx" alt="$tx" $ICONPAR src="$ICONURL/$ic.gif"></a>
EOM


$ic = 'search';
$tx = 'search in basket';                                           #UK
$a  = "$SCRIPT/Search?search=%7B_basket%7D";

push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'Search' );
<a href="$a"><img title="$tx" alt="$tx" $ICONPAR src="$ICONURL/$ic.gif"></a>
EOM


$ic = 'serialmail';
$tx = 'serial mail to people in basket';                            #UK
$a  = "$SCRIPT/AdmMailForm?search=%7B_basket%7D";

push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'AdmMailForm' );
<a href="$a"><img title="$tx" alt="$tx" $ICONPAR src="$ICONURL/$ic.gif"></a>
EOM

}


sub formatFoundSeparators {

local ( $format, $n ) = @_;

if ( $format eq 'CSV' || $format eq 'CSVS' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'TAB' ) {
$t0 = "<XMP>\n";
$t1 = "";
$t2 = "\n";
$t3 = "</XMP>\n";
}
elsif ( $format eq 'RAW' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'XML' || $format eq 'XMLE' ) {
$t0 = "<!DOCTYPE records>\n<records>\n";
$t1 = "";
$t2 = "";
$t3 = "</records>\n";
}
elsif ( $format eq 'RSS' ) {
$x  = &htUntag("$WBB{'apTitle'} - $WBB{'dbTitle'}");
$x  = &htQuote($x);
$y  = &htQuote( $WBB{'about'} );
$t0 = <<EOM;
<rss version="0.91">
<channel>
<title>$x</title>
<link>$SCRIPTBASE$SCRIPT</link>
<description>$y</description>
<language>en-us</language>
EOM
$t1 = "";
$t2 = "";
$t3 = <<EOM;
</channel>
</rss>
EOM
}
elsif ( $format eq 'TABLE' ) {
$t0 = '<table class="DATATABLE" cellspacing="1">"\n"';
$t1 = "";
$t2 = "";
$t3 = "</table><br>\n";
}
elsif ( $format eq 'LONG' || $format eq 'NAMEVAL' ) {
$t0 = "";
$t1 = "";
$t2 = "<hr>\n";
$t3 = "";
}
elsif ( $format eq 'DEFAULT' || $format =~ m/^\d$/ ) {
$t0 = &evalMaybe( $WBB{"formatHead$format"} );
$t1 = '';
$t2 = '';
$t3 = &evalMaybe( $WBB{"formatFoot$format"} );
}
elsif ( $format eq 'PARAGRAPH' ) {
$t0 = '';
$t1 = '';
$t2 = '';
$t3 = '<br><br>';
}
}


sub formatFormats {

local ($selected) = @_;
local ( @vals, @texts, @v, @t );

$selected = 'DEFAULT' unless $selected;

@vals = ( "DEFAULT", "LONG", "PARAGRAPH", "TABLE", "CSV", "CSVS", "TAB", "XML", "XMLE", "RSS" );
@texts = (
"default short format",                 #UK
"default detailed format",              #UK
"paragraph of all selected fields",     #UK
"table format - one record per row",    #UK
"comma delimited format (.csv)",        #UK
"semicolon delimited format (.csv)",    #UK
"tab delimited format",                 #UK
"XML format",                           #UK
"easy to parse XML",                    #UK
"RSS 0.91",                             #UK
);

if ( $WBB{'detail'} ) {
push( @vals,  "NAMEVAL" );
push( @texts, "custom detailed format" );    #UK
}

@x = keys %WBB;
@x = grep ( /^formatName\d+/, @x );
foreach $_ (@x) {
$v = $WBB{$_};
$_ =~ m/^formatName/;
$text = $';
$formats .= qq(<option value="$text">$v\n);
unshift( @vals,  $text );
unshift( @texts, $v );
}


for ( $vi = 0 ; $vi <= $#vals ; $vi++ ) {
$v = $vals[$vi];
if ( &wbAllowed( $Group, 'Search', "format=$v" ) ) {
push( @v, $v );
push( @t, $texts[$vi] );
}
}

$formats = &wbFormatOptions( *v, *t, $selected );

return $formats;
}


sub wbFormatOptions {

local ( *v, *t, $default ) = @_;
local ( $nItems, $i );

$nItems = $#v;
$_      = '';
foreach ( $i = 0 ; $i <= $nItems ; $i++ ) {
if ( $default ne '' && $default eq $v[$i] ) {
$_ .= "<option value=\"$v[$i]\" SELECTED>$t[$i]\n";
}
else {
$_ .= "<option value=\"$v[$i]\">$t[$i]\n";
}
}

return $_;
}


sub formatFoundHeader {

local ( $format, *fields ) = @_;
local ( $f, $hd, $ft );

@fields = &visibleFields(@fields);

if ( $format eq 'TABLE' ) {
$hd = '<tr class="DATAH" ><th>&nbsp;</th>' . "\n";
}
else {
$hd = '';
}

foreach $f (@fields) {
if ( $format eq 'TABLE' ) {
$x = &formatFieldName($f);
$hd .= '<th align="left">' . $x . '</th>';
}
elsif ( $format eq 'TAB' ) {
$hd .= "$f\t";
}
elsif ( $format eq 'CSV' ) {
$hd .= "$f,";
}
elsif ( $format eq 'CSVS' ) {
$hd .= "$f;";
}
}

if (   $format eq 'TAB'
|| $format eq 'CSV'
|| $format eq 'CSVS' )
{
chop($hd);
}

if ( $format eq 'TABLE' ) {
$hd .= "</tr>";
}

$hd .= "\n" if $hd ne '';

return $hd;
}


sub printSearchHttpHeader {

local ( $format, $yh, $yf ) = @_;
local ( $html, $x );

if ( $format =~ m/^(\d+)$/ && $WBB{"formatHttpHead$1"} ne '' ) {
$x = $WBB{"formatHttpHead$1"};
$x =~ s/\n*$//g;    # remove trailing newlines
print "$x\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head or foot stuff for sure
}
elsif ( $format =~ m/^CSV/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^TAB$/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^RAW$/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^XML/ ) {
printXmlHead() if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^RSS/ ) {
print "Content-type: text/xml\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
else {
$html = 1;
}

return ( $html, $yh, $yf );

}


sub printXmlHead {
$e = $WBB{'intlCharset'} || 'UTF-8';
print $HTTP200OK;
print "Content-type: text/xml\n\n";
print <<EOM;
<?xml version="1.0" encoding="$e" standalone="yes" ?>
EOM
}


sub writeBasket {
local ( %printed, $file, $i, $ii );

$file = &basketFile();
if ( $#BasketID < 0 ) {
unlink($file);
return 0;
}
else {
open( h, ">$file" );
binmode(h);
for ( $i = 0 ; $i <= $#BasketID ; $i++ ) {
$ii = $BasketID[$i];
next unless &recExists($ii) >= 0;
if ( !$printed{$ii} ) {    # remove duplicates
print h $ii . "\t" . $BasketNO[$i] . "\n" if $BasketNO[$i] > 0;
$printed{$ii} = 1;
}
}
close(h);
}
return $i + 1;
}
1;
