

sub cgiBrowseContents {

wbBrowseDefaults();

$icon = '<img src="' . $ICONURL . '/search.gif" ' . $ICONPAR . ' alt="search" title="search">';
$join = "<br />";

if ( $#fields == 0 ) {
$f = &formatFieldName( $fields[0] );
printHead("Browse by $f");    #UK
}
else {
$f = join( ',', @fields );
printHead("Browse by fields $f");    #UK
}

if ( $CGI{'comma'} ) {
$join = ', ';
$icon = '';
}

print <<EOM;                             #UK
<p>Follow the links to find items tagged with the keyword</p>
EOM

@items   = '';
$dItem   = 0;
$dSearch = 0;

foreach $field (@fields) {

if ( $WBF{ $field, typePar } =~ m/HEADING=(.{1,5})/i ) {    # check if the field contains HEADING
$heading = $1;
}
else {
$heading = '';
}

$dSearch = 0;                                               # reset position of label in @optionText;

$head   = &formatFieldName($field);
@kwords = &wbParseOptions($field);
$print  = "<b>$head</b><br>\n" if $#fields > 0;

@list = ();
foreach $kword (@kwords) {

if ( $heading && $kword =~ m/^$heading/ ) {             # if it is a heading value print it
push( @list, "<i>$kword</i>" );
$dSearch++;                                         # skip HEADING for labels
next;
}

$x = &wbOptionWordSearch( $field, $kword );
$s = $optionText[$dSearch] || $kword;                   # makes human readable display
push( @list, "<a href=\"$SCRIPT/Search?search=$x\">$icon $s</a>" );
$dSearch++;
}

$print .= join( $join, @list );
$items[ $dItem++ ] = $print;
}

print "<table>";

for ( $i = 0 ; $i <= $#items ; $i += $inarow ) {
print '<tr valign="top">', "\n";
for ( $j = 0 ; $j < $inarow ; $j++ ) {
$idx = $i + $j;
print <<EOM;
<td>
$items[$idx]
</td>
EOM
}
print "</tr>\n";
}

print "</table>";
}


sub wbBrowseDefaults {

wbSortFields();

$inarow = $CGI{'inarow'} || 3;
@fields = split( /,/, $CGI{'fields'} );

if ( $#fields < 0 ) {
foreach $field (@Fields) {
$t = $WBF{ $field, 'type' };
if ( $WBF{ $field, 'type' } =~ m/^OPTION$/ ) {
push( @fields, $field );
}
}
}
}


sub wbOptionWordSearch {

local ( $field, $word ) = @_;

$word =~ s|[/()]|\\$&|g;    # escape ( ) and / in search words
return &htEscape("+$field:\"$word\"");
}
1;
