

sub cgiBrowseMatrixList {

printHead("Select Browse Matrix Combination");    #UK
print "<p>\n";
print <<EOM;                                      #UK
This page lets you define a browse matrix. Select 
combination of two fields. Values of the first will be used for rows and
values of the second for columns. Note that matrices which would include
fields marked with a * may take longer to generate.

EOM

print <<EOM;                                      #UK
<p>You can also define the browse matrix using <a href="$SCRIPT/BrowseMatrixForm">a form</a>.
EOM

wbSortFields();
foreach $field (@Fields) {
if ( $WBF{ $field, 'type' } =~ m/OPTION$/ ) {
push( @fields, $field );
$nice = &formatFieldName( $field, 1 );
$nice .= " *" if $WBF{ $field, 'type' } eq 'LINKOPTION';


push( @niceFields, $nice );
}
}

$opts = '';
for ( $i = 0 ; $i <= $#fields ; $i++ ) {
$rn = $fields[$i];
$ru = &htEscape($rn);
$rv = $niceFields[$i];
print "<p><b>$rv</b><br>\n";
for ( $j = 0 ; $j <= $#fields ; $j++ ) {
next if $i == $j;
$cn = $fields[$j];
$cu = &htEscape($cn);
$cv = $niceFields[$j];
print <<EOM;    #UK
<a href="$SCRIPT/BrowseMatrix?row=$ru&amp;col=$cu">
$rv : $cv</a> 
(<a href="$SCRIPT/BrowseMatrix?row=$ru&amp;col=$cu&amp;count=on">count</a>)
<br>
EOM
}
}
}
1;
