

sub cgiChanged {

prepareHtmlArea();


$x = &wbCookieCGI();


if ( $WBB{'verifyEdits'} ) {
printHead( "Confirm Edits", $x );    #UK
}
else {
printHead( "Data Submitted", $x );    #UK
}

if ( $CGI{'_password'} ne $CGI{'_password1'} ) {
print '<p class="ERROR">';
print "The two passwords do not match!";    #UK
return;
}

$oldID = $CGI{'_id'};


if ($oldID) {
recRead($oldID);
if ( %rec
&& !&wbTestPass( $CGI{'_accessPassword'}, $rec{'_password'} ) )
{
if ( &isOwner() ) {

}
else {
wbBadPass($oldID);
return;
}
}

if ( $CGI{'_at'} && $rec{'_at'} ne $CGI{'_at'} ) {
wbError(
"Data in form expired",
"The data changed while you were editing it. Your changes are lost! Perhaps another user was editing the same record at the same time. Or you got to an old Edit screen by using browser's back and forward buttons.",
'',
-2
);    # UK
return;
}


if ($ADMINPASS) {
print '<p class="WARN">';
print "Bad password entered by administrator.<br>Existing password will be preserved.</p>\n";    #UK
$oldRec{'_password'} = $rec{'_password'};
}


foreach $x ( keys(%rec) ) {
$oldRec{$x} = $rec{$x} unless defined $CGI{$x};                                                  # was not on form

next if $WBF{ $x, 'modifies' } eq '';                                                            # everyone modifies
next if $Group =~ m/admin|$WBF{$x,'modifies'}/;                                                  # I modify
$oldRec{$x} = $rec{$x};                                                                          # I don't modify
}
}


wbCheckDir($TMPDIR);
$tmpID = &tmpID();


wbCgiToRec($tmpID);


changeRec();


$rec{'_password'} = &wbFixPass( $CGI{'_lock'}, $CGI{'_password'} );


foreach $x ( keys(%oldRec) ) {
$rec{$x} = $oldRec{$x};
}


recWriteFile("$TMPDIR/$tmpID.rec");


$newID = &evalWBBkey();


if ( $newID eq '' ) {

$newID = $oldID;    # existing? random key reused

}
elsif ( $newID eq $oldID ) {


}
elsif ( &recExists($newID) >= 0 ) {

wbError( "Record exists", "Record with the same key data ($newID/$oldID) exists <a href=\"$SCRIPT/Show?_id=$newID\">here</a>." );    #UK
return;

}
elsif ( $oldID eq '' ) {


}
else {

$WBB{'verifyEdits'} = 1;

$b = "Go back";    #UK
$b = <<EOM;
<form>
<input class="BUTTON" type=BUTTON value="$b" onClick="history.go(-1);">
</form>
EOM

$t = <<EOM;        #UK
You changed key data in this record.
<p>
If you ignore this warning,
a new record will be added to the database.
<p>
The new record will include any attachments of this record.
<p>
Relations to/from the record will all be broken.
<p>
The old record would have to be deleted!
EOM
wbWarn( "Warning, key changed", "$t$b" );    #UK

}

$err        = &recValidate();
$rec{'_at'} = time;
$html       = &wbRecHtml();
undef $rec{'_at'};

if ( $WBB{'verifyEdits'} ) {
print <<EOM ;                                #UK
<p>Nothing has been saved (yet). Please review what you entered
and confirm at the bottom of this page.
EOM
}
else {
print <<EOM unless $err;                     #UK
<p>This is what you entered:
EOM
}

print <<EOM unless $err;                         #UK
<p>
$html
<p>Please note that the attachments 
and perhaps the related data may not be properly
displayed at this point!
EOM

if ($err) {
$x = "<img src=\"$ICONURL/del.gif\" title=Error alt=Error $ICONPAR>";
$err =~ s/\n/<br>/g;

if ( $Group eq 'admin' ) {
print <<EOM;    #UK
<p>$html</p>
<p class="WARN">$err<br>... but as admin you are allowed to make errors!</p>
EOM
}
else {
print <<EOM;    #UK
<h3 class="ERROR">Errors were discovered !</h3>

<p>Please correct the fields with errors below.
They are marked with $x and <font class="ERROR">painted like this</font>.</p>
EOM
correct();
return;
}

}
else {
print "<p>There are no errors in your input, but please <b>manually</b> check <b>all links</b>!\n";    #UK
}

$x = "Save changes";                                                                                       #UK
$b = "Go back";                                                                                            #UK
$t = "Nothing is saved yet. Please select:";                                                               #UK

if ( $WBB{'verifyEdits'} ) {


print <<EOM;
<p>
<form name="main" action="$SCRIPT/Store">
<center>
$t<br><br>
<input name="tmpID" value="$tmpID" type="hidden">
<input name="newID" value="$newID" type="hidden">
<input class="BUTTON" type="submit" method="post" value="$x">
<input class="BUTTON" type=BUTTON value="$b" onClick="history.go(-1);">
</center>
</form>
<p>
EOM

}
else {

undef %CGI;
$CGI{'tmpID'} = $tmpID;
$CGI{'newID'} = $newID;
cgiStore();

}
}


sub changeRec {

wbSortFields();

foreach $field (@IFields) {
if ( $WBF{ $field, 'change' } ne '' ) {
$_ = $rec{$field};
$rec{$field} = &evalSafe( $WBF{ $field, 'change' } );
}
}

}


sub wbFixPass {

local ( $lock, $pass ) = @_;

if ( $lock eq 'user' ) {
return "u:$User";

}
elsif ( $lock eq 'group' ) {
return "g:$Group";

}
elsif ( $lock eq 'none' ) {
return "";

}
elsif ( $lock eq 'host' ) {
return "h:$RA";

}
elsif ( $pass ne '' ) {
return &wbCryptPasswd($pass);

}
else {
return '';

}
}


sub evalWBBkey {

local ( $x, $y );

$x = $WBB{'key'};
return '' if $x =~ m/\&NEXT/;

$y = &evalSafe($x);    # setting
return &wbFixId($y);

}


sub wbCgiToRec {

local ($tmpID) = @_;

undef %rec;

foreach $field ( keys(%WBF) ) {


if ( $CGI{"$field-old"} && !$CGI{$field} ) {
$rec{$field} = $CGI{"$field-old"};
}


next if $CGI{$field} =~ m/^\s*$/;


if ( $WBF{ $field, 'type' } eq 'DATE' ) {
$y           = $field . "_year";
$m           = $field . "_month";
$rec{$field} = "$CGI{$y}/$CGI{$m}/$CGI{$field}";

}
elsif ($WBF{ $field, 'type' } eq 'USERFILE'
|| $WBF{ $field, 'type' } eq 'IMAGE' )
{
$rec{$field} = &wbUserFileSave( $field, $tmpID );

}
else {

$rec{$field} = $CGI{$field};
}
}
}


sub wbUserFileSave {

local ( $field, $tmpID ) = @_;
local ( $fileName, $ext, $destDir );

$destDir = &wbCheckDir("$DATADIR/_tmp");


$ext = $EXT{$field};
$ext = '.' . $ext if $ext;

$fileName = "$tmpID.$field$ext";

open( h, ">$destDir/$fileName" ) || wbFail("Cannot open $fileName\n");
binmode(h);
print h $CGI{$field};
close h;

if ( -e "$destDir/$fileName" ) {
return $fileName;
}
else {
return "";
}
}


sub correct {

$x     = &wbForm();
$reset = "Undo edits";    #UK

if ( $WBB{'verifyEdits'} ) {
$submit = "Continue to Preview ...";    #UK
}
else {
$submit = "Save into the database";     #UK
}

$enctype = "";
$enctype = 'ENCTYPE="multipart/form-data"' if $HasAttachmentField;

print <<EOM;
<form class="FORM" name="main" $enctype action="$SCRIPT/Changed" method="post">
$x
<p>
<input type="hidden" name="_id" value="$CGI{'_id'}">
<input type="hidden" name="_accessPassword" value="$CGI{'_accessPassword'}">
<input class="BUTTON" type="submit" value="$submit">
<input class="BUTTON" type="reset" value="$reset">
</form>
EOM
}


sub wbForm {

my ( $out, $l );

if ( $COOKIE{_conf} =~ m/:NOHELP/ ) {
$Help = '';
}
else {
$Help = 1;
}

$out = &formatFormJavaScript();

$help    = "Help";              #UK
$helpOff = "Show less help";    #UK
$helpOn  = "Show more help";    #UK
$helpAll = "Display manual";    #UK

$out .= <<EOM;
<table cellspacing="0" width="100%">
<tr valign="top"><th align="right">&nbsp;</th>
EOM
$referer = $Referer;
if ($Help) {
$out .= <<EOM;
<td><a class="BUTTON" href="$SCRIPT/SetHelp?help=off&$referer" target="_self">$helpOff</a>
EOM
}
else {
$out .= <<EOM;
<td><a class="BUTTON" href="$SCRIPT/SetHelp?help=on&$referer" target="_self">$helpOn</a>
EOM
}

if ( &wbAllowed( $Group, 'DisplayStructure' ) ) {
$out .= <<EOM;
<a class="BUTTON" href="$SCRIPT/DisplayStructure" target="woda_help">$helpAll</a></td></tr>
EOM
}
wbSortFields();
foreach $field (@Fields) {
wbFormFieldItems($field);
}

if ( $WBB{'form'} ne '' ) {
$out .= "<!-- using WBB{'form'} -->\n";
$out .= "<tr><td COLSPAN=2>\n";
$out .= &evalSafe( $WBB{'form'} );
$out .= "</td></tr>\n";
}
else {

$out .= "<!-- not using WBB{'form'} -->\n";

foreach $field (@Fields) {


next
if ( $Form{ $field, 'name' } eq ''
&& $Form{ $field, 'input' } eq '' );

if ( $Form{ $field, 'input' } eq '' ) {    # to izpisuje 'BREAK'
$t = $Form{ $field, 'name' };
$t =~ s/^"//;
$t =~ s/"$//;

$out .= <<EOM;
<tr valign="top">
<td COLSPAN=2>
<b>$t</b>
</td>
</tr>
EOM
}
else {

$Form{ $field, 'prompt' } .= '<br>'
if $Form{ $field, 'prompt' };
$Form{ $field, 'input' } .= '<br>' if $Form{ $field, 'help' };
$out .= <<EOM;
<!-- ----------------------------- -->
<tr valign="top">
<th align="right">
$Form{$field,'name'}
$Form{$field,'err'}
</th>
<td align="left">
$Form{$field,'prompt'}
$Form{$field,'input'}
$Form{$field,'help'}
</td>
</tr>

EOM
}
}
}

$WBB{'recordLock'} = 'password|user' if $WBB{'recordLock'} eq '';

@locks = split( /\|/, "$WBB{'recordLock'}|" );
@locks = grep( /./, @locks );

if ( $#locks == -1 || $#locks == 0 && $locks[0] eq 'none' ) {


}
else {

$x{password} = "with this password:";                #UK
$x{user}     = "to user $User";                      #UK
$x{group}    = "to group $Group";                    #UK
$x{host}     = "to host $RA";                        #UK
$x{none}     = "don't lock - anyone can edit it";    #UK

$y{user}  = "u:";
$y{group} = "g:";
$y{host}  = "h:";

if ( $WBB{recordLock} eq 'user' ) {                  # only one choice!

$out .= qq(<input type="HIDDEN" name=_lock value="user">\n);

}
elsif ( $WBB{recordLock} eq 'group' ) {              # only one choice!

$out .= qq(<input  type="HIDDEN" name=_lock value="group">\n);

}
else {
$x = 'locking:';                                 #UK
$out .= <<EOM;
<tr valign="top">
<th align="right">$x</th><td>
EOM

$out .= <<EOM;                                   #UK
How would you like to lock this record?<br>
EOM

$out .= '<select name="_lock">' . "\n";
$na = 0;
foreach $lock (@locks) {

if ( $lock eq 'user' || $lock eq 'group' ) {
if ( $Group eq 'guest' ) {
$x = 'no locking - you must log in to lock this record';
$out .= qq(<option value="none" SELECTED>$x\n);
last;
}
}
$x = $x{$lock};

$d = '';
$d = 'SELECTED'
if $y{$lock} && $rec{'_password'} =~ m/^$y{$lock}/;
$d = 'SELECTED'
if $lock eq 'password' && defined $CGI{'_accessPassword'};

$na++;
$out .= qq(<option value="$lock" $d>$x\n) if $x;

}

$out .= "</select>\n";

if ( $na eq 0 ) {
wbWarn( "Warning:", "Locking of this record will not be possible for an anonymous user. Please log in." );    #UK
}

if ( grep( /password/, @locks ) ) {

if ( &isLoginTable() && &isOwner() ) {

$CGI{'_accessPassword'} = $LogPass;
}

$CGI{_accessPassword} = $CGI{_password} if ( !$CGI{_accessPassword} );

$x = 'again';    #UK
$out .= <<EOM;
<input type="password" name="_password" size="10" value="$CGI{'_accessPassword'}">
$x
<input type="password" name="_password1" size="10" value="$CGI{'_accessPassword'}">
EOM
$out .= <<EOM;    #UK
<br><span class="HINT">Same password should be entered twice to avoid errors.</span>
EOM

if ( &isLoginTable() ) {
$out .= <<EOM;    #UK
<br><span class="WARN"><b>
This password will also be used
for logging in into this application.
</b></span>
EOM
}
}
$out .= "</td></tr>\n";
}

}

$out .= "</table>\n";

return $out;
}


sub isLoginTable {

local ($ut);

if ( $WBB{'userTable'} eq '' ) {

return 0;

}
else {

return &wbTables( 'URL', $WBB{'userTable'} ) eq &wbTables( 'URL', '' );

}
}


sub formatFormJavaScript {

local ($fname) = @_;    # name of the form

return '' unless $JS;

$fname = $fname || 'main';

return <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

// check all or none of the checkboxes
function allBoxes(name,n) {
for (var i=0; i<document.forms['$fname'].elements[name].length; i++) document.forms['$fname'].elements[name][i].checked=n;
}

// validate form element if it is a regular expression
function validText(name,expression,message) {

myRe = expression;
if (myRe.test(name.value)) {
return
} else {
alert(message)
}
}	


// --></script>
EOM
}


sub cgiStore {

$tmpID = $CGI{'tmpID'};

recReadFile("$TMPDIR/$tmpID.rec");

if ( !%rec ) {
wbError( "Data missing", "The submitted data in $TMPDIR/$tmpID.rec could not be read" );    #UK
return;
}


$newID = $CGI{'newID'} || &evalWBBkey();
if ( !$newID ) {
$newID = &recRandID();
}


recMoveAttached( $tmpID, $newID );
recSetSystem();
$rec{'_id'} = $newID;
$Log .= "Write $newID\n";
recWrite();
$Log .= "Read $newID\n";
recRead($newID);

if ( !%rec ) {
wbError("ERROR: Database Update Failed");    #UK
return;
}

unlink("$TMPDIR/$tmpID.rec");
wbTmpClean();

$t = "Database Updated";                         #UK
if ($HtmlHeadPrinted) {

}
else {
printHead($t);
}

wbRecordChanged();
wbDatabaseChanged();

$url = "$SCRIPTBASE$SCRIPT/Show?_id=$newID";

$x = <<EOM ;    #UK
<p>Thank you for contributing to $WBB{'dbTitle'}. Your edits were saved at URL <p>
<center><p><a class="BUTTON" href="$url">$url</a>.</p></center>
<p>
This information may be useful to locate the record for editing or updating.
You may wish to <tt>[bookmark]</tt> it.
<p>
To add a record, click on the add icon in the toolbar.
EOM

$y = "Success!";    #UK
print &formatWindow( $y, $x );

$t = "Add another record";    #UK
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Add">
<img $ICONPAR src="$ICONURL/add.gif" alt="$t" title="$t"></a>
EOM

if ( &isLoginTable() ) {
$t = 'WARNING: Login information changed!';    #UK
$m = <<EOM;                                    #UK
<p>Please note that <b>$newID</b> is a username to
<a href="$SCRIPT/LoginForm?username=$newID">log into</a> this
application.
<p>The password to log in is the password that was used
to lock this record.
EOM
if ( $WBB{'userAllow'} ) {
$m .= <<EOM;                               #UK
<p>There are some special conditions set,
so that you might not be able to log-in
right away.
EOM
}

wbWarn( $t, $m, 'width="400"' );
}

if ( $WBB{'cacheExpire'} > 0 ) {

$file = "_cache/default.tbl";
$file =~ tr/[A-Z]/[a-z]/;
open( h, "$file.time" );
$secs = <h>;
close(h);
$secs += 2;

$t = "WARNING: Data not indexed";    #UK
$m = <<EOM;                          #UK
<p>Although your data has been entered, due to the setup of this database,
it may take up to <b>$WBB{'cacheExpire'} hours</b> before it can be found
by searches.
<p>If you want your edits to be visible
immediately, <a href="$SCRIPT/Add">add</a> or edit any other data you may have,
then click below and <b>be patient</b>. The processing may take about <b>$secs seconds</b>.
<form action="$SCRIPT/Reindex" method="post">
<input name="sort" type="hidden" value="default">
<input name="secs" type="hidden" value="$secs">
<input class="BUTTON" type="submit" value="OK, I'll wait">
</form>
EOM
print &formatWindow( $t, $m );
}

print "<p>\n";
}


sub wbRecordChanged {

if ( $WBB{'afterRecordModify'} ne '' ) {
&evalSafe( $WBB{'afterRecordModify'} );
}
}


sub wbTmpClean {

wbDirClean( $TMPDIR, 30, <<EOM);
This directory contains temporary files.
Files older than 30 days are deleted anyway.
EOM

}


sub recRandID {

local ( $id, $x );

$x = $WBB{'key'};
if ( $x =~ m/\&NEXT/ || $x =~ m/NEXT\(/ ) {
return &evalSafe($x);
}
else {
while (1) {
$id = &wbRandKey();
last unless &recExists($id) >= 0;
}
return $id;
}
}


sub wbRandKey {

local ($n) = $_[0];
local (@a) = ( 0 .. 9, 'a' .. 'f' );
local ( $x, $n, $c, $o, $base, @c, $i );
$base = $#a + 1;

$n = $n || 4;
$x = $base**$n;
$x = int( rand($x) );

for ( $i = 1 ; $i <= $n ; $i++ ) {
$o     = $x % $base;
$c[$i] = $a[$o];
$x     = int( $x / $base );
}

return ( join( '', @c ) );
}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub recMoveAttached {

local ( $tmpID, $newID ) = @_;
local ( $destDir, $srcDir, $srcFile, $destFile, $d, @toDelete );

$destDir = &wbCheckDir("$HTMLDIR/att");
$srcDir  = "$DATADIR/_tmp";

wbSortFields();
foreach $field (@Fields) {
next
unless ( $WBF{ $field, 'type' } eq "USERFILE"
|| $WBF{ $field, 'type' } eq "IMAGE" );
$srcFile = $rec{$field};

if ( $srcFile eq '' ) {


@toDelete = &glob("$destDir/$newID.$field.*");
foreach $d (@toDelete) {
unlink "$destDir/$d";
}

}
elsif ( -e "$srcDir/$srcFile" ) {


$srcFile =~ m/([^\.]*)$/;    # extract .extension
$ext = $1;
$x   = rand();
$x =~ s/\D//g;
$x = substr( $x, 0, 5 );
$destFile = "$newID.$field.$x.$ext";


@toDelete = &glob("$destDir/$newID.$field.*");
foreach $d (@toDelete) {
unlink "$destDir/$d";
}


wbMoveFile( "$srcDir/$srcFile", "$destDir/$destFile" );
$rec{$field} = $destFile;

}
elsif ( $srcFile !~ m/^$newID\./ ) {


$srcFile =~ m/\.$field\./;
$destFile = "$newID.$field.$'";
wbMoveFile( "$destDir/$srcFile", "$destDir/$destFile" );
$rec{$field} = $destFile;

}

}    # each field

}



sub recSetSystem {


local ($from);
$from         = $RH;
$from         = $RA if !$from;
$rec{'_from'} = $from;


$rec{'_at'} = time;

}


sub recWriteFile {

local ($file) = @_;

open( h, ">$file" ) || return 0;
binmode(h);
print h &recToVector();
close(h);
return 1;
}


sub wbCookieCGI {

local ( $out, $v, $stick );

$out = '';

foreach $x ( keys(%CGI) ) {
next if ( $stick = $WBF{ $x, 'sticky' } ) eq '';

if ( $stick =~ m|/| ) {
$stick = "path=$stick;";
}
else {
$stick = '';
}
$v = &htEscape( $CGI{$x} );
next if $v eq '';    # make sure all cookies have values


$out .= "Set-Cookie: $x=$v; $stick expires=expires=Wed, 1-Jan-2020 23:59:59 GMT\n";
}

return $out;
}


sub prepareHtmlArea {

if ( $ENV{'HTTP_USER_AGENT'} =~ m/msie [6789]|msie 5.5|gecko/i ) {
$HtmlAreaWorks = 1;
$MetaFields    = <<EOM;    #UK
<!-- are .js files installed there ? -->
<script type="text/javascript" src="$WODAURL/htmlarea/htmlarea.js"></script>
<script type="text/javascript" src="$WODAURL/htmlarea/lang/en.js"></script>
<script type="text/javascript" src="$WODAURL/htmlarea/dialog.js"></script>
<script type="text/javascript" src="$WODAURL/htmlarea/popupwin.js"></script>
<style type="text/css">
\@import url($ICONURL/../htmlarea/htmlarea.css);
</style>
EOM

}
else {
$HtmlAreaWorks = 0;
}
}


sub tmpID {

local ($id);
while (1) {
$id = &wbRandKey();
last unless -e "$TMPDIR/$id.rec";
}
return $id;
}

sub recValidate {

local ($err);

$err = "";

foreach $field ( keys(%WBF) ) {
next if $field =~ m/$;/;
next if $field =~ m/^_/;
$vex = $WBF{$field};
$_ = $value = $rec{$field};
$_ =~ s/\r//g;    # remove CR

next if $WBF{ $field, 'type' } eq 'BREAK';
next if $WBF{ $field, 'type' } eq 'SUBMIT';

if (   $_
&& $WBF{ $field, 'type' } eq "FILE"
&& !-f "$HTMLDIR/att/$value" )
{
$err .= "WARNING: file $HTMLDIR/att/$value does not exist\n";    #UK
$err{$field} = 1;
next;
}

if (   $vex eq '1;'
&& $WBF{ $field, 'type' } eq 'EMAIL'
&& $value ne ''
&& !&isEmail($value) )
{
$err .= "WARNING: bad email address at $field\n";                #UK
$err{$field} = 1;
next;
}

if ( $vex eq '1;' && $WBF{ $field, 'type' } eq 'DATE' && $value ) {
local ( $y, $m, $d ) = split( /\//, $value );
if ( $y !~ /^\d\d\d\d$/ || $m > 12 || $m < 1 || $d < 1 || $d > 31 ) {
$err .= "WARNING: bad date at $field\n";                     #UK
$err{$field} = 1;
}
next;
}

if ( $WBF{ $field, 'type' } eq 'LIST' ) {
@x = split( /\n/, $_ );
}
else {
@x = ($_);
}

foreach $_ (@x) {

$y = 1;

$* = 1;                  # multiline matching
$y = &evalSafe($vex);    # calculate
$* = 0;                  # single line matching

if ($y) {
if ( $y =~ m/CLASS\=ERROR/i ) {
wbFail( "Error validation expression", "$y in $vex" );    #UK
}
}
else {
$m = $WBF{ $field, 'cond' };
$m = $WBF{$field} if !$m;
$err .= "WARNING: bad value for <b>$field</b>:\n\t'$value' does not satisfy '<b>$m</b>'\n";    #UK
$err{$field} = 1;
}
}

}

if ( defined(&myRecVerify) ) {
$err .= &myRecVerify();
}

$Log .= $err;

return $err;
}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub wbBadPass {

local ($id) = @_;

$id = &htEscape($id);

local ( $t, $x );
$t = "Bad password";    #UK

$x = <<EOM;             #UK
Password does not match the password saved with the information.
You are not allowed to conclude this operation.
EOM

$x .= <<EOM;            #UK
<p>
If an email address is stored with that information
it may be possible to
<a href="$SCRIPT/PassR1?_id=$id">
restore the password</a>.
EOM

wbError( $t, $x );

}
1;
