

sub cgiDeleteIt {

printHead("Delete results");    #UK

$id = $CGI{'_id'};
if ( $id eq '' ) {
wbError( "Error: Blank ID", "Records with blank ID cannot be deleted.<br>ID may be blank, because the {key} setting is corrupt." );
}

recRead($id);
if ( $rec{'_id'} eq '' ) {
wbError( "Error: Record does not exist", "Record $id does not exist.<br>Perhaps it has already been deleted." );
}

if ( !&wbTestPass( $CGI{'_accessPassword'}, $rec{'_password'} ) ) {
wbBadPass($id);
return;
}


$err = &recDelete($id);
if ($err) {
print '<h3 class="ERROR">Delete failed</h3>';    #UK
print "$err\n";
return;
}
else {
print "<h3>Record deleted</h3>";                 #UK
wbDatabaseChanged();
}
}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub wbBadPass {

local ($id) = @_;

$id = &htEscape($id);

local ( $t, $x );
$t = "Bad password";    #UK

$x = <<EOM;             #UK
Password does not match the password saved with the information.
You are not allowed to conclude this operation.
EOM

$x .= <<EOM;            #UK
<p>
If an email address is stored with that information
it may be possible to
<a href="$SCRIPT/PassR1?_id=$id">
restore the password</a>.
EOM

wbError( $t, $x );

}


sub recDelete {

local ( $id, $keepAttach ) = @_;

if ( $id eq '' || $id =~ m/^[\*\?\.]/ || $id =~ m/\t|\n/ ) {
wbFail( 'Bad id', "Cannot delete record with id='$id'" );
}

wbCheckIdPos( $id, '-1' );

open( h, ">>$DATADIR/_data/fat.txt" );
flock( h, 2 );
binmode(h);
print h "$id\t-1\n";
close(h);

if ($keepAttach) {

}
else {
chdir("$HTMLDIR/att") || wbFail("Cannot chdir to $dir");
local ( @all, $x );
@all = &glob("$id.*");
foreach $x (@all) {
unlink "$x" || wbFail("Could not delete $x");
}
}
}
1;
