

sub cgiFormSave {

printHead("Saving form data");    #UK

$eFormdata = &htQuote( $CGI{'formdata'} );

hashImport( *x, $CGI{'formdata'} );

$x{_formname} = $CGI{'_formname'};

if ( $x{_formname} eq '' ) {

%y = %x;
foreach $key ( keys(%y) ) {
delete $y{$key} if $y{$key} eq '';
}

$h = &formatHash( "Parameters to be saved are:", 1, %y );    #UK

$a = "Define name";                                          #UK
$p = "Save";                                                 #UK
$b = <<EOM;                                                  #UK
<form action="$SCRIPT/FormSave">
Before a form can be saved, it must be named:<br>
<input name="_formname" size="30">
<input type="hidden" name="formdata" value="$eFormdata">
&nbsp;
<input class="BUTTON" type="submit"  value="Save">
</form>
$h
EOM
print &formatWindow( $a, $b );
return;
}
else {
$formdata = &hashExport(*x);


saveFormAppend($formdata);
$dform = $x{_form};

saveFormSavedMessage($dform);
}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}
1;
