

sub cgiFriendsOnline {

if ( $Group eq 'guest' ) {
wbError( "Not registered", "We do not provide this information to unregistered users" );    #UK
return;
}

printHead("Recent users");                                                                      #UK
$now     = time;
$minutes = $CGI{'minutes'} || 2;
$secs    = $minutes * 60;
$lf      = &logFile();
open( h, $lf );
while (<h>) {
@x = split( /\t/, $_ );
next if $now - $x[2] > $secs;
$users{ $x[4] }++;
}
close(h);

if ( &wbAllowed( $Group, 'AdmLogfilePrint' ) ) {
$log = 1;
}
else {
$log = 0;
}

$seconds = $minutes * 60;

foreach $user ( keys(%users) ) {
$u =~ s/^_//;
( $email{$user}, $x ) = &getRegisteredData($u) || 'email unknown';    #UK
if ($log) {
$email{$user} .= <<EOM;                                           #UK
<a href="$SCRIPT/AdmLogfilePrint?last=$seconds&amp;format=short&amp;search=$user">logfile</a>
EOM
}
}

$mform = <<EOM;                                                           #UK
<form action="$SCRIPT/FriendsOnline">
<br>Users in the last <input size="4" name="minutes" value="$minutes"> minutes.
<input class="BUTTON" type="submit" value="Refresh">
</form>
EOM
print &formatHash( $mform, 0, %email );
}


sub getRegisteredData {

local ($k) = @_;

open( h, "$DATADIR/_cache/register.txt" );
while (<h>) {
if (m/^$k\t/) {
( $key, $email, $name ) = split( /\t/, $_, 3 );
chop($name);
return $email;
}
}
return '';
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}
1;
