

sub cgiOfficeWSDL {

$string = <<EOM;
<?xml version="1.0" encoding="utf-8"?>
<definitions xmlns:http="http://schemas.xmlsoap.org/wsdl/http/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:s="http://www.w3.org/2001/XMLSchema" xmlns:s0="urn:Microsoft.Search" xmlns:soapenc="http://schemas.xmlsoap.org/soap/encoding/" xmlns:tm="http://microsoft.com/wsdl/mime/textMatching/" xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/" targetNamespace="urn:Microsoft.Search" xmlns="http://schemas.xmlsoap.org/wsdl/">
<types>
<s:schema elementFormDefault="qualified" targetNamespace="urn:Microsoft.Search">
<s:element name="Registration">
<s:complexType>
<s:sequence>
<s:element minOccurs="0" maxOccurs="1" name="registrationXml" type="s:string" />
</s:sequence>
</s:complexType>
</s:element>
<s:element name="RegistrationResponse">
<s:complexType>
<s:sequence>
<s:element minOccurs="0" maxOccurs="1" name="RegistrationResult" type="s:string" />
</s:sequence>
</s:complexType>
</s:element>
<s:element name="Query">
<s:complexType>
<s:sequence>
<s:element minOccurs="0" maxOccurs="1" name="queryXml" type="s:string" />
</s:sequence>
</s:complexType>
</s:element>
<s:element name="QueryResponse">
<s:complexType>
<s:sequence>
<s:element minOccurs="0" maxOccurs="1" name="QueryResult" type="s:string" />
</s:sequence>
</s:complexType>
</s:element>
</s:schema>
</types>
<message name="RegistrationSoapIn">
<part name="parameters" element="s0:Registration" />
</message>
<message name="RegistrationSoapOut">
<part name="parameters" element="s0:RegistrationResponse" />
</message>
<message name="QuerySoapIn">
<part name="parameters" element="s0:Query" />
</message>
<message name="QuerySoapOut">
<part name="parameters" element="s0:QueryResponse" />
</message>
<portType name="ResearchSoap">
<operation name="Registration">
<documentation>Registration for the Woda Search Service.</documentation>
<input message="s0:RegistrationSoapIn" />
<output message="s0:RegistrationSoapOut" />
</operation>
<operation name="Query">
<documentation>Runs a search in Woda.</documentation>
<input message="s0:QuerySoapIn" />
<output message="s0:QuerySoapOut" />
</operation>
</portType>
<binding name="ResearchSoap" type="s0:ResearchSoap">
<soap:binding transport="http://schemas.xmlsoap.org/soap/http" style="document" />
<operation name="Registration">
<soap:operation soapAction="urn:Microsoft.Search/Registration" style="document" />
<input>
<soap:body use="literal" />
</input>
<output>
<soap:body use="literal" />
</output>
</operation>
<operation name="Query">
<soap:operation soapAction="urn:Microsoft.Search/Query" style="document" />
<input>
<soap:body use="literal" />
</input>
<output>
<soap:body use="literal" />
</output>
</operation>
</binding>
<service name="Research">
<documentation>Woda Research Web Service</documentation>
<port name="ResearchSoap" binding="s0:ResearchSoap">
<soap:address location="$SCRIPTBASE$SCRIPT/Office" />
</port>
</service>
</definitions>
EOM

$len = length($string);
binmode(STDOUT);
print "Content-type: text/xml; charset=utf-8\nContent-Length: $len\n\n$string";

}
1;
