

sub cgiPassR1 {

$did = $CGI{'_id'};

printHead("Reseting password for $did");    #UK
recRead($did);

$show = qq(<a href="$SCRIPT/Show?_id=$did">$did</a>);

if ( $rec{'_id'} eq '' ) {
wbError( "Password for $did cannot be reset", "Are you sure record $show exists at all? Try to <a href=\"$SCRIPT/SearchForm\">find it</a>!" )
;                                     #UK
return;
}
elsif ( $rec{'_password'} =~ m/^[ugh]:/ ) {
wbError( "Record $did is not locked with password", "$show is associated to a user, group, hostname or IP number. It cannot be changed" ); #UK
return;
}

$to = '';
wbSortFields();
foreach $field (@Fields) {
if ( $WBF{ $field, 'type' } eq 'EMAIL' && $rec{$field} =~ m/\@/ ) {
$to = $rec{$field};
last if $WBF{ $field, 'typePar' } =~ m/OWNER/;
}
}

if ( $to eq '' ) {
wbError( "Valid email required", "Record $show does not contain a valid email address. Reseting password is not possible" );    #UK
return;

}

$from = $WBB{'managerEmail'};
$key  = int( rand(100000000) );
$url  = "$SCRIPTBASE$SCRIPT/PassR2?key=$key";

$subject = "Password Recovery: " . $WBB{'dbTitle'};                                                                                 #UK

$headers = <<EOM;
From: $from
Reply-to: $from
To: $to
Subject: $subject
EOM

$message = <<EOM;                                                                                                                   #UK
Hi,

To really change the password,
please open this URL:

$url

or enter this value:

$key

into the form shown at

$SCRIPTBASE$SCRIPT/PassR2

Automatically,

$WBB{'manager'},
manager.
EOM


open( h, ">$TMPDIR/$key.pwd" );
binmode(h);
print h "$did\n" || wbFail("Could not write .pwd file");
close(h);


$message = "$headers\n$message";

if ( $e = &sendMail("$headers\n$message") ) {
wbFail( "Error sending mail", "Email could not be sent. Error was $e" );
}

print <<EOM;    #UK
<p>Soon you will receive an email to all the email addresses
in record $show.

<p>For security reasons we cannot disclose these addresses,
but perhaps this application lets you see record
$show anyway.

<p>In the email, you will learn a key,
so that you will be able to complete
the password recovery at 
<a href="$SCRIPT/PassR2">$SCRIPTBASE$SCRIPT/PassR2</a>.

<p>If the emails in the record are not yours, we can not help you!

<p>If something goes wrong, try to contact $WBB{manager} at $WBB{managerEmail}.
EOM
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}
1;
