

sub cgiSearchHistory {

@s = &wbSearchHistoryGet();

if ( $#s >= 0 ) {
$n = $#s + 1;
printHead("Search in your recent $n searches");                     #UK
print "<ol>";
foreach $s (@s) {
print "<li>";
print &wbSearchForm( $s, 'FORM' );
}
print '</li>';
print <<EOM;                                                        #UK
<li>
<a href="$SCRIPT/SearchHistoryClear">CLEAR</a>
all of the search history above.
</li>
</ol>
EOM
}
else {
cgiSearchForm();
}
}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub cgiSearchForm {

printHead("Simple search form");    #UK
print &wbSearchForm( $CGI{'search'}, 'FORM,PROMPT,HISTORY' );
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
print <<EOM;                    #UK
<br><a href="$SCRIPT/AdvancedSearchForm"><b>Advanced search form</b></a>
EOM
}
wbHelpSearch();
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub wbHelpSearch {

wbHelps();
print "<ul>\n";
foreach $help (@helps) {
print "<li>$help</li>\n";
}

print <<EOM;    #UK
</ul>
<p>
<b>
<a href="$WodaHelpURL#search">Detailed search help.</a>
</b>
EOM
}
1;
