

sub cgiSimilarShow {

local ( @list, $this, @ids );

$this = $CGI{'id'};

printHead("Records viewed by users who viewed <a href=\"$SCRIPT/Show?_id=$this\">$this</a>");    # UK

@logs = &glob('_log/*.log');
@logs = sort { $b cmp $a } (@logs);

undef @rows;
foreach $log (@logs) {

open( h, "_log/$log" );
push( @rows, grep( /\tShow\t/, <h> ) );
close(h);

if ( $#rows > 10000 ) {

last;
}
}


@thisShows = grep( /_id=$this/, @rows );
$times = $#thisShows + 1;


foreach $row (@thisShows) {
@x = split( /\t/, $row );
$users{ $x[4] }++;
}

$since = &formatDate( $x[2] );


@users  = keys(%users);
$nusers = $#users + 1;

$pattern = join( '\t|\t', @users );
$pattern = "\\t$pattern\\t";

@otherShows = grep( /$pattern/, @rows );

foreach $rows (@otherShows) {
$rows =~ m/_id=([^&\s]*)/;
$show{$1}++;
}

@ids = sort { $show{$b} <=> $show{$a} } keys(%show);

unless ( $#ids >= 0 ) {
wbWarn('None');    #UK
return;
}

print <<EOM;           #UK
<p>Examining $#rows /Show pages, record $this was shown <b>$times times</b>
since $since by <b>$nusers users</b>. These users also showed (more popular first):
EOM

printRecords( 'DEFAULT', *ids, 10 );
}


sub printRecords {

local ( $format, *ids, $max ) = @_;

$max = $max | 10;

undef @list;
wbSortFields();

$i = 0;
foreach $id (@ids) {
recRead($id);
next unless $rec{'_id'};
$i++;
$ThisRecordNo = $i;
$list[$i] = &formatFoundRec( $format, *PFields );    # Hidden ??
last if $i eq $max;
}

$head = &formatFoundHeader( $format, *PFields );         # Hidden ??
formatFoundSeparators( $format, 1 );

print <<EOM;
<form action="$SCRIPT/BasketEdit" target="_self">	
<div class="RECORDS"> $t0 $head
EOM
$i = 0;
foreach $_ (@list) {
print "$t1$_$t2";
$i++;
last if $i eq $max;
}
print $t3;

$modify = "Add checked items to $WBB{'basketName'}";    #UK
$x      = 'SUBMIT';
$x      = 'HIDDEN' unless $WBB{'basketName'};
print <<EOM;
</div>
<br>
<input $x class="BUTTON" type="$x" value="$modify">
</form>
EOM
}


sub formatFoundHeader {

local ( $format, *fields ) = @_;
local ( $f, $hd, $ft );

@fields = &visibleFields(@fields);

if ( $format eq 'TABLE' ) {
$hd = '<tr class="DATAH" ><th>&nbsp;</th>' . "\n";
}
else {
$hd = '';
}

foreach $f (@fields) {
if ( $format eq 'TABLE' ) {
$x = &formatFieldName($f);
$hd .= '<th align="left">' . $x . '</th>';
}
elsif ( $format eq 'TAB' ) {
$hd .= "$f\t";
}
elsif ( $format eq 'CSV' ) {
$hd .= "$f,";
}
elsif ( $format eq 'CSVS' ) {
$hd .= "$f;";
}
}

if (   $format eq 'TAB'
|| $format eq 'CSV'
|| $format eq 'CSVS' )
{
chop($hd);
}

if ( $format eq 'TABLE' ) {
$hd .= "</tr>";
}

$hd .= "\n" if $hd ne '';

return $hd;
}


sub formatFoundSeparators {

local ( $format, $n ) = @_;

if ( $format eq 'CSV' || $format eq 'CSVS' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'TAB' ) {
$t0 = "<XMP>\n";
$t1 = "";
$t2 = "\n";
$t3 = "</XMP>\n";
}
elsif ( $format eq 'RAW' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'XML' || $format eq 'XMLE' ) {
$t0 = "<!DOCTYPE records>\n<records>\n";
$t1 = "";
$t2 = "";
$t3 = "</records>\n";
}
elsif ( $format eq 'RSS' ) {
$x  = &htUntag("$WBB{'apTitle'} - $WBB{'dbTitle'}");
$x  = &htQuote($x);
$y  = &htQuote( $WBB{'about'} );
$t0 = <<EOM;
<rss version="0.91">
<channel>
<title>$x</title>
<link>$SCRIPTBASE$SCRIPT</link>
<description>$y</description>
<language>en-us</language>
EOM
$t1 = "";
$t2 = "";
$t3 = <<EOM;
</channel>
</rss>
EOM
}
elsif ( $format eq 'TABLE' ) {
$t0 = '<table class="DATATABLE" cellspacing="1">"\n"';
$t1 = "";
$t2 = "";
$t3 = "</table><br>\n";
}
elsif ( $format eq 'LONG' || $format eq 'NAMEVAL' ) {
$t0 = "";
$t1 = "";
$t2 = "<hr>\n";
$t3 = "";
}
elsif ( $format eq 'DEFAULT' || $format =~ m/^\d$/ ) {
$t0 = &evalMaybe( $WBB{"formatHead$format"} );
$t1 = '';
$t2 = '';
$t3 = &evalMaybe( $WBB{"formatFoot$format"} );
}
elsif ( $format eq 'PARAGRAPH' ) {
$t0 = '';
$t1 = '';
$t2 = '';
$t3 = '<br><br>';
}
}
1;
