

sub cgiStore {

$tmpID = $CGI{'tmpID'};

recReadFile("$TMPDIR/$tmpID.rec");

if ( !%rec ) {
wbError( "Data missing", "The submitted data in $TMPDIR/$tmpID.rec could not be read" );    #UK
return;
}


$newID = $CGI{'newID'} || &evalWBBkey();
if ( !$newID ) {
$newID = &recRandID();
}


recMoveAttached( $tmpID, $newID );
recSetSystem();
$rec{'_id'} = $newID;
$Log .= "Write $newID\n";
recWrite();
$Log .= "Read $newID\n";
recRead($newID);

if ( !%rec ) {
wbError("ERROR: Database Update Failed");    #UK
return;
}

unlink("$TMPDIR/$tmpID.rec");
wbTmpClean();

$t = "Database Updated";                         #UK
if ($HtmlHeadPrinted) {

}
else {
printHead($t);
}

wbRecordChanged();
wbDatabaseChanged();

$url = "$SCRIPTBASE$SCRIPT/Show?_id=$newID";

$x = <<EOM ;    #UK
<p>Thank you for contributing to $WBB{'dbTitle'}. Your edits were saved at URL <p>
<center><p><a class="BUTTON" href="$url">$url</a>.</p></center>
<p>
This information may be useful to locate the record for editing or updating.
You may wish to <tt>[bookmark]</tt> it.
<p>
To add a record, click on the add icon in the toolbar.
EOM

$y = "Success!";    #UK
print &formatWindow( $y, $x );

$t = "Add another record";    #UK
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Add">
<img $ICONPAR src="$ICONURL/add.gif" alt="$t" title="$t"></a>
EOM

if ( &isLoginTable() ) {
$t = 'WARNING: Login information changed!';    #UK
$m = <<EOM;                                    #UK
<p>Please note that <b>$newID</b> is a username to
<a href="$SCRIPT/LoginForm?username=$newID">log into</a> this
application.
<p>The password to log in is the password that was used
to lock this record.
EOM
if ( $WBB{'userAllow'} ) {
$m .= <<EOM;                               #UK
<p>There are some special conditions set,
so that you might not be able to log-in
right away.
EOM
}

wbWarn( $t, $m, 'width="400"' );
}

if ( $WBB{'cacheExpire'} > 0 ) {

$file = "_cache/default.tbl";
$file =~ tr/[A-Z]/[a-z]/;
open( h, "$file.time" );
$secs = <h>;
close(h);
$secs += 2;

$t = "WARNING: Data not indexed";    #UK
$m = <<EOM;                          #UK
<p>Although your data has been entered, due to the setup of this database,
it may take up to <b>$WBB{'cacheExpire'} hours</b> before it can be found
by searches.
<p>If you want your edits to be visible
immediately, <a href="$SCRIPT/Add">add</a> or edit any other data you may have,
then click below and <b>be patient</b>. The processing may take about <b>$secs seconds</b>.
<form action="$SCRIPT/Reindex" method="post">
<input name="sort" type="hidden" value="default">
<input name="secs" type="hidden" value="$secs">
<input class="BUTTON" type="submit" value="OK, I'll wait">
</form>
EOM
print &formatWindow( $t, $m );
}

print "<p>\n";
}


sub wbRecordChanged {

if ( $WBB{'afterRecordModify'} ne '' ) {
&evalSafe( $WBB{'afterRecordModify'} );
}
}


sub wbTmpClean {

wbDirClean( $TMPDIR, 30, <<EOM);
This directory contains temporary files.
Files older than 30 days are deleted anyway.
EOM

}


sub recRandID {

local ( $id, $x );

$x = $WBB{'key'};
if ( $x =~ m/\&NEXT/ || $x =~ m/NEXT\(/ ) {
return &evalSafe($x);
}
else {
while (1) {
$id = &wbRandKey();
last unless &recExists($id) >= 0;
}
return $id;
}
}


sub wbRandKey {

local ($n) = $_[0];
local (@a) = ( 0 .. 9, 'a' .. 'f' );
local ( $x, $n, $c, $o, $base, @c, $i );
$base = $#a + 1;

$n = $n || 4;
$x = $base**$n;
$x = int( rand($x) );

for ( $i = 1 ; $i <= $n ; $i++ ) {
$o     = $x % $base;
$c[$i] = $a[$o];
$x     = int( $x / $base );
}

return ( join( '', @c ) );
}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub isLoginTable {

local ($ut);

if ( $WBB{'userTable'} eq '' ) {

return 0;

}
else {

return &wbTables( 'URL', $WBB{'userTable'} ) eq &wbTables( 'URL', '' );

}
}


sub evalWBBkey {

local ( $x, $y );

$x = $WBB{'key'};
return '' if $x =~ m/\&NEXT/;

$y = &evalSafe($x);    # setting
return &wbFixId($y);

}


sub recMoveAttached {

local ( $tmpID, $newID ) = @_;
local ( $destDir, $srcDir, $srcFile, $destFile, $d, @toDelete );

$destDir = &wbCheckDir("$HTMLDIR/att");
$srcDir  = "$DATADIR/_tmp";

wbSortFields();
foreach $field (@Fields) {
next
unless ( $WBF{ $field, 'type' } eq "USERFILE"
|| $WBF{ $field, 'type' } eq "IMAGE" );
$srcFile = $rec{$field};

if ( $srcFile eq '' ) {


@toDelete = &glob("$destDir/$newID.$field.*");
foreach $d (@toDelete) {
unlink "$destDir/$d";
}

}
elsif ( -e "$srcDir/$srcFile" ) {


$srcFile =~ m/([^\.]*)$/;    # extract .extension
$ext = $1;
$x   = rand();
$x =~ s/\D//g;
$x = substr( $x, 0, 5 );
$destFile = "$newID.$field.$x.$ext";


@toDelete = &glob("$destDir/$newID.$field.*");
foreach $d (@toDelete) {
unlink "$destDir/$d";
}


wbMoveFile( "$srcDir/$srcFile", "$destDir/$destFile" );
$rec{$field} = $destFile;

}
elsif ( $srcFile !~ m/^$newID\./ ) {


$srcFile =~ m/\.$field\./;
$destFile = "$newID.$field.$'";
wbMoveFile( "$destDir/$srcFile", "$destDir/$destFile" );
$rec{$field} = $destFile;

}

}    # each field

}



sub recSetSystem {


local ($from);
$from         = $RH;
$from         = $RA if !$from;
$rec{'_from'} = $from;


$rec{'_at'} = time;

}
1;
