

sub cgiXputMany {

cgiAdmImport();

}


sub cgiAdmImport {

$makeRecordChanges = ''
|| $CGI{doOnRecordChange};    # must be requested explicitly

printHead("Import results");

if ( $CGI{'_password'} && $CGI{'_password'} ne $CGI{'_password1'} ) {
wbFail("Passwords do not match!");
}

if ( $CGI{'_password'} ) {
$cPassword = &wbCryptPasswd( $CGI{'_password'} );
}
else {
$cPassword = '';
}

$delim = $CGI{'fsep'} || ';';

if ( $CGI{'csv'} eq '' ) {
print '<h3 class="ERROR">No csv file supplied</h3>', "\n";
return;
}
else {
admReadCSV();
}


$x = join( "", @err );
if ( $x && !defined( $CGI{'eignore'} ) ) {
print '<h3 class="ERROR">ERRORS IN INPUT DATA:</h3>', "\n";

for ( $i = 2 ; $i <= $#err ; $i++ ) {
if ( $err[$i] ) {
$id = $id[$i];
$err[$i] =~ s/WARN/<br>WARN/g;
print <<EOM;
<h3 class="ERROR">Errors in row $i ... _id=$id</h3>
<p>$err[$i]
EOM
}
}
wbError( "Errors were found", <<EOM);
Nothing was saved.
EOM

}
else {
print "<h2>No errors in input data</h2>\n" unless $x;
print "<h2>Errors in input data ignored</h2>\n" if $x;

$| = 1;

for ( $inLine = 2 ; $inLine <= $#rec ; $inLine++ ) {

$home = $DATADIR;

if ( $id[$inLine] ) {    # before 24.11.1999 was ($WBB{'key'} || $id[$inLine])
$id = $id[$inLine];
}
else {
$id = &recRandID();
}


recFromVector( $rec[$inLine] );



if ( $at[$inLine] ) {
$rec{'_at'} = $at[$inLine];
}


if ( $rec{'_at'} eq '' ) {
$rec{'_at'} = time;
}


if ( $CGI{'how'} eq 'merge' ) {
%newrec = %rec;
recRead($id);

foreach $field ( keys(%newrec) ) {

$rec{$field} = $newrec{$field} if ( $newrec{$field} );
}
}


if ( $CGI{'crypt'} && $rec{'_password'} ) {
$rec{'_password'} = &wbCryptPasswd( $rec{'_password'} );
}

if ( $cPassword && $rec{'_password'} eq '' ) {
$rec{'_password'} = $cPassword;
}

$rec{'_id'} = $id;
recWrite();
wbRecordChanged() if $makeRecordChanges;
print "<br />Line $inLine was saved to <a href=\"$SCRIPT/Show?_id=$id\">$id</a>\n";
}
wbDatabaseChanged();    #moved out of loop, so we call it once at the end, not every loop
}
}


sub admReadCSV {

local ($how) = @_;


$CGI{'csv'} =~ s/\r//g;
@csv = split( /\n/, $CGI{'csv'} );
$line = 0;


while ( $dLine = shift(@csv) ) {

$line++;
undef %rec;

if ( $line == 1 ) {
if ( $dLine =~ m/\,/ ) {
$delim = ',';
}
elsif ( $dLine =~ m/\;/ ) {
$delim = ';';
}
else {
wbError( 'Bad delimiter', 'Delimiter of the .csv file should be comma (,) or semicolon (;)' );
return;
}
}

while ( ( $dLine =~ tr/"/"/ ) % 2 ) {

if (@csv) {
$dLine .= "\n";           # removed by split
$dLine .= shift(@csv);    # next line
}
else {
print "<h3>Bad .csv file at line $line; \" did not close</h3>\n";
return;
}
}

next
if $dLine =~ m/^$delim*$/;      # ignore lines with nothing but blank cells

@flds = split( /$delim/, $dLine );

if ( $line == 1 ) {
@csvf = @flds;
print "<p>The fields are:<ol><li>";
print join( "</li>\n<li>", @flds );
print "</li></ol><p>\n";
}

$field = 0;

while (1) {
last unless (@flds);

$f = shift(@flds);

$field++;

while ( ( $f =~ tr/"/"/ ) % 2 ) {
if (@flds) {
$f .= $delim . shift(@flds);
}
else {
print "<h3>Bad .csv file at line $line; \" did not close</h3>\n";
return;
}
}

$f =~ s/^"//;
$f =~ s/"$//;
$f =~ s/""/"/g;

if ( $line == 1 ) {
if ( $f eq '' ) {
wbError( 'Column without name', 'Aborted' );    #UK
}
$key[$field] = $f;
$CGI{"_f$field"} = $f;

}
else {
$rec{ $key[$field] } = $f;
admGuessFieldType( $field, $f ) if $how eq 'CREATE';
}

}

if ( $line > 1 ) {

$e = &recValidate();

if ( $rec{'_id'} ne '' ) {    # _id is in the file ... keep original ID

$id[$line] = $rec{'_id'};

}
elsif ( ( $newId = &evalWBBkey() ) ne '' ) {    # compute new ID via WBBkey

$id[$line] = $newId;

}
else {


}

if (   $id[$line] ne ''
&& $CGI{'how'} eq 'addonly'
&& &recExists( $id[$line] ) >= 0 )
{
$e = $e . "\n<b>Record exists!</b>\n";
}

$err[$line] = $e;
$keepUnderscores = 1
if $rec{'_from'} || $rec{'_at'} || $rec{'_password'};
$rec[$line] = &recToVector();
$at[$line] = $rec{'_at'} if $rec{'_at'};

unless ( $CGI{'quiet'} ) {
local $line;
print "<hr>";
print &wbRecHtml( 'NAMEVAL', *csvf );
}
}
}

print "<h3>$line rows read from file</h3>";

}

sub recValidate {

local ($err);

$err = "";

foreach $field ( keys(%WBF) ) {
next if $field =~ m/$;/;
next if $field =~ m/^_/;
$vex = $WBF{$field};
$_ = $value = $rec{$field};
$_ =~ s/\r//g;    # remove CR

next if $WBF{ $field, 'type' } eq 'BREAK';
next if $WBF{ $field, 'type' } eq 'SUBMIT';

if (   $_
&& $WBF{ $field, 'type' } eq "FILE"
&& !-f "$HTMLDIR/att/$value" )
{
$err .= "WARNING: file $HTMLDIR/att/$value does not exist\n";    #UK
$err{$field} = 1;
next;
}

if (   $vex eq '1;'
&& $WBF{ $field, 'type' } eq 'EMAIL'
&& $value ne ''
&& !&isEmail($value) )
{
$err .= "WARNING: bad email address at $field\n";                #UK
$err{$field} = 1;
next;
}

if ( $vex eq '1;' && $WBF{ $field, 'type' } eq 'DATE' && $value ) {
local ( $y, $m, $d ) = split( /\//, $value );
if ( $y !~ /^\d\d\d\d$/ || $m > 12 || $m < 1 || $d < 1 || $d > 31 ) {
$err .= "WARNING: bad date at $field\n";                     #UK
$err{$field} = 1;
}
next;
}

if ( $WBF{ $field, 'type' } eq 'LIST' ) {
@x = split( /\n/, $_ );
}
else {
@x = ($_);
}

foreach $_ (@x) {

$y = 1;

$* = 1;                  # multiline matching
$y = &evalSafe($vex);    # calculate
$* = 0;                  # single line matching

if ($y) {
if ( $y =~ m/CLASS\=ERROR/i ) {
wbFail( "Error validation expression", "$y in $vex" );    #UK
}
}
else {
$m = $WBF{ $field, 'cond' };
$m = $WBF{$field} if !$m;
$err .= "WARNING: bad value for <b>$field</b>:\n\t'$value' does not satisfy '<b>$m</b>'\n";    #UK
$err{$field} = 1;
}
}

}

if ( defined(&myRecVerify) ) {
$err .= &myRecVerify();
}

$Log .= $err;

return $err;
}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub evalWBBkey {

local ( $x, $y );

$x = $WBB{'key'};
return '' if $x =~ m/\&NEXT/;

$y = &evalSafe($x);    # setting
return &wbFixId($y);

}


sub admGuessFieldType {

local ( $field, $data ) = @_;

return if $CGI{"type$field"} =~ m/EMAIL|URL|HTMLAREA/;
if ( $data =~ m/\@/ ) {
$CGI{"type$field"} = 'EMAIL';
print "<br>I guess column $key[$field] is of type email!\n";
}
elsif ( $data =~ m/^http:\/\/|^ftp:\/\/|^news:|^mailto:/ ) {
$CGI{"type$field"} = 'URL';
print "<br>I guess column $key[$field] is of type URL!\n";
}
elsif ( $data =~ m/\034/ || length $data > 100 ) {
$CGI{"type$field"} = 'HTMLAREA';
print "<br>I guess column $key[$field] is of type HTMLAREA!\n";
}
}


sub recRandID {

local ( $id, $x );

$x = $WBB{'key'};
if ( $x =~ m/\&NEXT/ || $x =~ m/NEXT\(/ ) {
return &evalSafe($x);
}
else {
while (1) {
$id = &wbRandKey();
last unless &recExists($id) >= 0;
}
return $id;
}
}


sub wbRandKey {

local ($n) = $_[0];
local (@a) = ( 0 .. 9, 'a' .. 'f' );
local ( $x, $n, $c, $o, $base, @c, $i );
$base = $#a + 1;

$n = $n || 4;
$x = $base**$n;
$x = int( rand($x) );

for ( $i = 1 ; $i <= $n ; $i++ ) {
$o     = $x % $base;
$c[$i] = $a[$o];
$x     = int( $x / $base );
}

return ( join( '', @c ) );
}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub wbRecordChanged {

if ( $WBB{'afterRecordModify'} ne '' ) {
&evalSafe( $WBB{'afterRecordModify'} );
}
}
1;
