
strict;



no warnings qw(redefine);

no warnings qw(uninitialized);



sub main {

WODAUK'mainError() if $ENV{'MOD_PERL'};

if ( defined &WODAUK'run ) {    #UK
if ( defined %WBB ) {
WODAUK'run( *WBB, *WBF );    #UK
}
else {
WODAUK'run( *WBBase, *WBField );    #UK
}
}
else {
if ( defined %WBB ) {
run( *WBB, *WBF );
}
else {
run( *WBBase, *WBField );
}
}
}


sub run {

$STDOUT = select;


if ( $ENV{'MOD_PERL'} ) {
mainClean();

}
elsif ( $ENV{'SERVER_SOFTWARE'} =~ m/woda/i ) {


}

$StartTime = time;
logTime("Perl compile overhead");


local ( *WBB, *WBF ) = @_;


wbWhoami();
( $SCRIPTPACKAGE, @x ) = caller;


mainConfig();



mainCmdline();


mainPathInfo();


$rf = $WBB{'requireFile'};

if ( $rf ne '' ) {

if ( $rf =~ m|^/| ) {


}
elsif ( $rf =~ m/^\w/ ) {

$rf = "$TEMPLATEDIR/lib/$x";

}
else {

$rf = $WBB{'dataDir'} . '/' . $rf;

}

if ( -e $rf ) {
require $rf;
}
else {

$Log .= "ERROR: required file $rf is missing\n";
}
}


mainDataDir();


$x = "$DATADIR/../_common.pl";
if ( $DATADIR && -e $x ) {
require $x;
unless ( -e "$DATADIR/../$HtaccessFile" ) {
open( h, ">$DATADIR/../$HtaccessFile" );
print h $HtaccessDeny;
close(h);
}
}


mainDefaults();


time =~ m/....$/;
srand( $& * $$ );


if ($DATADIR) {
if ( !-d $DATADIR ) {
wbCheckDirectories();
}
chdir($DATADIR) || wbFail("Cannot chdir to $DATADIR");
}


$JS = 0;

if ( $ENV{'HTTP_USER_AGENT'} =~ m/Mozilla\/./i ) {
$JS = 1.2;
}

if ( $ENV{'HTTP_USER_AGENT'} =~ m/Mozilla\/3|Mozilla\/2/i ) {
$JS = 1.0;
}

if ( $WBB{'JavaScript'} ne '' ) {
$JS = $WBB{'JavaScript'} if $WBB{'JavaScript'} < $JS;
}


htParseMulti();


htReadCookies();

if ( $CGI{'_isindex'} && !$Page ) {
$Page = "Show";
$CGI{'_id'} = $CGI{'_isindex'};
}

if ( !$Page ) {
$Page = "Home";
}

if ( $CGI{'_isindex'} && !$Page ) {
$Page = "Show";
$CGI{'_id'} = $CGI{'_isindex'};
}

$Action   = "cgi" . $Page;
$MyAction = "my" . $Page;


wbLogin();


if ( $n = &wbDenied( $Group, $Page ) ) {
printDeny($n);
}


if ( -e "_cache/closed.ip" ) {
open( H, "_cache/closed.ip" );
$tip = <H>;
close(H);
if ( $tip ne $RA && $tip ne $ENV{'HTTP_WODA_END_USER'} ) {
open( H, "_cache/closed.txt" );
@msg = <H>;
$msg = join( '', @msg );
close(H);
wbError( "Database is closed", "$msg" );    #UK
}
else {
$WBB{'dbTitle'} .= "[CLOSED FOR GENERAL PUBLIC]";    #UK
}
}


if (
( $Page !~ m/Show|Home|About|Browse|RobotToc/ )
&& (   -e "$DATADIR/_tmp/robot.$RA"
|| $RA =~ m/$ROBOTIP/
|| $ENV{'HTTP_USER_AGENT'} =~ m/$ROBOTAGENT/i )
)
{
redirectRobot();
wodaExit();
}


if ( $UPTIME && $WBB{'quotaLoad'} ne '' ) {
$x = `$UPTIME`;
$x =~ m/averages:\s+([0-9\.]+)/;
$load = $1;
@x = split( /\n/, $WBB{'quotaLoad'} . "\n" );
foreach $x (@x) {
( $l, $p ) = split( /\s+/, $x, 2 );
next if $l eq '';
next if $p eq '';
next if $l > $load;
next if $Page !~ m/$p/;
wbError( "Load is too high", "Please try to reload $Page later" );    # UK
}
}


$NOCACHE = '.|/Adm|Form';                                                     # do not cache anything !!!

$request = "_$ENV{'PATH_INFO'}_$ENV{'QUERY_STRING'}_";
$request =~ s|/|\.|g;

unless ( $request =~ m|$NOCACHE|
|| 'admin' =~ m|$groups|
|| $ENV{'REQUEST_METHOD'} eq "POST" )
{                                                                             # something is not cached
$file = "$DATADIR/_cache/$request";
if ( -s $file ) {
open( h, $file );
@x = <h>;
close h;
}
else {
open( STDOUT, ">$file" );
binmode(STDOUT);
mainAction();
close(STDOUT);

open( STDOUT, ">-" );
binmode(STDOUT);
open( h, $file );
@x = <h>;
close h;
}
print @x;
}
else {
mainAction();
}

wodaExit();


if (0) {
&NOOP();
&ID();
&TODAY();
&QRY();
&GET();
&PUT();
&RELATED();
&DECODE();
&LINK();
&ROWS();
&FLD();
&KEY();
&FETCH();
&PIC();
&IDS();
&NEXT();
&URL();
&PUTN();
}
}


sub mainAction {


if ( !$DATADIR || $Action eq 'cgiUpgrade24' || $CMDLINE || -e '_data' ) {

}
else {
forwardTo("Upgrade24");
}

if ( defined &$MyAction ) {
&$MyAction();

}
elsif ( -e "$WodaFileDir/local/$Action.pl" ) {    # overloaded separate file ?
require "$WodaFileDir/local/$Action.pl";
&$Action()

}
elsif ( defined &$Action ) {
&$Action();

}
elsif ( -e "$WodaLibDir/$Action.pl" ) {           # separate file ?
require "$WodaLibDir/$Action.pl";
&$Action();

}
elsif ( -e "$WodaFileDir/contrib/$Action.pl" ) {    # overloaded separate file ?
require "$WodaFileDir/contrib/$Action.pl";
&$Action()

}
elsif ( -e "$WodaFileDir/../en/contrib/$Action.pl" ) {    # overloaded separate file ?
require "$WodaFileDir/../en/contrib/$Action.pl";
&$Action()

}
else {
$m = <<EOM;                                           #UK
Maybe file '$WodaLibDir/$Action.pl' is missing.
<br>Maybe full path to the above file is missing.
<br>Maybe the upper/lower case of the filename (under UNIX) is wrong.
EOM
wbFail( "Action '$Action' not implemented", $m );     #UK
}

printFoot();
wodaExit();
}


sub wbFail {

local ( $title, $more ) = @_;
( $package, $filename, $line ) = caller;

$more = <<EOM;    # UK
<p>Cannot continue because of an error in $filename in line $line.
<p><b>$more</b>
<p>Please report this to the manager of this database: $WBB{'managerEmail'}
EOM

$Err = 'FA';
wbError( "FATAL ERROR: $title", $more, $caller );    # UK
}


sub wbError {

local ( $title, $message, $caller, $ba ) = @_;

$ba = -1 if $ba eq '';

return if $IGNOREERRORS;

select($STDOUT) if $STDOUT;

if ( !$HttpHeadPrinted ) {


printMiniHead( "", "Woda-error:error\n" );
print "<br><br><br><br>";
}

$back = "Go back";    #UK
$body = <<EOM;
<p>$message
<p>$caller
<p>
<form name="buttonbar" action="">
<input class="BUTTON" type=BUTTON value="$back" onClick="history.go($ba)">
</form>
EOM

print &formatWindow( $title, $body, 'ERRBOX' );

$ErrMsg = "$title:$message";
$Err = $Err || 'ER';

$ICONURL = $ICONURL || '/icons/default';

printFoot();
wodaExit();
}


sub wodaExit {

recCloseAll();


if ( $ENV{'MOD_PERL'} ) {
Apache'exit(0);    # close ' for syntax highlighting
}
elsif ( $ENV{'SERVER_SOFTWARE'} =~ m/woda/i ) {
exit(0);
}
else {
exit(0);
}
}


sub recCloseAll {

$Log .= "Close all\n";
foreach $table ( keys(%Opened) ) {
recClose($table);
}
}


sub recClose {
local ($table) = @_;

if ( $Opened{$table} ) {
( $HData, $HFat ) = &recHandles($table);
close($HData);    # || wbFail("not closed1");
close($HFat);     # || wbFail("not closed2");
$Log .= "Closed $table\n";
}

$Opened{$table} = 0;
}



sub recHandles {

local ($x) = @_;
return ( "HD$x", "HF$x" );
}


sub printFoot {

$PageCount = &wbAccessCount();
wbLog();
logTime("Done");

return unless $HtmlHeadPrinted;


print &evalMaybe( $WBB{"foot;$Page"} )
|| "\n<!-- WBB{foot;$Page} would be here -->";

print "\n</div><!-- closing div for CORE -->\n";


if ( $WBB{'toolbar'} ne '' ) {
@x = split( /\n/, $WBB{'toolbar'} );
foreach $x (@x) {
( $patt, $string ) = split( /\s+/, $x, 2 );
if ( $Page =~ m/$patt/ ) {
my $x = &evalSafe($string) || $string;
push( @Toolbar, $x );
}
}
}


if ( !$MINIHEAD ) {

$homeURL = &homeURL();

if ( $Group eq 'admin' || $Group eq 'guest' || $Group eq 'friend' ) {
$uicon = "u$Group";
}
else {
$uicon = "uother";
}
local ( $hh, $w, $u );
if ($User) {
$us = "user $User from group $Group";    #UK
}
else {
$us = "belong to group $Group";          #UK
}

$hh   = "Home page of this database";          #UK
$hht  = "home";                                #UK
$w    = "Web Oriented Database Home";
$u    = "logout (you are $us)";                #UK
$u    = "login" if $Group eq 'guest';          #UK
$ah   = "ADMIN'S HOME";                        #UK
$lurl = "$SCRIPT/LoginOrRegister?$Referer";    #UK

push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'Home' ) || $homeURL !~ m/Home$/;
<a href="$homeURL" $TargetParent><img $ICONPAR src="$ICONURL/home.gif" alt="$hh" title="$hht"></a>
EOM
push( @Toolbar, <<EOM) if $Group eq 'admin';
<a href="$SCRIPT/AdmMenu" $TargetParent><img $ICONPAR src="$ICONURL/ahome.gif" alt="$ah" title="$ah"></a>
EOM

push( @Toolbar, <<EOM) if ( !$NOLOGICON ) && &wbAllowed( $Group, 'LoginOrRegister' );
<a href="$lurl"><img $ICONPAR src="$ICONURL/$uicon.gif" alt="$u" title="$u"></a>
EOM

$toolbarText = &evalMaybe( $WBB{"toolbarText"} )
|| "$WBB{'dbTitle'}<!-- WBB{'toolbarText'} -->";
$woda = <<EOM;
<a href="$POWERURL" $TargetParent><img class="ICON" src="$POWERIMG" alt="$POWERTEXT" title="$POWERTEXT" $POWERSIZE></a>
EOM

}    # MINIHEAD ?

if ( !$MINIHEAD && $WBB{'pageEnd'} ) {

$toolbar = join( '', @Toolbar );

print &evalMaybe( $WBB{'pageEnd'} );

}
elsif ( $#Toolbar >= 0 ) {


$toolbar = join( qq(<img src="$ICONURL/pixel.gif" alt="">), @Toolbar );


$toolbar =~ s/>\n/>/g;
$toolbar =~ s/>/\n>/g;


$cols = $toolbar =~ s/<td/<td/gi;
$cols += 2;


print <<EOM;
<!-- WBB{'pageEnd'} not defined -->
<div class="TOOLBAR">
<table width="100%"><tr>
<td align="left">$toolbar</td> 
<td align="center">$toolbarText</td>
<td align="right">$woda</td>
</tr></table>
</div>
EOM
}

if ($HtmlHeadPrinted) {
print &evalMaybe( $WBB{'pageFoot'} )
|| "\n<!-- WBB{'pageFoot'} would be here -->";
printTrap();
print '</body></html>';
print <<EOM if $PRINTLOG;
<!--  
++ ++ ++
WODA LOG
++ ++ ++
$Log
++ ++ ++
-->
EOM

}

}


sub evalMaybe {

local ($string) = @_;

if ( $string =~ m/^\s*qq\(|^\s*"|^\s*'|^#|;\n/ ) {
return &evalSafe($string);
}
else {
return $string;
}
}


sub evalSafe {

local ($ev) = @_;
local ( $x, $e );

return '' if $ev eq '';

if ( $x = &evalTrouble($ev) ) {
$x  = &htQuote($x);
$ev = &htQuote($ev);
$e  = qq(<em class="ERROR"><a href=\"$SCRIPT/AdmHelpSecurity\">Security risk:</a>'$x' in <pre>$ev</pre></em>\n);
$Log .= "EVAL ERROR: UNSAFE\n$x\n";
$@ = $x;
}
else {
$e = eval $ev;
$e = qq(<em class="ERROR">Eval error:$@</em>\n) if $@;
}

return $e;
}


sub evalTrouble {

local ($_) = $_[0];

return '';
}


sub htQuote {
local ($_) = $_[0];

s/\&/\&amp;/g;
s/\>/\&gt;/g;
s/\</\&lt;/g;
s/\"/\&quot;/g;
s/\'/\&#39;/g;    # &apos; not generally used by browsers !!!

return $_;
}


sub wbAllowed {

return !&wbDenied(@_);

}


sub wbDenied {

local ( $dgroup, $dpage, $dparam ) = @_;
local (@x);

if ( $HIDDENCGI && $dpage =~ m/$HIDDENCGI/ ) {

$Log .= ("Hidden $dpage\n");
return 1;
}

return 0
if $dpage =~ /^Login$|^LoginForm$|^LoginOrRegister$|^$|^AboutUser$/;



if (   $RGroup eq 'other'
&& $dpage =~ m/Edit|Modify|Delete/
&& $dgroup ne 'admin' )
{
return 1;
}


$x = $WBB{'rights'};
$c = chop($x);
if ( $c ne "\n" ) {
$x .= "$c\n";
}
else {
$x .= "\n";
}


$x .= <<EOM;
allow	client	^X
deny	guest	^Basket|^SearchHistory|^Form
deny	.*	^Agent
deny	.*	^Adm|^X
deny	.*	^Search	format=XML|format=CSV|format=TAB
EOM

@x = split( /\n/, $x );

$querystring = $dparam;    # will not use CGI!
foreach $_ (@x) {

( $what, $group, $patt, $qpatt ) = split( /\s+/, $_, 4 );
$patt =~ s/\s+//;
if ( $dpage =~ m/$patt/ && $dgroup =~ m/$group/ ) {
if ( $qpatt eq '' ) {
return 1 if $what eq 'deny' && $dgroup ne 'admin';
return 0 if $what eq 'allow';
}
else {


if ( $querystring eq '' ) {
foreach $key ( keys(%CGI) ) {
next if length( $CGI{$key} ) > 500;
$querystring .= "&$key=";
$querystring .= $CGI{$key};
}
}

next if $querystring eq '';    # applies if qs is there

if ( $querystring =~ m/$qpatt/ ) {
$y = $&;
$x = $`;
$x =~ m/[^\&]*$/;
$DeniedPar = "$&$y";
return 10 if $what eq 'deny' && $dgroup ne 'admin';
return 0 if $what eq 'allow';
}
}
}
}

return 0;
}


sub wbLog {

local ( @x, $x, $yyyy, $mm, $dd, $lf, $t, $rh, $ll );

$ll = $WBB{'logLevel'};
$ll = 3 if $ll eq '';
return unless $ll;

$lf   = &logFile();
$yyyy = $x[5];
$mm   = $x[4];
$dd   = $x[3];

$t = &lapTime() || '?';

$rh = $RH || $RA;
if ($Err) {
$e = $Err;
return if $e eq 'ER' && $ll < 2;
}
else {
$e = 'ok';
return if $ll < 3;
}

$ErrMsg =~ tr/\n/ /;
$ErrMsg = '' if $e eq 'NA';    # we don't want the not available error in the log
open( h, ">>$lf" ) || return;
flock( h, 2 );
binmode(h);
$tt = time;
print h <<EOM;
$e	$t	$tt	$rh	$User	$Group	$SCRIPT	$ENV{'REQUEST_METHOD'}	$Page	$ENV{'QUERY_STRING'}	$ErrMsg
EOM

if ( $ll > 3 ) {
$t = $Log;
$t =~ s/\n/\n-/g;
chop($t);
print h '-', $t;
}
close(h);
}


sub logFile {

$lf   = $WBB{'logFile'} || '$yyyy-$mm.log';
@x    = &fixDate(time);
$yyyy = $x[5];
$mm   = $x[4];
$dd   = $x[3];
$lf   = '"' . $lf . '"';
$lf   = &evalSafe($lf);
return $lf if $lf =~ m|^/|;
return "$DATADIR/_log/$lf";
}


sub fixDate {

local (@x) = localtime( $_[0] );

$x[4]++;

for ( $i = 0 ; $i <= $#x ; $i++ ) {
$x[$i] = "0" . $x[$i] if length( $x[$i] ) == 1;
}

$x[5] += 1900;

return @x;
}


sub lapTime {

local (@x) = eval 'times;' || ( time - $StartTime );
$x[0] =~ m/^.{0,5}/;
return $&;
}


sub homeURL {

if ( $WBB{'homePage'} ) {
if ( $WBB{'homePage'} =~ m|/| ) {
$homeURL = $WBB{'homePage'};
}
else {
$homeURL = "$WBB{'htmlURL'}/$WBB{'homePage'}";
}
}
else {
$homeURL = "$SCRIPT/Home";
}

return $homeURL;
}


sub logTime {

$Log .= &lapTime() . ":\t$_[0] \n";
}


sub printTrap {

print qq(<a href="$SCRIPT/Trap"> </a>);

}


sub wbAccessCount {

local ( @data, $file, $job );

$file = "$DATADIR/_cache/access3.txt";

unless ( -e $file ) {
open( access, ">$file" );
binmode(access);
print access "0\n";
print access time() . "\n";
close(access);
}

open( access, "+<$file" );
binmode(access);
@data = <access>;    # no locking !!!, newlines included !
chop(@data);
$data[0]++;
if ( !$CMDLINE ) {
$data[4] = "UID=$>";
$data[5] = "URL=$SCRIPTBASE$SCRIPTNAME";
$data[6] = "SCRIPTFILE=$SCRIPTFILE";
}

$freq = $WBB{'maintenancePeriod'} || 0;    # automatic maintenance off !!!
$freq = $freq * 3600;
$t    = time - $data[2];
if ( !$CMDLINE && $freq && $data[3] ne '1' && ( time - $data[2] ) > $freq ) {
$job = &wbAtdo();
if ($?) {
$data[3] = 1;
}
else {
$data[2] = time;
}
}

seek( access, 0, 0 );
print access join( "\n", @data );
print access "\n";
close(access);

return $data[0];
}


sub wbAtdo {

local ($job);

$job = &wbAtjob();

wbCheckDir($TMPDIR);
open( at, ">$TMPDIR/$$.at" );
binmode(at);
print at $job;
close(at);

return `$AT -f$TMPDIR/$$.at now 2>&1`;

}


sub wbCheckDir {

unless ( -d $_[0] ) { mkdir( $_[0], $DIRMODE ); }
unless ( -d $_[0] ) { wbFail("Cannot make/access directory $_[0]"); }
return $_[0];
}


sub wbAtjob {

findSendmail();
( $prg, $prefix ) = &wbPrepareCommandLine();

return "$prg -x $prefix/AdmDaily 2>&1 | $SENDMAIL $WBB{'managerEmail'}";

}


sub findSendmail {

return if -e $SENDMAIL;

$SENDMAIL = '/usr/libexec/sendmail/sendmail';
return if -e $SENDMAIL;

$SENDMAIL = '/usr/sbin/sendmail';
return if -e $SENDMAIL;

$SENDMAIL = '/usr/lib/sendmail';
return if -e $SENDMAIL;

$SENDMAIL = '/usr/bin/sendmail';
return if -e $SENDMAIL;

wbFail( '$SENDMAIL not configured properly', "Cannot execute $SENDMAIL" );
}


sub wbPrepareCommandLine {

local ($table) = @_;

$cgiPrg = &wbTables( 'DEF', $table );
unless ($cgiPrg) {
return ( '', "ERROR - Table $table not known" );
}

if ( $cgiPrg =~ m|$DATADIRDIR/([^/]+)/_datadict/dd| ) {
$cgiDef = $1;
$cgiPrg = $SCRIPTFILE;
}
elsif ( $cgiPrg =~ m|$TEMPLATEDIR/structures/| ) {
$cgiDef = $';
$cgiPrg = $SCRIPTFILE;
}
else {
$cgiDef = '';
}

return ( $cgiPrg, $cgiDef );
}


sub wbTables {

local ( $op, $alias ) = @_;
local ( @x, $x, $al, $dir, $def );
local $_;


if ( $TBL{ $op, $alias } =~ m|/| ) {
my $s = $TBL{ $op, $alias };
$s =~ s#/U=.*$##;
return $s;
}


if ( $alias eq '' ) {
my $s;
$s = $DATADIR              if $op eq 'DIR';
$s = $DATADICT             if $op eq 'DEF';
$s = $SCRIPTBASE . $SCRIPT if $op eq 'URL';
$s =~ s#/U=.*$##;
return $s;
}


if ( $op eq 'DIR' && $alias =~ m|/| ) {

if ( $alias =~ m|^/| ) {

my $s = $alias;
$s =~ s#/U=.*$##;
return $s;
}
else {

my $s = $DATADIR . '/' . $alias;
$s =~ s#/U=.*$##;
return $s;
}
}


if ( $WBB{'tables'} ne '' && !defined(%TBL) ) {
@x = split( /\n/, $WBB{'tables'} );
foreach $_ (@x) {
( $al, $def, $dir ) = split( /\s+/, $_, 3 );
if ( $def =~ m/^http/ ) {

$dir = '' if $dir eq '';
$TBL{ 'URL', $al } = $def;
$TBL{ 'DIR', $al } = $dir;    # likely to be empty
$TBL{ 'DEF', $al } = '';
}
else {

if ( $def =~ m!/cgi|/db!i ) {
$TBL{'URL'} = $SCRIPTBASE . $& . $';
}
else {

}
$TBL{ 'DEF', $al } = $def;
$TBL{ 'DIR', $al } = $dir;
}
}
}


$TBL{ 'DIR', '' } = $DATADIR;
$TBL{ 'DEF', '' } = $DATADICT;
$TBL{ 'URL', '' } = $SCRIPTBASE . $SCRIPT;


if ( $TBL{ $op, $alias } =~ m|/| ) {
my $s = $TBL{ $op, $alias };
$s =~ s#/U=.*$##;
return $s;
}


if ( defined $TBL{ $op, $alias } ) {
return '' if $TBL{ $op, $alias } eq '';
}


$TBL{ 'DIR', '' } =~ m|[^/]*$|;
$we = $&;
$other = $TBL{ $op, '' };
$other =~ s|/$we|/$alias|;

$Log .= "table '$alias' not defined in WBB{'tables'} ... we are '$we' ... TBL{$op,$alias}=$other\n";

$TBL{ $op, $alias } = $other;
my $s = $TBL{ $op, $alias };
$s =~ s#/U=.*$##;
return $s;

}


sub formatWindow {

local ( $title, $body, $class ) = @_;

$class = 'BOX'    if $class eq '';
$body  = '&nbsp;' if $body  eq '';
$title = '&nbsp;' if $title eq '';
return <<EOM;
<p>
<table CLASS=$class cellspacing="2">
<tr><td CLASS=$class>
<h3>$title</h3>
</td></tr>
<tr><td CLASS=$class>
$body
</td></tr>
</table>
EOM
}


sub printMiniHead {

$MINIHEAD = 1;
printHead(@_);
}


sub printHead {

local ( $pgTitle, $cookie ) = @_;
local ( $homeURL, $dbTitle, $apTitle, $scriptURL, $p );

if ( $Page eq 'Changed' && $WBB{'title'} ne '' ) {

$pgTitle = $WBB{"title;$Page"} || $pgTitle;
}
else {
$pgTitle = $CGI{'title'} || $WBB{"title;$Page"} || $pgTitle;
}

$dbTitle = $WBB{'dbTitle'};
$apTitle = &evalMaybe( $WBB{'apTitle'} );



binmode($STDOUT);

unless ($HTMLFILE) {
if ( $WBB{'intlCharset'} ne '' ) {
$chs = "; charset=$WBB{'intlCharset'}";
}
else {
$chs = '';
}
print $HTTP200OK . "Content-type: text/html$chs\n";
print $cookie;
print $DemandedCookies;
print "\n";

$Log .= "Cookies:\n";
$Log .= $cookie;
$Log .= $DemandedCookies;

$HttpHeadPrinted = 1;
}

$tt = "$apTitle$dbTitle";
$tt = &htUntag($tt);
$tt =~ tr/\n/ /;

$t = "$apTitle$dbTitle : $pgTitle";
$t = &htUntag($t);
$t =~ tr/\n/ /;

$dt = $WBB{doctype} || '<!-- no doctype setting defined -->';

print <<EOM;
$dt
<html>
<head>
<title>$t</title>
<meta name="GENERATOR" content="$POWERGEN">
EOM

if ( &wbAllowed( $Group, 'Search' ) ) {
print <<EOM;
<link rel="search" title="Search $tt" href="$SCRIPTBASE$SCRIPT/SearchForm">
<link rel="alternate" title="$tt RSS feed" href="$SCRIPTBASE$SCRIPT/Search?format=RSS&amp;sort=TIME&amp;max=10" type="application/rss+xml">
EOM
}

if ($chs) {
print <<EOM;
<meta http-equiv="Content-Type" content="text/html$chs">
EOM
}

print qq(<base href="$SCRIPTURL">\n) if $HTMLFILE;
print qq(<base $TargetDefault>\n)    if $TargetDefault;
print $MetaFields;


if ( $WBB{'style'} ) {
$style = <<EOM;
<style type="text/css">
<!-- 
$WBB{'style'}
--></style>
EOM
}
else {

$style = &defaultStyle();

}

if ( $WBB{'font'} ) {
$style =~ s/font-family: [^;]*/font-family: $WBB{'font'}/g;
}

print $style;
print $WBB{'script'} || "<!-- WBB{'script'} empty -->\n";
print $WBB{'head'}   || "<!-- WBB{'head'} empty -->\n";
print "</head>\n\n";

$HtmlHeadPrinted = 1;


$pb = $WBB{'pageBody'} || $styleBody;

$pb = $WBB{'frameBody'}
|| 'STYLE="background-color: #CCC;" LEFTMARGIN=0 TOPMARGIN=0'
if $FRAMEHEAD;

print "<body onLoad=\"self.focus();\" $pb>\n<!-- body parameters came from WBB{'pageBody'} -->\n";

if ($MINIHEAD) {
if ($pgTitle) {
print '<div class="MINITITLE">', $pgTitle, '</div>';
printTrap();
}

print '<div class="CORE">', "\n";
print &evalMaybe( $WBB{"head;$Page"} )
|| "<!-- WBB{head;$Page} would be here -->\n";

return;    # ------------------------------>

}

$loginBox = &formatLoginBox() unless $Page =~ /^Login|^Pass/;
print &evalMaybe( $WBB{'pageHead'} )
|| "<!-- WBB{'pageHead'} not defined -->";

$x = time;
printTrap();

$homeURL     = &homeURL();
$scriptURL   = $SCRIPT;
$dbTitleLink = qq(<a href="$homeURL" $TargetParent>$dbTitle</a>);

$phi = $WBB{'pageHeadIcon'} || "<!-- WBB{'pageHeadIcon'} -->";

if ($pgTitle) {
if ( $WBB{'pageTitle'} ) {
$x = &evalSafe( $WBB{'pageTitle'} );
print $x;
}
else {
$x = "";
print <<EOM;
<!-- WBB{'pageTitle'} not defined -->
<div class="DBTITLE">
$phi $apTitle $dbTitleLink
</div>
<div class="TITLE">
<h1>$pgTitle</h1>
</div>
EOM
}

print &evalMaybe( $WBB{"head;$Page"} )
|| "<!-- WBB{head;$Page} would be here -->\n";

}

print '<div class="CORE">';

}

# --- returns default style

sub defaultStyle {

local ( $bgcPage, $ink, $above, $border, $font, $lines, $error, $warning );

# --- key parameters ---

$fontsize = '10pt';
$font     = 'Arial,Helvetica,sans-serif';

$bodycolor      = 'black';
$bodybackground = 'white';

$headfootbackground = '#8DF';
$headfootcolor      = '#004';
$headfootborder     = "1px solid black";

$abovebackground = '#EEE';
$abovecolor      = $bodycolor;
$aboveborder     = "1px solid grey";

$buttonbackground = '#DDD';
$buttoncolor      = '#440';
$buttonborder     = "1px outset $buttonbackground";

$linkcolor       = 'blue';
$focusbackground = $headfootbackground;

$modifycss = $WBB{'styleModify'} || '/* WBB{styleModify} not defined */';

return <<EOM;
<!-- because WBB{'style'} not defined default sheet is used -->
<style type="text/css">
<!-- 
/* '*' selector dangerous e.g. A on black background ... */
/* note that uppercase is used for all tags and classes !!! */


BODY,LI,P,DD,TD,TH {
color: $bodycolor;
font-size: $fontsize;
font-family: $font;
}

BODY {
background-color: $bodybackground;
margin:5px;
padding:5px;
}

TT,PRE,CODE,SAMP {
color: $bodycolor;
font-size:$fontsize;
font-family:monospace;
}

H1,H2,H3,H4,H5 { font-weight: bold }

H1 { font-size: 20pt; }
H2 { font-size: 16pt; }
H3 { font-size: 14pt; }
H4 { font-size: 12pt; }
H5 { font-size: 10pt; }

/* default anchors */

A, A:active {color: $linkcolor;}
A {xx-text-decoration: none}

/* focus */

A:hover, INPUT:focus, TEXTAREA:focus, SELECT:focus {
background-color: $focusbackground;
}

A>IMG.ICON {
-moz-opacity: 0.6;
filter:alpha(opacity=60);
border: 1px outset $buttonbackground;
background-color:$buttonbackground;
}

A>IMG.ICON:hover {
border: 1px inset $buttonbackground;
filter:alpha(opacity=100);
-moz-opacity: 1;
}

/* elements at top and end of page */

.DBTITLE, .TITLE, .MINITITLE, .TOOLBAR { 
color: $headfootcolor;
border: $headfootborder;
background-color: $headfootbackground;
width: 100%;
}

.TOOLBAR { 
/* position:fixed; */
/* bottom:0; left:0; */ 
}


.MENU {
border: $aboveborder;
background-color: $abovebackground;
padding: 5px;
margin: 0px;
padding-bottom:2px;

}

DIV.DBTITLE A {
text-decoration: none;
color: $headfootcolor;
}

.TITLE {
font-size: 20pt;
margin-bottom: 10px;
margin-top: 1px;
}

DIV.TITLE H1 {
margin: 2px;
}

.MINITITLE {
font-size: 14pt;
}

.CORE {
/* in this div is the rest of the page */
margin-top: 10px;
margin-bottom: 10px;
}

.SEARCHTITLES {
/* stuff on search results pages before results */
}

.SEARCHREFORMAT {
/* links to reformat search results */
display: none;
}

/* some small stuff */

.HIDDEN { display: none; }
.NOBORDER { border: 0px none white !important; }
.ERROR	{ color: red; }
.WARN	 { color: orange; }
.FOUND	 { background-color: $focusbackground; }
.HINT   { font-size: 8pt; color: #666; }
.SMALL	{ font-size: 8pt; }

/* menu */

DIV.MENU BR {
display: none;
}

DIV.MENU A {
display:block;
}

DIV.MENU A, .BUTTON {
border: $buttonborder;
color: $buttoncolor;
background-color: $buttonbackground;
text-align: left;
text-decoration: none;
padding: 1px;
margin-top: 1px;
margin-bottom: 1px;
}

DIV.MENU A:hover, .BUTTON:hover, A.BUTTON:hover {
border: 1px inset $buttonbackground; 
background-color: $buttonbackground;
text-decoration: none;
}

DIV.MENU A:active, .BUTTON:active, A.BUTTON:active {
border: 1px inset $abovebackground; 
background-color:$abovebackground;
text-decoration: none;
}

.MENUT {
display:block;
border: 0px solid $abovebackground;	/* same size as anchor */
text-align: left;
vertical-align: top;
padding-top: 2px;
margin-top: 0px;
}

/* form elements */

INPUT, TEXTAREA, SELECT {
border: 1px inset $abovebackground;
}

/* forms */

.BOX, .SEARCHBOX, .FORM, DIV.RECORDS TABLE {
background-color: $abovebackground;
border: $aboveborder;
vertical-align: middle;
padding:4px;
}

FORM.FORM TD, FORM.FORM TH,
DIV.RECORDS TD, DIV.RECORDS TH {	
border-bottom: dotted 1px $bodycolor;
padding:4px;
}

TABLE.BOX { /* cells need padding, TABLE not */
padding:0px;
}

/* boxes are similar */

.BOX, .ERRBOX, .WARNBOX {
margin-left:20%;
margin-right:20%;
width: 60%;
text-align: center;
}

.ERRBOX {
background-color: red;
border: outset 1px red;
color: black;
}

.WARNBOX {
background-color: orange;
border: outset 1px orange;
color: black;
}

/* tables for records */

.DATATABLE {
xx-background-color: $buttonbackground;
}

.DATAH  { 
background-color: $abovebackground;
color: $abovecolor;
}

.DATA	 { background-color: $bodybackground }
.DATA1	 { background-color: #DDD }
.DATA0	  { background-color: #EEE }

/* end of WODA default */

$modifycss	

-->
</style>
EOM
}

sub formatLoginBox {

local ($al) = @_;

local ( $a, $t, $c, $w );

return '' unless $WBB{'userTable'};
return '' if $User !~ m/^_anon/;
return '' if $Group eq 'admin';
return '' if $Group eq 'friend';

if ( $User =~ m/^_anon/ ) {

$a = $WBB{'userTable'};
$url = &wbTables( 'URL', $a );

$Referer =~ m/referer\=/;
$r = $';
$r = &htUnescape($r);

$x1 = 'Username';    #UK
$x2 = 'Password';    #UK
$x3 = 'Login';       #UK
$x4 = 'New user';    #UK

return <<EOM;
<form action="$SCRIPT/Login" method="post">
<table class="BOX" cellspacing="0" border="0" $al>
<tr><td align="right">$x1:</td><td><input name="groupname" size="8"></td></tr>
<tr><td align="right">$x2:</td><td><input name="password" size="8" type="password"></td></tr>
<tr><td COLSPAN=2><input type="hidden" name="referer" value="$r">
<input class="BUTTON" type="submit" value="$x3" name="login">
<input class="BUTTON" type="submit" value="$x4" name="new">
</td></tr>
</table>
</form>
EOM
}
else {

return '';
}
}


sub htUnescape {

$_[0] =~ s/\+/ /g;
$_[0] =~ s/%([\da-f]{1,2})/pack(C,hex($1))/eig;
return $_[0];
}


sub htUntag {

local ($_) = @_;

s/<[^>]*//g;
s/>//g;

return $_;

}


sub forwardTo {
printLocation("$SCRIPTBASE$SCRIPT/$_[0]");
}


sub printLocation {

local ( $location, $cookie ) = @_;

print $cookie;
print "Location: $location\n\n";
wodaExit();
}


sub PUTN {

local ( $othertable, $search, $then ) = @_;

$data = &QRY( '', $search, $then, '', 'CSV' );
$url = &wbTables( $othertable, 'URL' );
$url = "$url/XputMany";
( $status, $headers, $page ) = &httpPost( $url, $data, 'text/csv' );
}


sub httpPost {

httpAny( 'POST', @_ );

}


sub httpAny {

local ( $method, $url, $payload, $payloadType ) = @_;
local ( $host, $dir, $them, $port );



$url =~ m|http://(.*)|;
$url = $1;
( $host, $dir ) = split( /\//, $url, 2 );
$dir = "/$dir";
( $them, $port ) = split( /:/, $host, 2 );
$port = 80 unless $port;

$cl = length($payload);
$payloadType = $payloadType || 'text/plain';
logTime("HTTP $method $cl bytes with http://$host:$port$dir");


wbOpenS( $them, $port );

print S <<EOM;
$method $dir HTTP/1.0
Host:$host
User-agent: WODA $VERSION
Woda-end-user: $RA
Content-type: $payloadType
Content-length: $cl

EOM
print S $payload;

@page = <S>;
close(S);

$header = '';
$page   = '';
while (@page) {
$line = shift(@page);
if ( $line eq "\n" || $line eq "\r\n" ) {
$page = join( '', @page );
@page = ();
}
else {
$header .= $line;
}
}

$header =~ m/\s(\d+)/;
$status = $1;
$page = '' unless $status eq '200';


$page = '' if $header =~ m/\nWoda-error:/;
$page =~ s/\r//g;    # get rid of carriage returns
$Log .= $header if $page eq '';
logTime("HTTP-DONE - status $status");
return ( $status, $header, $page );
}


sub wbOpenS {

local ( $them, $port ) = @_;

return "Host not defined" if $them eq '';

local ( $sockaddr, $aliases, $proto, $type, $len, $thisaddr, $thataddr, $x );

$sockaddr = 'S n a4 x8';
( $name, $aliases, $proto ) = getprotobyname('tcp');
( $name, $aliases, $type, $len, $thisaddr ) = gethostbyname('localhost');
( $name, $aliases, $type, $len, $thisaddr ) = gethostbyname($name);


( $name, $aliases, $type, $len, $thataddr ) = gethostbyname($them);

$this = pack( $sockaddr, $AF_INET, 0,     $thisaddr );
$that = pack( $sockaddr, $AF_INET, $port, $thataddr );

socket( S, $AF_INET, $SOCK_STREAM, $proto ) || return "socket failed";
bind( S, $this ) || return "bind failed";
connect( S, $that ) || return "connect to $name failed";
binmode(S);

$x = select(S);
$| = 1;
select($x);

return '';
}


sub QRY {
local ( $table, $search, $then, $sort, $format, $first, $max, $flds ) = @_;
local ( $ddir, $cgiPrg, $queryString, $dir, $prog, @x );

$ddir = &wbTables( 'DIR', $table );
$url  = &wbTables( 'URL', $table );

if ( $url eq '' ) {
$Log .= "ERROR: QRY in $table - url unknown\n";
return '';    # error
}

$cache = 0;
$cache = 1 if $search ne '';
$cache = 1 if $then ne '';
$cache = 0 if $ddir eq '';     # table on remote server!

$cache = 0 unless $WBB{searchCache};    # jan.2006

$_ = &htEscape($search);
$queryString .= "search=$_&" if $_;

$_ = &htEscape($then);
$queryString .= "then=$_&" if $_;

$_ = &htEscape($sort);
$queryString .= "sort=$_&" if $_;

$_ = &htEscape($format);
$queryString .= "format=$_&" if $_;

$_ = &htEscape($first);
$queryString .= "first=$_&" if $_;

$_ = &htEscape($max);
$queryString .= "max=$_&" if $_;

$_ = &htEscape($flds);
$queryString .= "fields=$_&";

chop($queryString);    # remove the trailing &


if ($cache) {
wbCheckDir("$DATADIR/_qry");
wbQryClean();
$cacheFile = "$DATADIR/_qry/$table-$Group-$queryString.txt";
}
else {
$cacheFile = '';
}


if ( &wbExpired( $cacheFile, $ddir ) ) {
$url = "$url/Xsearch?$queryString";
( $ok, $headers, $reply ) = &httpGet($url);
if ( $cache && length($reply) < 100000 ) {

chdir($DATADIR);
open( qry, ">$cacheFile" );
binmode(qry);
print qry $reply;
close(qry);

unlink $cacheFile unless $reply;
}

}
else {
$Log .= "Using cached search";
open( qry, $cacheFile );
@x = <qry>;
close(qry);
$reply = join( '', @x );
}

logTime("Done QRY");

return $reply;
}


sub wbQryClean {

local ( $dir, $old, $f, $file );

$dir = "$DATADIR/_qry";
$old = $WBB{'searchCacheAge'} || 720;    # 30 days

wbDirClean( $dir, $old, <<EOM);
Files here are results of searches.
You should delete them if you are testing
new scripts etc. Files older than $old hours
are deleted automatically.
EOM

}


sub wbDirClean {

local ( $dir, $old, $readme ) = @_;

local @x = stat("$dir/_readme");
return if ( time - $x[9] ) < 3600 * 24;    # tries every 24 hrs


open( h, ">$dir/_readme" );
print h $readme;
close(h);

opendir( D, $dir );
local @files = readdir(D);
closedir(D);

foreach $f (@files) {
$file = "$dir/$f";
next if -d $file;
@x = stat($file);
if ( time - $x[9] > $old * 3600 ) {
unlink $file;
}
}
}


sub httpGet {

httpAny( 'GET', $_[0] );
}


sub wbExpired {

local ( $file, $dataDir, $exp ) = @_;
local ( $now, @x, @y, @z );

return 1 if $file eq '';

$exp     = $WBB{'cacheExpire'} if $exp     eq '';
$exp     = 0                   if $exp     eq '';
$dataDir = $DATADIR            if $dataDir eq '';

return 1 if !-e $file;    # expired if it does not exist


@x = stat($file);         # _cache file
@y = stat($dataDir);      # _fat file

if ( ( $y[9] - $x[9] ) > $exp * 3600 || !$UNIX ) {
opendir( D, $dataDir );
@z = readdir(D);
closedir(D);
}

if ( grep( /[^_]\.rec$/, @z ) ) {
appendRecFiles($dataDir);
}

if ( !-e "$dataDir/_data/fat.txt" ) {
&evalSafe( $WBB{'onExpire'} );
return 1;
}


if ( $WBB{'onExpire'} ne '' && time - $x[9] > $exp * 3600 ) {
&evalSafe( $WBB{'onExpire'} );
return $x[9];
}


@y = stat("$dataDir/_data/fat.txt");


if ( ( $y[9] - $x[9] ) > $exp * 3600 ) {
&evalSafe( $WBB{'onExpire'} );
return $x[9];
}
else {
return 0;
}
}


sub appendRecFiles {

local ($dataDir) = @_;
$dataDir = $dataDir || $DATADIR;

chdir($dataDir);
wbCheckDir('_rec');

if ( !-d "_data" ) {
wbFail("_data directory does not exist in $dataDir");
}

@files = &glob("*");
foreach $file (@files) {
next if -d $file;
if ( $file =~ m|([^/]*)\.rec$| ) {
$id = $1;
recReadFile($file);
$rec{'_id'} = $id;
recWrite($dataDir);
wbMoveFile( $file, "$dataDir/_rec/$file" );
$rec++;
}
elsif ( $file =~ m/\.bak$/ || $file =~ m/^\./ ) {

}
else {
$att++;
wbMoveFile( $file, "$dataDir/att/$file" );
}
}
chdir($DATADIR);
return $rec;
}


sub wbMoveFile {
local ( $from, $to ) = @_;

return unless -e $from;
return if $to eq '';

rename( $from, $to ) || wbFail("Could not rename $from to $to");
}



sub recReadFile {
local ($inFile) = @_;
local (@rows);

open( h, "$inFile" ) || return "Cannot open $inFile";
@rows = <h>;
close(h);
recFromVector( join( '', @rows ) );
}


sub recFromVector {

local (@x);
undef %rec;


$_[0] =~ s/\x0D//g;    # get rid of any CRs

if ( $_[0] !~ m/^\%/ ) {



@x = split( /\n/, $_[0] );
shift(@x) while $x[0] eq '';    # remove all blank rows up front

foreach $x (@x) {
$x =~ tr/\034/\012/;        # escaped newlines replaced in-place
}

unless ( $#x % 2 ) {            # not a pair
pop(@x);
}

%rec = @x;

}
else {


@x = split( /\n\%/, $_[0] );
foreach $_ (@x) {
next if m/^\%/;    # comment %%
( $tag, $value ) = split( /\:/, $_, 2 );
$value =~ s/\n\s+/\n/g;    # delete space after newline
$value =~ s/^\s*//;        # delete leading space
$value =~ s/\s*$//;        # delete trailing space
$rec{$tag} = $value;
}
}
}


sub recWrite {

local ($table) = @_;
local ($dir)   = &wbTables( 'DIR', $table );
local ($id)    = $rec{'_id'};
local ( $vector, $start, $len );

if ( $id eq '' ) {
wbFail( "Error: Blank record ID", "It should not be blank!!!" );
}

open( h, ">>$dir/_data/records.txt" );
flock( h, 2 );
binmode(h);
seek( h, 0, 2 );
$start  = tell(h);
$vector = &recToVector();
$len    = length($vector);
$t      = time;
print h "$len\t$t\n";
print h $vector;
close(h);

wbCheckIdPos( $id, $start );

open( h, ">>$dir/_data/fat.txt" );
flock( h, 2 );
binmode(h);
print h "$id\t$start\n";
close(h);
}


sub recToVector {

local ( $out, $x, $v );

foreach $x ( sort( keys(%rec) ) ) {
next if $x eq '';    # skip values with blank keys!
$v = $rec{$x};
$v =~ tr/\012/\034/;
$out .= "$x\n$v\n";
}

return $out;
}


sub wbCheckIdPos {

local ( $id, $pos ) = @_;

if ( $id =~ m/\t|\n/ ) {
wbFail("ID contains newlines or tabs\n");
}

if ( $pos !~ m/^[0-9-]+$/ ) {
wbFail("Position is not a number\n");
}

}


sub glob {

$_ = $_[0];
s/\./\\\./g;
s/\*/\.\*/g;

return &wbDir( $_, $_[1] );
}


sub wbDir {

local ( $patt, $then ) = @_;
local ( @x, @y, @xx, $ddir );

if ( $patt =~ m|/| ) {
$patt =~ m|(.+)/([^/]+)$|;
$dir  = $1;
$patt = $2;
}
else {
$dir = '.';
}

opendir( D, $dir );
@x = readdir(D);
closedir(D);
@y = grep ( /$patt/, @x );

if ( $then > 0 ) {
undef @x;
foreach $_ (@y) {
@xx = stat("$dir/$_");
next if $xx[9] < $then;
push( @x, $_ );
}
return @x;
}
else {
return @y;
}
}


sub htEscape {
local ($x) = @_;
$x =~ s/(\W)/&htToHex(ord($1))/ge;
return $x;
}


sub htToHex {
local ($_) = @_;
return '%' . ( 0 .. 9, 'a' .. 'f' )[ $_ / 16 ] . ( 0 .. 9, 'a' .. 'f' )[ $_ & 15 ];
}


sub wbWhoami {

local ( $WodaPackage, $filename, $line ) = caller;
local ( $i, $c, $p, $v, $x );

$filename =~ m|[^/]*$|;
$WodaFile    = $&;    # what is the name of this script
$WodaFileDir = $`;    # in which dir is this script
chop($WodaFileDir);   # remove the trailing /
$x = $WodaFile;       # same as the file
$x =~ s/woda/include/;    # replace woda with include
$x =~ s/\.pl//;           # replace .pl with nothing
$WodaLibDir = "$WodaFileDir/$x";

$SCRIPTFILE = $0;         # command being executed
$SCRIPTFILE =~ tr/\\/\//;        # use forward slashes
$SCRIPTFILE =~ s/^[a-z]\://i;    # remove c: d: or similar
$SCRIPTFILE =~ m|/[^/]*$|;       # match directory
$SCRIPTDIR = $`;

if ( $WodaFileDir !~ m|^/| ) {    # not absolute
$WodaFileDir = $SCRIPTDIR . '/' . $WodaFileDir;
}

$WodaFileDir =~ s|/[^/]+/\.\.||g;    # remove /something/..

$PERL = $PERL || $^X;                # first argument from command line
if ( $PERL !~ /perl/i || $PERL eq 'perl' || $SCRIPTFILE =~ m/\Q$PERL/ ) {    # looks like $^X reported wrong
$PERL = '/usr/local/bin/perl';
$PERL = '/usr/bin/perl' unless -e $PERL;
$PERL = '' unless -e $PERL;
}
$PERLV      = $] + 0.0;                                                      # what Perl are we running for perl >= 5.6
$PERLV      = $^V if $PERLV >= 5;                                            # old format, before Perl 5.6
$TESTCGIDIR = $SCRIPTDIR . "/test";
}


sub mainPathInfo {


$RH = $ENV{'REMOTE_HOST'};
$RA = $ENV{'REMOTE_ADDR'};


$SN = $ENV{'HTTP_HOST'} || $ENV{'SERVER_NAME'};


$ENV{'SERVER_PROTOCOL'} =~ m|/|;
$p = $` || $ENV{'SERVER_PROTOCOL'};
$p =~ tr/[A-Z]/[a-z]/;
$p = 'https'
if ( $ENV{'HTTPS'} || $ENV{'HTTP_NR_SSL'} && $p eq 'http' );    ## HTTPS ## mf
$SCRIPTBASE = $p . '://' . $SN . ':' . $ENV{'SERVER_PORT'};
$SCRIPTBASE =~ s/\n|\r//g;
$SCRIPTBASE =~ s/:80$//;                                          # remove :80 !


if ( $ENV{'QUERY_STRING'} =~ m/\?/ ) {


$pi = $`;
$qs = $';

$SCRIPTNAME = $ENV{'SCRIPT_NAME'};
$SCRIPTNAME = "/$SCRIPTNAME" unless $SCRIPTNAME =~ m|^/|;

}
elsif ( $ENV{'SERVER_SOFTWARE'} =~ /Microsoft/ ) {


$pi = $ENV{'QUERY_STRING'};
$qs = '';

$SCRIPTNAME = $ENV{'SCRIPT_NAME'};
$SCRIPTNAME = "/$SCRIPTNAME" unless $SCRIPTNAME =~ m|^/|;

}
elsif ( $ENV{'SCRIPT_NAME'} =~ m|^/[A-Z]| ) {

}
else {


$pi = $ENV{'PATH_INFO'};
$qs = $ENV{'QUERY_STRING'};


if ( $qs =~ m|^/| ) {
$pi = $qs;
$qs = '';
}

$SCRIPTNAME = $ENV{'SCRIPT_NAME'};
$SCRIPTNAME = "/$SCRIPTNAME" unless $SCRIPTNAME =~ m|^/|;
}


$SCRIPT = $SCRIPTNAME;


$SCRIPT .= '?' if $ENV{'SERVER_SOFTWARE'} =~ /Microsoft/i;


@x = split( /\//, $pi );

shift(@x);    # first is blank, started with / !


$COOKIESCOPE = $SCRIPTNAME;
$DATADICT    = $SCRIPTFILE;
$DDTYPE      = $DDTYPE || 'CGI';


if ( $x[0] =~ /\=/ ) {
$p = $1 if $x[0] =~ m/P=([^\&]*)/;
$u = $1 if $x[0] =~ m/U=([^\&]*)/;
$SCRIPT = "$SCRIPT/U=$u&amp;P=$p";    # encode the ampersand #mf
$URL_login = "$u:$p" if $u;
shift(@x);
}


$Page = $x[0];


if ( $Page =~ m/ToFrame(.)$/ ) {
;
$TargetDefault = 'target="_parent"';
$TargetSelf    = 'target="_self"';
$InFrame       = $1;
$Page          = $`;
}


$SCRIPTURL = "$SCRIPTBASE$SCRIPT/$Page";
$SCRIPTURL .= '?' . $ENV{'QUERY_STRING'} if $ENV{'QUERY_STRING'};

if ( $ENV{'REQUEST_METHOD'} eq 'GET' ) {
$Referer = "referer=" . &htEscape($SCRIPTURL);
}
else {
$Referer = '';
}
}


sub PUT {

local ($table) = @_;

if ( &wbTables( 'DIR', $table ) ) {

$Log .= "PUT into local $table\n";
recWrite($table);

}
elsif ( $url = &wbTables( 'URL', $table ) ) {

$Log .= "PUT into remote $table\n";

local ($x);
$x = '';
foreach $field ( keys(%rec) ) {
$x .= $field . '=' . &htEscape( $rec{$field} ) . '&';
}

chop($x) if $x;    # delete last &

( $status, $headers, $page ) = &httpPost( "$url/Xput", $x );
if ( $status ne '200' ) {
wbFail( "http POST returned $status", $headers );
}

}
else {

wbFail( "$table not known", "Table $table is neither local nor defined in WBB{'tables'}" );

}

return 1;
}


sub NOOP {
}


sub htParseMulti {

local ( $boundary, @pairs, $position );
local ( $raw_data, $value, $name, $part, $type );


undef %CGI;
$raw_data = &htGetData();    # QUERYSTRING if Get or STDIN if Post

if ( $ENV{'CONTENT_TYPE'} =~ m|text/xml| ) {
$CGI{'xml'} = $raw_data;
return;
}

if ( $ENV{'CONTENT_TYPE'} =~ m|text/csv| ) {
$CGI{'csv'} = $raw_data;
return;
}

if ( $ENV{'CONTENT_TYPE'} =~ m|multipart/form-data| ) {


}
else {

&htParseSimple($raw_data);
return;
}






( $boundary = $ENV{CONTENT_TYPE} ) =~ s/^.*boundary=(.*)$/$1/m;    # get the boundary value, seek in multilines
@pairs = split( /--$boundary/m, $raw_data );                       # boundaries begins with --, seek in multilines
@pairs = splice( @pairs, 1, $#pairs );


foreach $part (@pairs) {

if ( $part =~ m/\x0D\x0A$/m ) {
$CRLF = "\x0D\x0A";
}
else {
$CRLF = "\x0A";
}
( $head, $content ) = split( /$CRLF$CRLF/m, $part, 2 );
chop $content;
chop $content if length($CRLF) == 2;

$head =~ s/\r//gm;
$head =~ s/\n/;/gm;    # replace new lines with ";"
(@headers) = split( /\s*;\s*/m, $head );    # do we still need multiline (/m) here and bottom ?
undef %hdr;
foreach $item (@headers) {
next if ( $item eq '' || $item eq '--' );
( $name, $value ) = split( /=|:/m, $item, 2 );
$value =~ m/\s*"*([^"]*)/m;
$value = $1;
$hdr{$name} = $value;

}



$name = $hdr{'name'};
next if $name eq '';

if ( defined $CGI{$name} ) {
$CGI{$name} = $CGI{$name} . "\x0A" . $content;
}
else {
$CGI{$name} = $content;
}

if ( $hdr{filename} ) {
$hdr{filename} =~ m/([^\.]*)$/m;
if ($`) {
$EXT{$name} = $1 if $`;
$EXT{$name} =~ tr/[A-Z]/[a-z]/;
}
else {
$EXT{$name} = '';
}
$C_TYPE{$name} = $hdr{"Content-Type"};
}


}

}


sub htParseSimple {
local ($raw_data) = $_[0];
local ( @items, $key, $value );


unless ( $raw_data =~ m/\=/m ) {    # multiline matching
$_ = $raw_data;
$_ =~ tr/+/ /;
$_ =~ s/%(..)/pack("C", hex($1))/egm;    # multiline matching
$CGI{'_isindex'} = $_;
return;
}

@items = split( '&', $raw_data );


for (@items) {

$_ =~ tr/+/ /;

if (m/\=/m) {    # multiline matching
( $key, $value ) = split( '=', $_, 2 );
}
else {
( $key, $value ) = ( '_isindex', $_ );
}

$key   =~ s/%(..)/pack("C", hex($1))/eg;    # multiline matching
$value =~ s/%(..)/pack("C", hex($1))/eg;    # multiline matching
if ( defined $CGI{$key} ) {
$CGI{$key} = $CGI{$key} . "\x0A" . $value;
}
else {
$CGI{$key} = $value;
}

}

}


sub htGetData {
local ( $buffer, $toread, $read );

if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
$toread = $ENV{'CONTENT_LENGTH'};
$Log .= "post method - $toread bytes!\n";

binmode(STDIN);
$read = read( STDIN, $buffer, $toread, 0 );

if ( $read != $toread ) {
wbFail("Read $read bytes from STDIN, should read $toread\n");
}

return $buffer;

}
elsif ( $ENV{'REQUEST_METHOD'} eq "GET" ) {
return $ENV{'QUERY_STRING'};

}
else {
return 0;

}
}


sub PIC {

local ($dFields) = @_;

local ( $field, @f );
undef %pic;

if ($dFields) {
@f = split( /,/, $dFields );
}
else {
wbSortFields();
@f = @Fields;
}

foreach $field (@f) {
if ( $Hidden{$field} ) {
$pic{$field} = '[hidden]';    #UK
}
else {
$pic{$field} = &formatField($field);
}
}
}


sub wbSortFields {

return if defined @PFields;

unless ( $WBF{'_at'} ) {
$WBF{'_from'} = '';
$WBF{ '_at', 'head' }    = 'last changed';      #UK
$WBF{ '_at', 'picture' } = '&formatDate($_)';
}

unless ( $WBF{'_from'} ) {
$WBF{'_from'} = '';
$WBF{ '_from', 'head' } = 'changed from';       #UK
$WBF{ '_from', 'sees' } = 'admin';
}

undef %Hidden;
undef %IsField;
undef @Fields;
undef @IFields;
undef @PFields;

local ( $x, $y, $f );

foreach $x ( keys(%WBF) ) {

next if $x =~ m/$;/;

if ( $WBF{ $x, 'type' } eq 'EMAIL' ) {
$HasEmailField = 1;
}

if ( $y = $WBF{ $x, 'sees' } ) {
unless ( $Group =~ m/$y/ || $Group eq 'admin' || $RGroup =~ m/$y/ ) {
$Hidden{$x} = 1;

}
}

push( @Fields, $x )
unless $x =~ m/^_/;    # do not add underscore named fields (hidden will be set!)
$IsField{$x} = 1;
}

@Fields = sort { $WBF{ $b, 'srt' } <=> $WBF{ $a, 'srt' } } @Fields;
@PFields = ( '_id', @Fields, '_from', '_at' );

foreach $f (@Fields) {
push( @IFields, $f )
unless $WBF{ $f, 'type' } =~ m/BREAK|COMPUTE|SUBMIT/;
}
@IFields = ( '_id', @IFields, '_password', '_from', '_at' );

return;
}


sub formatDate {

local ($time) = @_;
local ( @x, $i );

@x = &fixDate($time);
return "$x[5]/$x[4]/$x[3] $x[2]:$x[1]";
}


sub formatField {

local ($field) = @_;
my $x;
local $_;


$_  = $rec{$field};
$ID = $rec{'_id'};

if ( $WBF{ $field, 'type' } eq 'BREAK' ) {
return '';
}

if ( $WBF{ $field, 'type' } eq 'SUBMIT' ) {
return '';
}

if ( $WBF{ $field, 'type' } eq 'COMPUTE' ) {
$y = $WBF{ $field, 'picture' };
$x = &evalSafe($y);

return "$x";
}

return '' if $_ eq '';


$pict = $WBF{ $field, 'picture' };
$pict = '' if $pict eq "\n";    # in forms this may be generated by itself

if ( $_ =~ m/\n/ && $WBF{ $field, 'type' } =~ m/OPTION$|^LIST$/ ) {
if ($pict) {
local ($ret) = '';
local ($_)   = $_;
$_ =~ s/\r//g;          #scix
local (@items) = split( /\n/, $_ );
foreach $_ (@items) {
$ret .= &evalSafe($pict);    # 30.12.2001 dodal ta BR
}
return $ret;
}
else {

$_ =~ s/\n/, /g unless m/<br>/i;    # if we do our own linespacing ...
return $_;
}
}


if ($pict) {

return &evalSafe($pict);                # || "<em class="ERROR">$@</em>";

}
elsif ( $WBF{ $field, 'type' } eq "TEXTAREA" ) {

if ( $_ =~ m/<p|<br/ ) {
return $_;
}
else {
local ( @rows, $max, $row );
@rows = split( /\n/, $_ );
$max = 0;
foreach $row (@rows) {
if ( length($row) > $max ) {
$max = length($row);
}
}
if ( $max > 60 ) {
$_ =~ s/\n/<br>\n/g;
return "<tt>$_</tt>";
}
else {
return "<pre>$_</pre>";
}
}

}
elsif ( $WBF{ $field, 'type' } eq "HTMLAREA" ) {

if ( $_ =~ m/<p|<br|<b|<I/i ) {

}
else {
s/\n\n/<p>/g;
}

return $_;

}
elsif ( $WBF{ $field, 'type' } eq "FILE" ) {

return "<a href=\"$WBB{'htmlURL'}/att/$rec{$field}\">$rec{$field}</a>";

}
elsif ( $WBF{ $field, 'type' } eq "IMAGE" ) {

return "<img alt=\"\" src=\"$WBB{'htmlURL'}/att/$rec{$field}\">";

}
elsif ( $WBF{ $field, 'type' } eq "USERFILE" ) {

$unit = 'bytes';                             #UK
@x    = stat("$HTMLDIR/att/$rec{$field}");
$rec{$field} =~ m/([^\.]*)$/;
$xt = $1;
if ( $xt =~ m/$FILETYPES/ ) {
$ic = "$ICONURL/$xt.gif";
}
else {
$ic = "$ICONURL/binary.gif";
}

$s = $x[7];
$s = '0' x ( 21 - length($s) ) . $s;
$s =~ s/\d{3}/$&\,/g;
chop($s);
$s =~ s/^[0,]*//;

return qq~<a href="$WBB{'htmlURL'}/att/$rec{$field}"><img alt="" $ICONPAR $xt align="top" src="$ic">file.$xt</a> ($s $unit)~;

}
elsif ( $WBF{ $field, 'type' } eq "URL" ) {

return "<a href=\"$rec{$field}\">$rec{$field}</a>";

}
elsif ( $WBF{ $field, 'type' } eq "EMAIL" ) {

return &formatMailto( $rec{$field} );

}
elsif ( $WBF{ $field, 'type' } eq "DATE" ) {

( $yyyy, $mm, $dd ) = split( /\//, $rec{$field}, 3 );
return &formatYMD( $yyyy, $mm, $dd );

}
else {

return $rec{$field};

}
}


sub formatYMD {

local ( $yyyy, $mm, $dd ) = @_;

if ( $WBB{'dateFormat'} ne '' ) {
return &evalSafe( $WBB{'dateFormat'} );
}
else {
return "$yyyy/$mm/$dd";
}
}


sub formatMailto {

local ($addr) = @_;
local ( $x, $y );
$x = &htEscape($addr);
$y = $addr;
$y =~ s/\./&#46;/g;
$y =~ s/\@/&#64;/g;
if ( $JS >= 1 ) {
return qq[<script LANGUAGE="JavaScript" type="text/javascript">document.write('<a HR'+'EF'+'="'+'mai'+'lto'+':'+'$x'+'">$y</a>');</script>];
}
else {
return qq[<a href="mailto:$x">$y</a>];
}

}



sub printDeny {

local ($n) = @_;

$title = "Access denied";    #UK
$t     = '';

if ($userAllowFailed) {

$message = <<EOM;        #UK
As <b>$User</b> you are not allowed to
use this database. Try to access it as 
'guest'.
EOM

}
else {

if ( $n == 10 ) {
$p = "<br>with parameter <b>$DeniedPar</b>";    #UK
}

if (   &wbAllowed( 'friend', $Page )
&& &wbAllowed( $Group, 'RegisterForm' ) )
{
$t = qq(<li><a href="$SCRIPT/RegisterForm">register</a> as a friend.</li>);    #UK
}


if (
1
|| ( !&wbDenied( 'user', $Page ) )
|| ( $WBB{'userTableGroup'}
&& !&wbDenied( $WBB{'userTableGroup'}, $Page ) )
)
{
$t .= qq(<li><a href="$SCRIPT/LoginForm">login</a> with your username here\n);    #UK
$t .= &formatLoginBox('');
$t .= '<br clear="all"></li>';
}

if ( !&wbDenied( 'guest', $Page ) ) {
$t .= qq(<li><a href="$SCRIPT/Login?logout=1">logout</a>.</li>);                  #UK
}

if ($t) {
$t =
'To be granted access to that page you can select one of the following options:<ol style="list-style-type: none">' . $t . '</ol>';   #UK
}
else {

}

$message .= <<EOM;                                                                                                                         #UK
<div>Users from group <b>$Group</b> are not allowed to request page <b>$Page</b> $p.
<br>$t
... or ...</div>
EOM

}

$Err = 'NA';
wbError( $title, $message );
}


sub wbLogin {

local ( $group, $pass ) = @_;
$Group = $User = '';


if ( $group eq ' ' ) {

$dGroup  = '';
$LogPass = '';
$Log .= "Logging with parameters - empty\n";

}
elsif ( $group ne '' ) {

$dGroup  = $group;
$LogPass = $pass;
$Log .= "Logging with parameters as $group\n";

}
elsif ( $URL_login ne '' ) {

( $dGroup, $LogPass ) = split( /:/, $URL_login, 2 );
$Log .= "Logging with URL as '$dGroup'\n";

}
else {

( $dGroup, $LogPass ) = split( /:/, $COOKIE{'_login'}, 2 );
$Log .= "Logging with COOKIES as '$dGroup'\n";

}


$cscope = $WBB{'userScope'} || $COOKIESCOPE;


if ( $WBB{'groups'} eq '' ) {    # use default of WODA
@passwd = ($ADMUSER);
}
else {
@passwd = split( /\n/, $WBB{'groups'} );
}


if ( !grep( /^client\s/, @passwd ) && $ENV{'HTTP_USER_AGENT'} =~ m/woda/i ) {
local ($x);
$x = $ENV{'SERVER_ADDR'};
push( @passwd, "client\t$x|127.0.0.1\t" );
}


if ( $dGroup ne '' ) {
@passwd = grep( /^$dGroup\s/, @passwd );
}


foreach $_ (@passwd) {
( $group, $patt, $passwd ) = split( /\s+/, $_, 3 );
$passwd =~ s/\s*//g;    # remove whitespace from password
$patt   =~ s/\s+//;
$patt   =~ tr/#/./;     # compatibility reasons

if ( $passwd eq $LogPass
&& ( ( $RH && $RH =~ m/$patt/ ) || $RA =~ m/$patt/ ) )
{


if ( $dGroup || $group ne 'admin' ) {
$Group = $group;
$Log .= "Logged as $Group using groups setting\n";
last;
}
}
}


if ( $Group eq '' && $dGroup ne '' && $WBB{'userTable'} ) {
$t = int( time / 1000 );    # close / for syntax highlighting


if (   $COOKIE{_group}
&& $COOKIE{_voucher}
&& &wbTestPass( "$ra$t:$dGroup", $COOKIE{_voucher} ) )
{
$Group = $COOKIE{_group};
$User  = $dGroup;
$Log .= "Logged using valid voucher\n";
return;
}


$Log .= "Reading from $WBB{'userTable'} for $dGroup\n";
%rec = &GET( $WBB{'userTable'}, $dGroup );

if (%rec) {


$Log .= "recpass='$rec{'_password'}'\n";

if ( $rec{'_password'} && &wbTestPass( $LogPass, $rec{'_password'} )
|| ( $rec{'_password'} eq '' && $LogPass eq '' ) )
{

if ( $WBB{'userAllow'} eq '' || &evalSafe( $WBB{'userAllow'} ) ) {    # setting
$User    = $dGroup;
$Group   = $rec{'group'} || $WBB{'userTableGroup'} || 'user';
$voucher = &wbCryptPasswd("$ra$t:$dGroup");
$cg      = &htFormatCookie( '_group', $Group, $cscope, 'SESSION' );
$cv      = &htFormatCookie( '_voucher', $voucher, $cscope, 'SESSION' );
&htDemandCookie( $cu, $cg, $cv );
$Log .= "Verified username and password in a database, setting voucher\n";
return;
}
else {
$Log .= "userAllow failed\n";
$userAllowFailed = 1;
}
}
else {
$Log .= "Login in userTable failed - bad password for $dGroup\n";
}
}
else {
$Log .= "Login in userTable failed - bad username $dGroup\n";
}
undef %rec;
}
else {
$Log .= "Login without userTable\n";
}


$Group = $Group || 'guest';    # make him at least guest

if ( $COOKIE{_user} =~ m/^_/ ) {
$User = $COOKIE{_user};
}
else {
$User = '_anon_' . int( rand(1000000) );
}

htDemandCookie( &htFormatCookie( '_user', "$User", $cscope ) )
unless $COOKIE{_user} eq $User;


if (   $Group eq 'guest'
&& $COOKIE{_user}  =~ m/^_\d+$/
&& $COOKIE{_email} =~ m/.\@./ )
{
$Log .= "Promoting to friend\n";
$Group = 'friend';
}
}


sub wbCryptPasswd {

local ($what) = @_;
local ($salt);

unless ($NO_CRYPT) {

$salt = '$1$wb' . substr( $what, 0, 2 );
return crypt( $what, $salt );
}
else {

$what =~ s/(.)/substr(log(ord($1)),2,5)/eg;
$what =~ s/\.//g;
return $what;
}
}


sub htFormatCookie {

local ( $name, $value, $path, $time ) = @_;

if ( $path ne '' ) {

$path = "path=$path;";
}

$path =~ s|:80/|/|;

if ( $time eq '' ) {
$time = 'expires=Wed, 1-Jan-2020 23:59:59 GMT';
}
elsif ( $time eq "RESET" ) {    # in the past
$time = 'expires=Sun, 30-Nov-1997 23:59:59 GMT';
}
elsif ( $time eq "SESSION" ) {    # after session
$time = '';
}

return '' if $name  eq '';
return '' if $value eq '';

$value = &htEscape($value);
return "Set-Cookie: $name=$value; $path $time\n";
}


sub wbTestPass {

local ( $new, $old ) = @_;
local ($x);


$x = -1;

if ( $old =~ m/^u:/ ) {
$x = $' eq $User;
}
elsif ( $old =~ m/^g:/ ) {
$x = $' eq $Group;
}
elsif ( $old =~ m/^h:/ ) {
$x = $' eq $RH;
}

if ( $x > 0 ) {
return $old;
}

if ( $Group eq 'admin' ) {
$Log .= "Non password authentification OK, because you are admin\n";
$ADMINPASS = 1;
return 1;
}
elsif ( $Group ne '' && $Group eq $WBB{'ownerGroup'} ) {
$Log .= "Non password authentification OK, because you are from group $WBB{'ownerGroup'}\n";
$ADMINPASS = 1;
return 1;
}


$x = &wbCryptPasswd($new);

$Log .= "newpass='$x'\noldpass='$old'\n";

if ( $old eq '' && $new eq '' || $x eq $old ) {
return 1;
}
else {
if ( $Group eq 'admin' ) {
$Log .= "Password is OK, because you are admin\n";
$ADMINPASS = 1;
return 1;
}
else {
return 0;
}
}
}



sub htDemandCookie {

$DemandedCookies .= join( '', @_ );
}


sub GET {
local ( $table, $id ) = @_;
local ( %rec, $url );

if ( &wbTables( 'DIR', $table ) ) {

recRead( &wbFixId($id), $table );

}
elsif ( $url = &wbTables( 'URL', $table ) ) {

$id   = &wbFixId($id);
$page = &FETCH("$url/Xget?_id=$id");
@x    = split( /\n/, $page );
@x    = grep( /^[^\<]/, @x );          # trash XML headers and footers


foreach $x (@x) {
( $n, $v ) = split( /=/, $x, 2 );
$v =~ tr/\034/\012/;
$rec{$n} = $v;
}

}
else {

wbFail( "$table not known", "Table $table is neither local not defined in WBB{'tables'}" );

}

return %rec;
}


sub FETCH {

local ($url) = @_;

undef $ok;
undef $headers;
undef $page;

( $ok, $headers, $page ) = &httpGet($url);

if ( $ok ne '200' ) {

$headers =~ m/\n/;
return $`;    # first row returned!

}
else {

local ( $h, $b, $f ) = split( /\<a name="PAGEBODY".\>/m, $page );    # with multiline (/m)
return $b || $page;
}
}


sub wbFixId {
local ($id) = @_;
local ( $lcFrom, $lcTo, $asFrom, $asTo );

( $lcFrom, $lcTo ) = split( / /, $WBB{'intlLower'} );
( $asFrom, $asTo ) = split( / /, $WBB{'intlAscii'} );

if ( $lcFrom ne '' ) {
$_ = $id;
eval "tr/$lcFrom/$lcTo/";
eval "tr/$asFrom/$asTo/" if $asFrom;
$id = $_;
}
else {

}

$id =~ tr/[A-Z]/[a-z]/;
$id =~ tr| /\t\n|_|;
$id =~ tr/\\()<>,;|"${}:\.\&\?/_/;    # does not allowed in ID!
$id =~ tr/[\200-\377]/_/;

return $id;
}


sub recRead {
local ( $id, $table ) = @_;
local ( $err, $handle, $p, $meta, $l, $t );
undef %rec;

( $HData, $HFat ) = &recOpen($table);
$p = &recExists( $id, $table );
if ( $p >= 0 ) {

seek( $HData, $p, 0 ) || wbFail("Cannot seek $p in $HData.");
$meta = <$HData>;
chop($meta);
( $l, $time ) = split( /\t/, $meta );
read( $HData, $string, $l )
|| wbFail("Cannot read $l bytes at $p in $Hdata.");
recFromVector($string);
if (%rec) {
$rec{'_id'} = $id;
return '';
}
}
else {
return "No such record";
}
}


sub recExists {

local ( $id, $table ) = @_;
local ( $idd, @x );

$idd = -1;

if ( defined $IDS && $IDS eq $table ) {
$idd = $IDS{$id};
}
else {
( $HData, $HFat ) = &recOpen($table);
seek( $HFat, 0, 0 );
while (<$HFat>) {
chop;
if (m/^$id\t/) {
$idd = $';
}
else {

}
}
}

return $idd;

}


sub recOpen {

local ($table) = @_;
local ($dir);

local ( $HData, $HFat );

if ( !$Opened{$table} ) {

( $HData, $HFat ) = &recHandles($table);
$dir = &wbTables( 'DIR', $table );

open( $HFat, "$dir/_data/fat.txt" ) || return;
binmode($HFat);
open( $HData, "$dir/_data/records.txt" ) || return;
binmode($HData);

$Opened{$table} = 1;
$Log .= "Opened $dir\n";

return ( $HData, $HFat );

}
else {

return &recHandles($table);

}
}

sub mainDataDir {


$DATADIRDIR =~ s/^[a-z]\://i;


if ( $WBB{'homeURL'} && !$WBB{'htmlDir'} ) {
$WBB{'htmlURL'} = $WBB{'homeURL'};
$WBB{'htmlDir'} = $WBB{'dataDir'};
}


$WBB{'htmlDir'} = $WBB{'htmlDir'} || $WBB{'dataDir'};


$na = "/htmlURL/is/not/defined";

if ( !$WBB{'htmlURL'} || $WBB{'htmlURL'} eq $na ) {

$x = $ENV{'DOCUMENT_ROOT'};
if ( $x ne '' && $WBB{'htmlDir'} =~ m|$x|i ) {    # ignore case for mac IE5
$x = $';                                      # unmatched part
$x =~ s/\/$//;                                # remove trailing slash
$x = "/$x";                                   # prepend start slash
$x =~ s|//|/|;                                # remove double slashes
$x =~ s|^[a-z]\:||i;                          # remove c: at start

$WBB{'htmlURL'} = $x;
}
else {

$WBB{'htmlURL'} = $na;
}
}

$DATADIR = $WBB{'dataDir'};
$HTMLDIR = $WBB{'htmlDir'};


$DATADIR =~ s|\$DATADIRDIR|$DATADIRDIR|;
$HTMLDIR =~ s|\$DATADIRDIR|$DATADIRDIR|;

if ( $DATADIR eq '' ) {
$SCRIPTFILE =~ m|[^/]*$|;
$DATADIR = "$DATADIRDIR/$&";
$HTMLDIR = $DATADIR;
}


if ( $DATADIR && $DATADIR !~ m|^/| ) {
$DATADIR = "$SCRIPTDIR/$DATADIR";
}

if ( $HTMLDIR && $HTMLDIR !~ m|^/| ) {
$HTMLDIR = "$SCRIPTDIR/$HTMLDIR";
}

$TMPDIR = "$DATADIR/_tmp";
}


sub URL {

return &wbTables( 'URL', @_ );

}


sub FLD {
local ( $table, $id, $name ) = @_;
local ( $dataDir, $dataFile );
local $_;

if ( $VALid eq "$table/$id" ) {


}
else {

%VALrec = &GET( $table, $id );

}

return $VALrec{$name};
}


sub TODAY {

local ( $d, $t );

$d = &formatDate(time);
( $d, $t ) = split( / /, $d );
return $d;
}


sub LINK {

local ( $table, $id, $text ) = @_;
local ($_) = $_;
local ( $ddir, $durl );

$id   = $id   || $_;
$text = $text || $id;
$id   = &wbFixId($id);
$durl = &wbTables( 'URL', $table );

return <<EOM;
<a href="$durl/Show?$id">$text</a>
EOM
}


sub mainClean {

( $package, @x ) = caller;

local (*_stab) = eval("*_$package");                 # if $] <5;
local (*_stab) = eval("*${package}::") if $] >= 5;

while ( ( $_key, $_val ) = each(%_stab) ) {
local (*_entry) = $_val;
next unless $_key =~ m/^[A-Z]/;                  # starts with a letter
next if $_key =~ m/^ENV|^INC|^ARGV|^SIG|^WBB|^WBF|^VERSION|^STDOUT/;
next if $_key =~ m/::/;

undef %_entry if defined %_entry;
undef @_entry if defined @_entry;
undef $_entry if defined $_entry;
}

}


sub htReadCookies {

local ( $n, $v, $x, @x );

@x = split( /;/, $ENV{'HTTP_COOKIE'} );
foreach $x (@x) {

( $n, $v ) = split( /\=/, $x );

$n =~ s/\s//g;
$v =~ s/\+/ /g;
$v =~ s/%([\da-f]{1,2})/pack(C,hex($1))/eig;
$Log .= "cookie $n = $v\n";
$COOKIE{$n} = $v;

}
}


sub wbCheckDirectories {

local (@dirs) = (
"$DATADIR",      "$DATADIR/_cache", "$DATADIR/_data", "$DATADIR/_friend", "$DATADIR/_tmp", "$DATADIR/_qry",
"$DATADIR/_log", "$HTMLDIR",        "$HTMLDIR/att",   "$HTMLDIR/robots",  "$HTMLDIR/_doc"
);

foreach $dir (@dirs) {
wbCheckDir($dir);
if ( $dir eq $DATADIR || $dir eq $HTMLDIR ) {

open( h, ">$dir/$HtaccessFile" )
|| wbFail("Cannot create $dir/$HtaccessFile files");
binmode h;
print h $HtaccessDeny;
close(h);
}
if ( $dir =~ m/att$|robots$/ ) {

open( h, ">$dir/$HtaccessFile" )
|| wbFail("Cannot create $dir/$HtaccessFile files");
binmode h;
print h $HtaccessAllow;
close(h);
}
if ( $dir =~ m/att$/ ) {
open( h, ">$dir/index.htm" );
print h <<EOM;
Browsing denied!
EOM
close(h);
}
}
return @dirs;
}

sub mainDefaults {

$ROBOTIP = $ROBOTIP || '193.2.92.xx';    # for testing purposes
$ROBOTAGENT = $ROBOTAGENT
|| 'scooter|mercator|altavista|google|spider|slurp|msnbot|aipbot|crawler|bot';


$WodaHomeURL = 'http://woda.sourceforge.net';
$WodaHelpURL = "$WodaHomeURL/help.htm";


$WBB{'sort;DEFAULT'}   = $WBB{'listRow'}  unless $WBB{'sort;DEFAULT'};
$WBB{'format;DEFAULT'} = $WBB{'listHtml'} unless $WBB{'format;DEFAULT'};
$WBB{'formatNameDEFAULT'} = 'Default'
unless $WBB{'formatNameDEFAULT'} ne '';
if ( $WBB{'formatRowDEFAULT'} eq '' && $WBB{'format;DEFAULT'} ne '' ) {

$WBB{'formatHeadDEFAULT'} = "<ol>";
$WBB{'formatFootDEFAULT'} = "</ol>";
}
elsif ( $WBB{'formatRowDEFAULT'} eq '' && $WBB{'format;DEFAULT'} eq '' ) {    #MF failsafe
$WBB{'formatHeadDEFAULT'} = "<ol>";
$WBB{'formatFootDEFAULT'} = "</ol>";
}

$WBB{'maxHits'}  = 10000 unless $WBB{'maxHits'};
$WBB{'dfltHits'} = 10    unless $WBB{'dfltHits'};
$WBB{'generatedHomePage'} = "index.htm" if $WBB{'homePage'} eq '1';
$WBB{'homePage'}          = "index.htm" if $WBB{'homePage'} eq '1';
$WBB{'groups'} = $WBB{'groups'} || $WBB{'users'};
$WBB{'grepBigger'} = '300000';


$WODAURL = '/woda';


if ( $WBB{'iconURL'} ne '' ) {
$ICONURL = $WBB{'iconURL'};
}
elsif ( $WBB{'iconSet'} ne '' ) {
$ICONURL = '/woda/icons/' . $WBB{'iconSet'};
}
else {
$ICONURL = '/woda/icons/default';
}

$ICONOPEN = $WBB{'iconOpen'} || 'open';

$ICONPAR      = 'border="0" height="24" width="24" class="ICON"';
$BIGICONPAR   = 'border="0" height="48" width="48" class="ICON"';
$SMALLICONPAR = 'border="0" height="12" width="12" class="ICON"';


$p    = qq(<img alt="" src="$ICONURL/pixel.gif" width="1" height="1">);
$Pix4 = qq(<img alt="" src="$ICONURL/pixel.gif" width="4" height="1">);

$nCriteria = 5;


$POWERURL  = $POWERURL  || $WodaHomeURL;
$POWERTEXT = $POWERTEXT || "Powered by WODA $VERSION";
$POWERIMG  = $POWERIMG  || "$ICONURL/poweredby.gif";
$POWERGEN  = $POWERGEN  || "WODA $VERSION - $WodaHomeURL";
$POWERSIZE = $POWERSIZE || 'width="76" height="24"';


$WBB{'intlCharset'} = $WBB{'intlCharset'} || 'UTF-8';                #UK
$WBB{'intlCollate'} = ''                  || $WBB{'intlCollate'};    #UK
$WBB{'intlLower'}   = ''                  || $WBB{'intlLower'};      #UK
$WBB{'intlAscii'}   = ''                  || $WBB{'intlAscii'};      #UK
$WodaLanguage       = 'en'                || $WBB{'language'};       #UK
$WodaLanguageAuthor = 'Ziga Turk &lt;ziga.turk@fagg.uni-lj.si&gt;';  #UK
}


sub DECODE {

local ( $fld, $val, $short ) = @_;

if ( $#_ == -1 ) {
$fld = $field;
$val = $_;
}

if ( defined $Decode{ $fld, $val } ) {

}
else {
@os = &wbParseOptions($fld);
for ( $i = 0 ; $i <= $#os ; $i++ ) {
$o = $os[$i];
$t = $optionText[$i];
$Decode{ $fld, $o } = $t;
}
}

$d = $Decode{ $fld, $val };
if ( $d ne '' ) {
if ($short) {
return $d;
}
else {
return "$d ($val)";
}
}
else {
return $val;
}
}


sub wbParseOptions {

local ($field) = @_;
local ( @wbp, @x, $i, $o, $t, $alias, $fields, $options );
undef @optionText;

$options = $WBF{ $field, 'options' };

if ( $WBF{ $field, 'type' } eq "LINKOPTION" ) {
if ( $WBF{ $field, 'into' } =~ /^\&|^\#/ ) {
$t = &evalSafe( $WBF{ $field, 'into' } );
@wbp = split( /\n/, $t );
}
else {
@x = &recAll( $WBF{ $field, 'into' } );
return @x;
}
}
elsif ( $options =~ /^\&|^\#/ ) {
$t = &evalSafe($options);
@wbp = split( /\n/, $t );
}
elsif ( !( $options =~ /\|/ ) ) {
@wbp = split( /\n/, $options );    # /n delimited
}
else {
return split( /\|/, $options );    # | delimited
}

for ( $i = 0 ; $i <= $#wbp ; $i++ ) {
( $o, $t ) = split( /\t/, $wbp[$i], 2 );
$wbp[$i]        = $o;
$optionText[$i] = $t;
$wbp[$i] =~ s/\s+$//;
}

return @wbp;
}


sub recAll {

local ($table) = @_;

undef %IDS;
( $HData, $HFat ) = &recOpen($table);
seek( $HFat, 0, 0 );
while (<$HFat>) {
( $id, $rest ) = split( /\t/, $_, 2 );
if ( $rest == -1 ) {
delete $IDS{$id};
}
else {
$IDS{$id} = $rest;
}
}

$IDS = $table;

return wantarray ? keys(%IDS) : '';
}


sub KEY {

local ( $id, $table ) = @_;

local (%t);

if ( &wbTables( 'DIR', $table ) ) {
return &recExists( $id, $table ) >= 0;
}
else {
%t = &GET( $table, $id );
return $t{_id} ne '';
}
}


sub RELATED {

local ( $table, $flds, $search ) = @_;

$Log .= "RELATED $table,$flds,$search\n";

local ( $x, $out, $ddir, $durl );
$durl = &wbTables( 'URL', $table );

if ( $flds ne '' ) {
$flds = "_id,$flds";
}

$x = &ROWS( $table, $flds, $search );

@x = split( /\n/, $x );
$out = '';

$i = 0;
foreach $x (@x) {
$i++;
$out .= "<tr>\n";
@y = split( /\t/, $x );
$c = $#y;
if ( $flds eq '' ) {
$c = 2;
}
$y[0] = qq(<a href="$durl/Show?$y[0]">$i</a>);
$out .= '<td class="DATA1">' . join( '</td><td>', @y[ 0 .. $c ] ) . '</td></tr>';
}

if ($out) {
$out = <<EOM;    #UK
<table>$out</table>
... <a href="$durl/Search?search=$search&amp;noform=1">details</a>
EOM
}

return $out;
}


sub ROWS {
local ( $table, $flds, $search, $then, $sort, $format, $first, $max ) = @_;


$ddir = &wbTables( 'DIR', $table );
$format = $format || 'DEFAULT';
$tblfile = "$format.tbl";
$tblfile =~ tr/[A-Z]/[a-z]/;
$tblfile = "$ddir/_cache/$tblfile";
$max = 9999999999 || $max;


if ( $ddir ne '' && &wbExpired( $tblfile, $ddir ) ) {
return &QRY( $table, $search, $then, $sort, 'RAW', $first, $max, $flds );
}

if ( $ddir eq '' ) {

return &QRY( $table, $search, $then, $sort, 'RAW', $first, $max, $flds );
}


local ( %rec, %data, %hits, $allHits, $id, $sex, @list, @fields, @fieldNames, @editable, @y );

( $allHits, *list, *fields ) = &recSelect( $table, $search, $sort, 'RAW', $flds );

return ( join( "\n", @list ) ) . "\n" if @list;
return '';
}


sub recSelect {

local ( $table, $search, $sort, $format, $fields, $first, $max ) = @_;

logTime("---- recSelect in table '$table' for search '$search' with fields '$fields' started");

if ( $table eq '' ) {

}
elsif ( $sort eq 'TIME' || $sort eq 'DEFAULT' || $sort eq '' ) {

}
else {
wbFail( "Cannot select from $table", "Sort should be TIME or DEFAULT" );
}


undef @x;
undef @faWords;
undef @fnWords;
undef @fsWords;
undef $fthen;
undef $fsex;
undef $fgrepPatt;
undef $filter;

@x = split( /\n/, $WBB{'filter'} ) if $table eq '';    # only do it on self
foreach $_ (@x) {
( $group, $filter ) = split( /\s+/, $_, 2 );
if ( $group eq $Group ) {
( *aWords, *nWords, *sWords, $fthen, $fsex, $fgrepPatt ) = &wbParseSearch( $filter, $table, 'filter' );
@faWords    = @aWords;
@fnWords    = @nWords;
@fsWords    = @sWords;
$filterAnds = $#faWords + 1;                   # to determine relevance ranking
$filterNots = $#fnWords + 1;                   # obsolete after 4.200
last;
}
}


$sort = 'DEFAULT' if $sort eq '';


if ( $WBB{"sort;$sort"} || $sort eq 'TIME' || $sort eq 'DEFAULT' ) {
$dynamicSort = '';
}
else {    # comma separated list of fields
$dynamicSort = $sort;
$dynamicSort =~ tr/\n/,/;    # newline separated comes from forms!
$sort = 'DEFAULT';           # this TBL will be used
local ( @f, $f );
@f = split( /,/, $dynamicSort );
$dynamicSort = '';
foreach $f (@f) {
next unless $f =~ m/\w/;    # skip any blanks
if ( $f =~ m/^DYNAMIC/ ) {
$dynamic = $f;
next;
}
$f =~ s/\s+//g;             # remove spaces
$dynamicSort .= "\$rec{'$f'} ";    # convert to expression with $rec
}
$dynamicSort = '"' . $dynamicSort . '"';    # make a string
}


local ( $sort, $format ) = ( $sort, $format );
wbReindex($sort) unless $table;


$first = 0        if !$first;
$max   = 99999999 if !$max;                     # adminExport !
$last  = $first + $max - 1;



( *aWords, *nWords, *sWords, $then, $sex, $grepPatt ) = &wbParseSearch( $search, $table );
logTime("Search parameters parsed");



$csearch = "$table-$search-$sort";
$csearch = "_qry/" . &htEscape($csearch) . ".tbl";
$csearch =~ s/%//g;
if ( !$table && !&wbExpired($csearch) ) {
$Log .= "\tUsing cached search\n";
open( H, $csearch );
$x = <H>;
chop($x);
@fieldNames = split( /\t/, $x );
@list = <H>;
close(H);
}
else {
$Log .= "Working with table: $table\n";
if ($search) {
( *records, *fieldNames ) = &wbReadRecords( $table, $sort, $grepPatt );    # read into RAM the presorted table
logTime("Read with user's '$grepPatt': $#records+1 records in RAM");
}
else {
( *records, *fieldNames ) = &wbReadRecords( $table, $sort, $fgrepPatt );    # read into RAM the presorted table
logTime("Read with filter's '$fgrepPatt': $#records+1 records in RAM");
}

*list = &wbGrepRecords( *records, *aWords, *nWords, *sWords, $then, $sex );     # create @list, may have duplicates
logTime("Grep with user's search: $#list+1 records remain.");

if ($filter) {
$sp      = $SearchPatts;
@records = @list;
*list    = &wbGrepRecords( *records, *faWords, *fnWords, *fsWords, $fthen, $fsex );    # create @list, may have duplicates
logTime("Grep to filter: $#list+1 records remain.");
$SearchPatts = $sp;
}

if ( $WBB{searchCache} && $#list < 1000 && ( $search ne '' || $then ne '' ) ) {

wbQryClean();
$Log .= "\tSearch cached - found $#list+1\n";
open( H, ">$csearch" );
binmode(H);
print H join( "\t", @fieldNames ) . "\n";
print H @list;
close(H);
}
else {
$Log .= "\tSearch not cached - found $#list+1\n";
}
}



undef $allHits;

if ( $#sWords < 0 && $dynamicSort eq '' ) {    # 0 search words, trim now, no extra sorting will be needed

$allHits = $#list + 1;
wbTrimList( *list, $first, $last );
$trimmed = 1;
$Log .= "\tQuick trimmed to $#list+1\n";

}
else {

$i = 0;
foreach $_ (@list) {
$i++;
( $id, $rest ) = split( /\t/, $_, 2 );
$sort{$id} = $i unless $sort{$id};

$data{$id} = $_ unless $data{$id};
$hits{$id}++;
}


foreach $_ ( keys(%data) ) {
$sort{$_} += ( 100 - $hits{$_} ) * 10000;
}


if ($dynamicSort) {
logTime("Before dynamic sort with $dynamicSort");
&evalSafe($dynamicSort);    # this will fail, below we can eval
foreach $id ( keys(%data) ) {
recFromRow( $data{$id}, *fieldNames );
$sort{$id} = eval($dynamicSort);    # it is a $rec expression

}
}


if ( $dynamic eq 'DYNAMICZA' ) {
@list = sort { $sort{$b} cmp $sort{$a} } keys(%hits);
}
elsif ( $dynamic eq 'DYNAMIC09' ) {
@list = sort { $sort{$a} <=> $sort{$b} } keys(%hits);
}
elsif ( $dynamic eq 'DYNAMIC90' ) {
@list = sort { $sort{$b} <=> $sort{$a} } keys(%hits);
}
else {
@list = sort { $sort{$a} cmp $sort{$b} } keys(%hits);
}




logTime("$#list+1 sorted");
$allHits = $#list + 1 unless $allHits;
wbTrimList( *list, $first, $last );
logTime("$#list+1 trimmed");
@ids = @list;

undef @list;

foreach $id (@ids) {
push( @list, $data{$id} );
}
}


$Log .= "$#list+1 before format\n";


if (   ( $format eq '' || $format eq 'TAB' || $format eq 'RAW' )
&& $fields eq ''
&& $Group  eq 'admin' )
{

@fields = @fieldNames;

}
else {

if ( $fields eq '' ) {
@fields = @fieldNames;
undef @editable;
}
elsif ( $fields !~ m/,/ ) {
@fields = ($fields);
}
else {
@fields = split( /,/, $fields );
}


foreach $f (@fields) {
if ( $f =~ m/^\?/ ) {
$f = $';
push( @editable, $f );
}
}

unless ( $Group eq 'admin' ) {
@fields = grep( !/_password/, @fields );

}

$stevec = $first + 1;
foreach $row (@list) {
recFromRow( $row, *fieldNames );
$ThisRecordNo = $stevec++;
$row = &formatFoundRec( $format, *fields, *editable );    # format goes here !
}
}

logTime("$#list+1 formated as $format ... recSelect done!");

return ( $allHits, *list, *fields );
}



sub wbParseSearch {

local ( $search, $table, $magic ) = @_;
undef $then;

if ($table) {
$dontKnowFieldNames = 1;
}
else {
wbSortFields();
}

( $search, $sExpression ) = split( /\{/, $search, 2 );

if ($sExpression) {
$_ = "{$sExpression";


if ( $_ =~ m/\{_at\}\s*>\s*(\d+)/ ) {
$then = $1;
$_    = $` . $';
}

s/\{/\$rec\{/g;
s/ and / && /g;
s/ or / || /g;
s/ not / ! /g;


$x = '\$rec\{_basket\}';
$y = '$Basket{$rec{\'_id\'}}>0';

if ( $_ =~ m/$x/ ) {
readBasket();
$_ =~ s/$x/$y/;
}

$sExpression = $_;



$x = &evalSafe($_);
if ( $x =~ m/class="ERROR"/i ) {
wbError( "Bad search expression", $x );    #UK
}
}

@words = split( / /, $search );
$s     = 0;
$n     = 0;
$a     = 0;
$dWord = '';
undef @sWords;
undef @aWords;
undef @nWords;

while (@words) {
$dWord .= shift(@words);
if ( ( $dWord =~ tr/"/"/ ) % 2 ) {
$dWord .= ' ';
next;
}

if ( $dWord =~ m/\:/ ) {
( $f, $w ) = split( /\:/, $dWord, 2 );
if ( $f =~ m/"/ ) {

}
else {
$we = $w;
$we =~ s/"//g;
$pwe = &wordBound($we);
( $s, $f ) =~ m/^([-+=\/]{0,1})(.*)$/;
$s = $1;
$f = $2;
if ( $s ne '' && !$dontKnowFieldNames && !$IsField{$f} ) {

wbError( "Warning: Bad search expression", "$f is not a field name. Perhaps you wanted to search for \"$dWord\"" );    #UK
}
else {
$s = $s || '+';
if ( $sExpression eq '' ) {
$sExpression = '1';
}
if ( $s eq '-' ) {
$sExpression .= " && ! (\$rec{'$f'} =~ m/$pwe/i)";
$dWord = '';
next;
}
if ( $s eq '+' ) {
$sExpression .= " && (\$rec{'$f'} =~ m/$pwe/i)";
$dWord = "+$w";

}
if ( $s eq '=' ) {
$sExpression .= " && (\$rec{'$f'} eq '$we')";
$dWord = "+$w";

}
if ( $s eq '/' ) {
$sExpression .= " && (\"\\n\$rec{'$f'}\\n\" =~ m/\\n$we\\n/i)";
$dWord = "+$w";

}
}
}
}

$dWord =~ s/"//g;

if ( $dWord =~ m/^\-(.+)/ ) {
$nWords[ $n++ ] = $1;
}
elsif ( $dWord =~ m/^\+(.+)/ ) {
$aWords[ $a++ ] = $1;
}
else {
$sWords[ $s++ ] = $dWord if $dWord ne '';
}
$dWord = '';
}

if ( $dWord ne '' ) {
wbError( "Error in search", "Search expression<br><b>$dWord</b><br>is invalid." );
}


$grepPatt = '';
if ($GREP) {    # prepare search pattern for GREP
if ( $aWords[0] ne '' ) {
$grepPatt = $aWords[0];
}
elsif ( $#sWords >= 0 ) {
$grepPatt = join( '|', @sWords );
}
}

return ( *aWords, *nWords, *sWords, $then, $sExpression, $grepPatt );
}


sub readBasket {

local ( @x, $id, $i, $no, $line, $file );

undef @BasketID;
undef @BasketNO;
undef @lines;

$file = &basketFile();

@x = stat($file);
my $be = $WBB{'basketExpire'} || 24;
if ( $x[9] < ( time - $be * 3600 ) ) {

unlink $file;
}
else {
open( b, $file );
@lines = <b>;
close(b);
}

$i = 0;
foreach $line (@lines) {
chop($line);
( $id, $no ) = split( /\t/, $line );
$BasketID[$i] = $id || $line;
$BasketNO[$i] = $no || 1;
$Basket{$id}  = $no || 1;
$i++;
}

return $#BasketID;
}


sub basketFile {
local ( $ip, $x );
$x = wbCheckDir("$DATADIR/_friend");
return ("$x/$User.bskt");
}


sub wordBound {
local ($word) = @_;

$word =~ s/(\W)/\\$1/g;     # escape special characters '*' too!
$word =~ s/\\\*/\.\*/g;     # lju\*ana into lju.*ana
$word =~ s/\\\?/\./g;       # ljubl?ana into ljubl.ana
$word =~ s/^(\w)/\\b$1/;    # prepend /b if it starts with a character
$word =~ s/(\w)$/$1\\b/;    # append /b if it ends with a character

return $word;
}


sub recFromRow {
local ( $row, *fields ) = @_;
local ( $field, $i, $x, @x );

undef %rec;

$x = chop($row);    # newline ?
if ( $x ne "\n" ) {
$row .= $x;
}

@x = split( /\t/, "$row\t." );    # because split(/\t/,"\t\t\t") does not return array of 4 empty fields
pop(@x);
if ( $#x != $#fields ) {
$x = '<table border="1"><tr><th>field</th><th>20 chars of value</th></tr>';
$i = 0;
while (1) {
local ( $n, $v );
$n = $fields[$i];
$v = substr( $x[$i], 0, 20 );
$x .= "<tr><tr><td>$n\n</td><td>$v\n</td></tr>\n";
last if $n eq '' && $v eq '';
$i++;
}
$x .= '</table>';
wbFail( "TBL file inconsistent", "$#x data items for $#fields fields!\n<hr> $x" );
}

$i = 0;
foreach $field (@fields) {
$x[$i] =~ s/\033/\t/g;
$x[$i] =~ s/\034/\012/g;
$rec{$field} = $x[$i];
$i++;
}
}


sub wbTrimList {
local ( *list, $first, $last ) = @_;

$last = $#list if $#list < $last;
@list = @list[ $first .. $last ];
return '';
}


sub formatFoundRec {

local ( $format, *fields, *editable ) = @_;
local ( $this, $open, $s, $i );

@ffields = &visibleFields(@fields);    # should preserve ... what of field hidden?

if (   $format eq 'TAB'
|| $format eq 'RAW'
|| $format eq 'CSV'
|| $format eq 'XML'
|| $format eq 'XMLE' )
{


}
else {


undef %pic;

if ( $#editable >= 0 && &wbCanModifyRecord( $CGI{'_accessPassword'} ) ) {
foreach $f (@editable) {
wbFormFieldItems($f);
$fld = $Form{ $f, 'input' };
$fld =~ s|NAME="|NAME="_id=$rec{'_id'}_field=|gi;
$fld =~ s/\n+/\n/g;
$rec{$f} = $fld;
$pic{$f} = $fld;
}
}


$ese = &htEscape( $CGI{'search'} );
$eso = &htEscape( $CGI{'sort'} || $sort );
$id  = $ID = $rec{'_id'};
$eid = &htEscape($id);


$this              = "$SCRIPT/Show$SuffixDetail?_id=$eid&amp;sort=$eso&amp;search=$ese&amp;hits=$allHits";
$ThisRecordURL     = $this;
$ThisRecordDate    = &formatYMDHMS( $rec{'_at'} );                                                           #4.151
$ThisRecordMatches = $hits{$id};

if ( $Group eq 'admin' && !$CMDLINE && $#editable < 0 ) {
$z = 'HSPACE=0' if $format eq 'DEFAULT';

$ThisRecordIcons =
"<a \nHREF=\"$SCRIPT/Delete$SuffixDetail?_id=$eid\"><img alt=\"\" \nSRC=\"$ICONURL/del.gif\" title=\"DEL\" $SMALLICONPAR $z></a> "
. "<a \nHREF=\"$SCRIPT/EditForm$SuffixDetail?_id=$eid\"><img alt=\"\" \nSRC=\"$ICONURL/edit.gif\" title=\"EDIT\" $SMALLICONPAR $z></a> "

;

}
else {
$ThisRecordIcons = '';
}


if ( grep( /\b_delete\b/, @ffields ) ) {
$alt          = "Check the checkbox to delete record";    #UK
$onFocus      = qq(onClick="self.status='$alt'");
$pic{_delete} = <<EOM;

<input
type="checkbox"
name="_delete"
value="$rec{'_id'}" 
$onFocus
>
EOM
$rec{'_delete'} = "";
}

if ( $format ne 'TABLE' ) {
$ThisRecordIcons .= $pic{_delete};
}


if (   $format eq 'PARAGRAPH'
|| $format eq 'DEFAULT' && $WBB{'format;DEFAULT'} =~ m/\$this/i )
{
$ThisRecordIcons .= &formatOpenIcon( 'SMALL', $this );
}
else {
$ThisRecordIcons .= &formatOpenIcon( '', $this );
}


if (   $PrintingBasket
|| $CMDLINE
|| !$WBB{'basketName'}
|| $#editable >= 0 )
{

}
else {

local ($c);

unless (%Basket) {
readBasket();
}
$c                = '';
$c                = 'CHECKED' if $Basket{$id};
$ThisRecordBasket = <<EOM;
<input name="id$id" type="checkbox" $c>
EOM
}
}

$print = '';

if ( $WBB{"formatRow$format"} ne '' ) {
$x = $WBB{"formatRow$format"};

$print = &evalSafe($x);    # || "EVAL ERROR:" . &htQuote("$x:$@");
paintFoundRec(*print);

}
elsif ( $WBB{"format;$format"} ) {
$x     = $WBB{"format;$format"};
$print = &evalSafe($x);                                              # || "EVAL ERROR:" . &htQuote("$x:$@");
$print = "<li> $ThisRecordIcons $ThisRecordBasket $print </li>\n";
paintFoundRec(*print);

}
elsif ( $format eq 'TAB' || $format eq 'RAW' ) {

$print = &recToRow(@ffields);

}
elsif ( $format eq 'CSV' ) {
foreach $x (@ffields) {                                              # kaj je to ???
$v = $rec{$x};
$v =~ s/\"/\"\"/g;
$print = $print . '"' . $v . '"' . ',';
}
chop $print;

}
elsif ( $format eq 'XML' ) {
$print = &rec2xml(@ffields);

}
elsif ( $format eq 'XMLE' ) {
$print = &rec2xmle(@ffields);

}
elsif ( $format eq 'RSS' ) {

local ($title);
$title = &evalSafe( $WBB{'detailTitle'} ) || "$WBB{'recordTitle'} $id";
$title = &htUntag($title);
$title = &htQuote($title);
$title = &htUTF8($title);

$x     = $WBB{"format;DEFAULT"} || $WBB{"formatRowDEFAULT"};
$print = &evalSafe($x);
$print = &htUntag($print);
$print = &htQuote($print);
$print = &htUTF8($print);

$print = <<EOM;
<item>
<title>$title</title>
<link>$SCRIPTBASE$SCRIPT/Show?_id=$ID</link>
<description>$print</description>
</item>
EOM
}
elsif ( $format eq 'CSVS' ) {
foreach $x (@ffields) {    # kaj je to ???
$v = $rec{$x};
$v =~ s/\"/\"\"/g;
$print = $print . '"' . $v . '"' . ';';
}
chop $print;

}
elsif ( $format eq 'TABLE' ) {
if ( $ffrt == 0 ) {
$ffrt = 1;
}
else {
$ffrt = 0;
}
$print = qq~\n<tr valign="top" class="DATA$ffrt"><td>$ThisRecordIcons $ThisRecordBasket</td>\n~;
foreach $x (@ffields) {
$value = $pic{$x}
|| &formatField($x);    # pic could be defined if this is a form
$value = '&nbsp;' if $value eq '' || $value =~ m/^\s*$/;
$print = $print . "<td>$value</td>\n";
}
$print .= "</tr>\n";
paintFoundRec(*print);

}
elsif ( $format eq 'PARAGRAPH' ) {
$print = "<p>$ThisRecordIcons $ThisRecordBasket";
foreach $x (@ffields) {
next if $x eq '_delete';
$value = $pic{$x}
|| &formatField($x);    # pic could be defined if this is a form
$value = '&nbsp;' if $value eq '' || $value =~ m/^\s*$/;
$print = $print . "$value,\n";
}
chop($print);                 # comma
paintFoundRec(*print);

}
elsif ( $format eq 'LONG' ) {
$print = $ThisRecordBasket . &wbRecHtml( '', *ffields );
paintFoundRec(*print);

}
elsif ( $format eq 'NAMEVAL' ) {
$print = $ThisRecordBasket . &wbRecHtml( 'NAMEVAL', *ffields );


}
else {

$print = &evalSafe($format);

}

return $print;
}


sub paintFoundRec {

local (*print) = @_;

return if $SearchPatts eq '';
return unless $CGI{'paint'} eq '1' || $CGI{'paint'} eq 'on';

eval { $print =~ s/>[^<]+/&paintFoundText($&)/gei };
return;
}


sub paintFoundText {

local ($x) = @_;


$x =~ s/$SearchPatts/<span class="FOUND">$&<\/span>/gi;
return $x;
}


sub recToRow {

local ( $out, $x );

foreach $x (@_) {
$v = $rec{$x};
$v =~ tr/\t/\033/;
$v =~ tr/\012/\034/;
$out .= $v . "\t";
}

chop $out;
return $out;
}


sub htUTF8 {

local ($_) = @_;
$_ =~ s/([\200-\377])/&htUTF8help(ord($1))/ge;
return $_;

}


sub htUTF8help {
local ($_) = @_;
return '&#x00' . ( 0 .. 9, 'a' .. 'f' )[ $_ / 16 ] . ( 0 .. 9, 'a' .. 'f' )[ $_ & 15 ] . ';';
}


sub rec2xml {

local (@fields) = @_;
local ($ret);

$id  = &htQuote( $rec{'_id'} );
$ret = "<rec _id=\"$id\">\n";

foreach $n (@fields) {
$v = $rec{$n};
$v = &htQuote($v);
$ret .= "<$n>$v</$n>\n";
}

return "$ret</rec>\n";
}


sub formatYMDHMS {

local ($time) = @_;
local ( @x, $i );

@x = &fixDate($time);
return &formatYMD( $x[5], $x[4], $x[3] ) . ' ' . &formatHMS( $x[2], $x[1], $x[0] );
}


sub formatHMS {

local ( $hh, $mm, $ss ) = @_;

if ( $WBB{'timeFormat'} ne '' ) {
return &evalSafe( $WBB{'timeFormat'} );
}
else {
return "$hh:$mm";
}
}


sub rec2xmle {

local (@fields) = @_;
local ($ret);

$id  = &htQuote( $rec{'_id'} );
$ret = "<rec _id=\"$id\">\n";
$ret .= <<EOM;
<!-- Below are name=value pairs, one per line.						-->
<!-- To decode values tr char 034 with 012							-->
<!-- Ignore any lines that do not begin with letter,digit,_underscore -->
<!-- This is not in XML spirit but easy to parse					  -->
<!-- use format=XML if you need proper XML							-->
<!-- note that ]] is not escaped									  -->
<![CDATA[
EOM
foreach $n (@fields) {

$v = $rec{$n};
$v =~ tr/\012/034/;
$ret .= "$n=$v\n";
}

return "$ret]]></rec>\n";
}


sub visibleFields {

local (@fields) = @_;

wbSortFields();
if ( $#fields < 0 ) {    # no parameters
@fields = @PFields;
}

@ret = ();
foreach $f (@fields) {
push( @ret, $f ) unless $Hidden{$f};
}

return @ret;
}


sub wbRecHtml {

local (@fields);
local ( $how, *fields ) = @_;

local ( $out, $value, $x, $th1, $th2 );

if ( $WBB{'detail'} ne '' && $how ne 'NAMEVAL' ) {
$out = &evalSafe( $WBB{'detail'} );
return $out;
}


$out .= <<EOM;
<table class="DATATABLE" cellspacing="1" cellpadding="2">
EOM


if ( $#fields < 0 ) {
wbSortFields();
@f = @Fields;
push( @f, '_from', '_at' );
}
else {
@f = @fields;
}

foreach $field (@f) {


next if $Hidden{$field};


$value = &formatField($field);

if ( $WBF{ $field, 'type' } eq 'BREAK' ) {
$t = $WBF{$field};
$t =~ s/^"//;
$t =~ s/"$//;
$out .= '<tr class="DATAH" ><th>&nbsp;</th><th align="left">' . $t . '</th></tr>' . "\n";
next;
}

if ( $WBF{ $field, 'type' } eq 'SUBMIT' ) {
next;
}

next if $value eq '';

$name = &formatFieldName($field);

$c = '';
$c = 'class="ERROR"' if $err{$field};

$out .= qq~<tr class="DATA" valign="top">\n<th align="right">$name</th>\n<td $c>$value</td>\n</tr>\n\n~;
}



$out .= "</table>\n";

return $out;
}


sub formatFieldName {

local ( $field, $nolink ) = @_;

$_ = $field;

if ( $WBF{ $_, 'head' } ) {
return $WBF{ $_, 'head' };
}

s/([a-z])([A-Z])/$1 $2/g;
tr/[A-Z]/[a-z]/;

if ( !$nolink && $WBF{ $field, 'type' } =~ m/OPTION/ ) {
$_ = qq(<a href="$SCRIPT/BrowseTree?field=$field&amp;order=AZ">$_</a>);
}

return $_;
}


sub formatOpenIcon {

local ($size) = $_[0];
local ($hits) = $ThisRecordMatches;
local ($num);

if ( $#sWords >= 0 ) {
$num = ( $hits - $Xtra ) / ( $#sWords + 1 );
}
elsif ($then) {
$num = ( $sort{$id} - $then ) / ( $now - $then );
}
else {
$num = 1;
}

$iconpar = $ICONPAR;
if ( $size eq 'SMALL' ) {
$iconpar = $SMALLICONPAR;
}

$aa = 1;
$aa = 2 if $num > .20;
$aa = 3 if $num > .50;
$aa = 4 if $num > .74;

$proc = int( $num * 100 + .5 ) . '%';

return <<EOM;    #UK
<a href="$this"><img src="$ICONURL/$ICONOPEN$aa.gif" $iconpar alt="$proc; open" title="$proc; open"></a> 
EOM

}


sub wbCanModifyRecord {

local ($pass) = @_;

return 1 if $Group eq 'admin';
return 1 if &isOwner();
return 0 if &isOwned();
return 1 if &wbTestPass( $pass, $rec{'_password'} );
return 0;
}


sub isOwned {

return $WBB{'ownerField'} && $rec{ $WBB{'ownerField'} } ne '';

}


sub isOwner {

wbSetOwner();
return $RGroup eq 'owner';
}


sub wbSetOwner {

undef $RGroup;

if ( $WBB{'ownerField'} ) {
if ( $rec{ $WBB{'ownerField'} } eq $User ) {
$RGroup = 'owner';
}
}
elsif (
( $User =~ m/^_anon_/ || $User eq '' )
&& (   $rec{ $WBB{'ownerField'} } eq '0'
|| $rec{ $WBB{'ownerField'} } eq '' )
)
{
$RGroup = 'public';
}
else {
$RGroup = 'other';
}

if ( $WBB{'ownerGroup'} && $WBB{'recordLock'} =~ m/group/ ) {
if ( $WBB{'ownerGroup'} eq $Group ) {
$RGroup = 'owner';
}
}
}


sub wbFormFieldItems {

local ($field) = $_[0];
local ( $onClick, $onFocus, $onBlur );

$Form{ $field, 'name' }   = '';
$Form{ $field, 'prompt' } = '';
$Form{ $field, 'input' }  = '';
$Form{ $field, 'help' }   = '';
$Form{ $field, 'err' }    = '';

if (   $CGI{'_id'} eq ''
&& $WBF{ $field, 'adds' }
&& $Group =~ /admin|$WBF{$field,'adds'}/ )
{

}
else {
return unless $Group =~ /admin|$WBF{$field,'modifies'}/;
}

if ( $CGI{'fields'} ne '' ) {

return unless "$CGI{'fields'}" =~ m/\b$field\b/;
}

if ( $WBF{ $field, 'type' } eq 'BREAK' ) {
$Form{ $field, 'name' } = $WBF{$field};
return;
}

if ( $WBF{ $field, 'type' } eq 'SUBMIT' ) {
return;
}

if ( $WBF{ $field, 'type' } eq 'COMPUTE' ) {
return;
}

$hidden = 0;
$hidden = 1 if $WBF{ $field, 'typePar' } =~ m/HIDDEN/i;

$niceField = $WBF{ $field, 'head' };
unless ($niceField) {
$niceField = $field;
$niceField =~ s/([A-Z]+)/ $1/g;
$niceField =~ tr/[A-Z]/[a-z]/;
}
$niceField = "$niceField:";
$niceField = '' if $hidden;

$validIfText = "valid if";    #UK


$Form{ $field, 'err' } = '<img src="' . $ICONURL . '/del.gif" alt="Error" title="Error" ' . $SMALLICONPAR . '>'
if $err{$field} == 1;

$Form{ $field, 'name' } = $niceField;
$Form{ $field, 'prompt' } = $WBF{ $field, 'p' } if $Help && !$hidden;

$alert = '';

$st = 'HINT';
$st = 'ERROR' if $err{$field};
if ( $WBF{ $field, 'cond' } ) {
$alert = $WBF{ $field, 'cond' };
$Form{ $field, 'prompt' } .= " <span CLASS=$st>($WBF{$field,'cond'})</span>"
if $Help && !$continue && !$hidden;
}
else {
$alert = "$validIfText: $WBF{$field}" if $WBF{$field} ne "1;";
$Form{ $field, 'prompt' } .= " <span CLASS=$st>($validIfText: $WBF{$field})</span>"
if $Help && $WBF{$field} ne "1;" && !$continue && !$hidden;
}


if ( $WBF{ $field, 'type' } eq 'EMAIL' || $WBF{ $field, 'required' } ) {    # MF necessary to show if admin says so
$optional = '';
$Form{ $field, 'name' } = '<span class="ERROR">*</span> ' . $Form{ $field, 'name' }
unless $hidden;
}
else {
$optional = 'class="DATA0" ';

}

if ( $JS >= 1.2 && $WBF{$field} =~ m|^m(/.*/[a-z]*$)| ) {
$onChange = <<EOM;
onChange="validText(this,$1,'$field: $alert')"
EOM
}
else {
$onChange = '';
}

if ( $JS && $status !~ m/<\(/ ) {    # weed out HTML !
$status = "$field: $WBF{$field,'p'} ... $alert";
$status =~ s/\n/ /g;
$status =~ tr/\"\'\<\>/ /;

$status = $onClick = $onFocus = $onBlur = '';

}
else {
$status = $onClick = $onFocus = $onBlur = '';
}


$default = $rec{$field};
$default = $CGI{$field} if $default eq '';
$default = $COOKIE{$field} if $default eq '' && $WBF{ $field, 'sticky' };
$default = $COOKIE{_email}
if $default eq '' && $WBF{ $field, 'type' } eq 'EMAIL';

if ( $default eq '' && $rec{_id} eq '' ) {    # claudio # mf
$default = $WBF{ $field, 'd' };
$default = &evalMaybe($default);
}
$default = &htQuote($default);
$typePar = $WBF{ $field, 'typePar' };


if ( $typePar =~ s/CONTINUE// ) {
$continue = 1;
}
else {
$continue = 0;
}

if ( $WBF{ $field, 'type' } =~ m/^TEXTAREA|HTMLAREA|LIST$/ ) {
$typePar = 'rows="8" cols="50"' if $WBF{ $field, 'typePar' } eq '';



if (   $HtmlAreaWorks
&& $WBF{ $field, 'type' } eq 'HTMLAREA'
&& $WBF{ $field, 'typePar' } =~ m/RICH/ )
{
$typePar =~ s/COLS/XCOLS/;    # fixed width!
}

$Form{ $field, 'input' } = <<EOM;
<textarea name="$field" ID="$field" $typePar $optional wrap="virtual"
$onChange $onFocus $onBlur
>$default</textarea>
EOM

if (   $HtmlAreaWorks
&& $WBF{ $field, 'type' } eq 'HTMLAREA'
&& $WBF{ $field, 'typePar' } =~ m/RICH/ )
{
$Form{ $field, 'input' } .= <<EOM;
<script type="text/javascript" DEFER="1">
var config = new HTMLArea.Config();
config.pageStyle = "body { background-color: #fff; font-family: serif; }";
config.editorURL = '$WODAURL/htmlarea/';
config.width = "604";
config.height = "auto";
config.statusBar = false;
config.toolbar = [ [ 
"formatblock", "separator", "bold", "italic", "underline", 
"separator", "justifyleft", "justifycenter", "justifyright", "justifyfull", "separator",
"insertorderedlist", "insertunorderedlist", "separator", "outdent", "indent", 
"subscript", "superscript", "separator", "createlink",
"htmlmode", "separator", "popupeditor", "space", "about" ]
];
HTMLArea.replace('$field',config);
</script>
EOM
}

}
elsif ( $WBF{ $field, 'type' } =~ m/^OPTION$|^LINKOPTION$/ ) {

@options = &wbParseOptions($field);

$no = 0;

$default = "\n$default\n";

if ( $WBF{ $field, 'typePar' } =~ m/COLS=(\d+)/i ) {
$cols = $1;
}
elsif ( $#options > 0 ) {
$cols = int( 50. / ( length( join( '1234567', @options ) ) / ( $#options + 1 ) ) );
}
else {
$cols = 1 if $#options < 3;
}
undef @x;

if ( $WBF{ $field, 'typePar' } =~ m/HEADING=(.{1,5})/i ) {    # take the 5 first letters from HEADING
$heading = $1;
}
else {
$heading = '';
}

$typePar = 'RADIO'
if ( $WBF{ $field, 'typePar' } eq '' && $#options < 2 );


if ( $typePar =~ m/CHECKBOX/ ) {
foreach $o (@options) {
$okey = "($o)";
$okey = '' if $WBF{ $field, 'typePar' } =~ m/NOID/;
$optionText[$no] = "$o" if $optionText[$no] eq '';
$t = $optionText[ $no++ ];
$t .= ' <span class="HINT">' . $okey . '</span>' if $okey;

$o   = &htQuote($o);     # default is htQuoted above
$reo = &regexpEsc($o);

if ( $heading && $o =~ m/^$heading/ ) {    # no checkbox ... prohibited
push( @x, "<b>$t</b>\n" );
next;
}

if ( $default =~ /\n$reo\n/ ) {
push( @x, qq(<input type="checkbox" name="$field" value="$o" checked $onClick>$t\n) );
}
else {
push( @x, qq(<input type="checkbox" name="$field" value="$o" $onClick>$t\n) );
}
}
$alltext  = "check all";                       #UK
$nonetext = "check none";                      #UK
$allhtm   = <<EOM;
<a href="javascript:allBoxes('$field',1)"><img src="$ICONURL/check.gif" $ICONPAR alt="$alltext" title="$alltext"></a>
<a href="javascript:allBoxes('$field',0)"><img src="$ICONURL/uncheck.gif" $ICONPAR alt="$nonetext" title="$nonetext"></a>
EOM
push( @x, $allhtm ) if $JS && $#options > 5;
$Form{ $field, 'input' } .= &formatColumns( $cols, @x );


}
elsif ( $typePar =~ m/RADIO/ ) {
foreach $o (@options) {
$okey = "($o)";
$okey = '' if $WBF{ $field, 'typePar' } =~ m/NOID/;
$optionText[$no] = "$o" if $optionText[$no] eq '';
$t = $optionText[ $no++ ];
$t .= ' <span class="HINT">' . $okey . '</span>' if $okey;

$o   = &htQuote($o);     # default is htQuoted above
$reo = &regexpEsc($o);

if ( $heading && $o =~ m/^$heading/ ) {    # no checkbox ... prohibited
push( @x, "<b>$t</b>\n" );
next;
}

if ( $default =~ /\n$reo\n/ ) {
push( @x, qq(<input type="radio" name="$field" value="$o" checked $onClick>$t\n) );
}
else {
push( @x, qq(<input type="radio" name="$field" value="$o" $onClick>$t\n) );
}
}
$Form{ $field, 'input' } .= &formatColumns( $cols, @x );


}
else {
$Form{ $field, 'input' } .= "<select name=\"$field\" $typePar $onClick $optional>\n";
foreach $o (@options) {
$okey = "($o)";
$okey = '' if $WBF{ $field, 'typePar' } =~ m/NOID/;
$okey = "$o" if $optionText[$no] eq '';
$t    = "$optionText[$no++] $okey";
$o    = &htQuote($o);                                 # default is htQuoted above
$reo  = &regexpEsc($o);

if ( $default =~ /\n$reo\n/ ) {
$Form{ $field, 'input' } .= "<option selected value=\"$o\">$t\n";
}
else {
if ( $heading && $o =~ m/^$heading/ ) {           # no value ... prohibited - default still selected
$t = "* $t";
$o = '';
$Form{ $field, 'input' } .= "<option>$t\n";
}
else {

$Form{ $field, 'input' } .= "<option value=\"$o\">$t\n";
}
}
}
$Form{ $field, 'input' } .= "</select>";
}

}
elsif ( $WBF{ $field, 'type' } eq "FILE" ) {
$typePar = "size=20";
$Form{ $field, 'input' } .= qq(<input type="input" name="$field" value="$default" $typePar $onFocus $onBlur $optional>\n);

}
elsif ($WBF{ $field, 'type' } eq "USERFILE"
|| $WBF{ $field, 'type' } eq "IMAGE" )
{

$HasAttachmentField = 1;

if ($default) {
$keep = "$field exists; to delete uncheck the checkbox; to replace submit a file below";    #UK
$keep = '' unless $Help;
$Form{ $field, 'input' } .= qq(<input type="checkbox" name="$field-old" value="$default" CHECKED><span class="HINT">$keep</span><br>\n);
}

$typePar = "size=30" if !$typePar;
$help = "select a file on <em>your</em> computer to upload to the Web (only works with Netscape Navigator 2+ or Microsoft Explorer 4+)";   #UK
$help = '' unless $Help;
$Form{ $field, 'input' } .= qq(<input $onFocus $onBlur type="file" name="$field" $typePar $optional><br><font class="HINT">$help</font>\n);

}
elsif ( $WBF{ $field, 'type' } eq "EMAIL" ) {
$typePar = "size=40" if !$typePar;

$Form{ $field, 'input' } .= qq(<input $onFocus $onBlur type="input" name="$field" value="$default" $typePar $optional $onChange>\n);

}
elsif ( $WBF{ $field, 'type' } eq "DATE" ) {
( $y, $m, $d ) = split( /\//, $default );
$ny   = $field . '_year';
$nm   = $field . '_month';
$help = "year/month/day";    #UK
$help = '' unless $Help;
$Form{ $field, 'input' } .= <<EOM;
<input $typePar $optional name="$ny" value="$y" size="4" $onFocus $onBlur
>/<input $typePar $optional name="$nm" value="$m" size="2" $onFocus $onBlur
>/<input $typePar $optional name="$field" value="$d" size="2" $onFocus $onBlur> $help
EOM

}
else {
$typePar = "size=50" if $WBF{ $field, 'typePar' } eq '';
if ( $typePar =~ m/HIDDEN/ ) {
$t = 'hidden';
}
else {
$t = 'text';
}
$Form{ $field, 'input' } .= <<EOM;
<input name="$field" type="$t" value="$default" $typePar $optional
$onChange
$onFocus
$onBlur
>
EOM

}


if ( !$continue ) {
if ( $Help && $WBF{ $field, 'help' } && !$hidden ) {
$Form{ $field, 'help' } .= '<span class="HINT">' . $WBF{ $field, 'help' } . '</span>';
}
}
}


sub regexpEsc {

local ($_) = $_[0];
s/(\W)/\\$1/g;
return $_;
}


sub formatColumns {

local ( $num, @items ) = @_;
local ( $ret, $left );

$num = 1 if $num == 0;    # parachute
$left = 1 + int( ($#items) / $num );

$ret = "<table><tr>\n";
for ( $i = 0 ; $i <= $#items ; $i += $left ) {
$j = $i + $left - 1;
$x = join( "\n<br>", @items[ $i .. $j ] );
$ret .= qq(<td valign="top" class="NOBORDER">$x</td>\n);
}
$ret .= "</tr></table>\n";
return $ret;
}

sub wbGrepRecords {

local ( *records, *aWords, *nWords, *sWords, $then, $sex ) = @_;

undef @list;
undef $SearchPatts;    # search patterns to be used in formatting

if ($then) {           # time zadnja zadeva !
foreach $_ (@records) {
m/([0-9]*)$/;
push( @list, $_ ) if $1 > $then;
}
$Log .= "Processed time with $then ... $#list\n";
}
else {
@list = @records;
$Log .= "list=records ... $#list+1\n";
}

foreach $word (@nWords) {
next if $word eq '';
$patt = &wordBound($word);
@list = grep( !/$patt/i, @list );
$Log .= "Perl grep NOT /$patt/i ... $#list+1\n";
}

foreach $word (@aWords) {
next if $word eq '';
$patt = &wordBound($word);
$SearchPatts .= "$patt|";
@list = grep( /$patt/i, @list );
$Log .= "Perl grep AND /$patt/i ... $#list+1\n";
}

if ($sex) {
$* = 1;    # multiline matching
undef @y;
foreach $row (@list) {
recFromRow( $row, *fieldNames );

push( @y, $row ) if &evalSafe($sex);
}
$*    = 0;    # singleline matching
@list = @y;

}

undef @y;
foreach $word (@sWords) {
next if $word eq '';
$patt = &wordBound($word);
$SearchPatts .= "$patt|";
@x = grep( /$patt/i, @list );
push( @y, @x );
$Log .= "Perl grep OR /$patt/i ... $#x/$#list\n";
}



$Xtra = 0;
if ( $nots || $ands ) {

push( @list, @y );
$Xtra = 1;
$Log .= "... OR words appended\n";
}
elsif (@sWords) {
@list = @y;
$Log .= "... using y because there are $#sWords\n";
}
else {
$Log .= "... using list\n";

}

chop($SearchPatts);
return *list;
}


sub wbReindex {
local ( $sort, $force ) = @_;
local ( $now, $file, $id, $pos, $len, $time, $string );
local ( %pos, %sort, %print );

$now = time;

$file = "_cache/$sort.tbl";
$file =~ tr/[A-Z]/[a-z]/;

unless ( $force || ( $tblm = &wbExpired($file) ) ) {

return;
}

if ( -e "$file.wrk" ) {
if ( ( time - &wbMtime("$file.wrk") ) > 1200 ) {    # give up after 20 minutes
unlink("$file.wrk");
wbWarn( "Reindexing", "Please wait ..." );      #UK
}
elsif ( ( time - &wbMtime("$file.wrk") ) > 300 ) {
wbWarn( "Reindexing", "Reindexing is taking longer than 5 minutes. Old index is being used." );
return;
}
else {
wbError( "Table is being reindexed.", "Please wait a minute. If the problem persists inform the manager" );    #UK
}
}

logTime("Begin re-indexing table");

open( hhh, ">$file.wrk" )
|| wbFail("Cannot reindex table and open $file.wrk");
binmode(hhh);

wbSortFields();
print hhh join( "\t", @IFields );
print hhh "\n" || wbFail("Cannot reindex table, disk full?");

( $coFrom, $coTo ) = &wbCollate();
( $lcFrom, $lcTo ) = split( / /, $WBB{'intlLower'} );
undef $coEval;
undef $lcEval;
$coEval = "tr/$coFrom/$coTo/" if $coFrom;
$lcEval = "tr/$lcFrom/$lcTo/" if $lcFrom;

logTime("Before reading FAT");

open( h, "$DATADIR/_data/fat.txt" );    # fat may not exist! ||wbFail("Cannot open fat.txt");
while (<h>) {
( $id, $pos ) = split( /\t/, $_, 2 );
$pos{$id} = $pos;
}
close(h);

logTime("Parsed FAT");

@keys = sort { $pos{"$a"} <=> $pos{"$b"} } keys(%pos);

logTime("Optimised FAT - $#keys+1 records");

open( h, "$DATADIR/_data/records.txt" );

$sortexp = $WBB{"sort;$sort"};

undef @badFatIDs;

while ( ( $id, $pos ) = each(%pos) ) {

next unless $pos >= 0;    # deleted record

unless ( seek( h, $pos, 0 ) ) {
push( @badFatPos, $id );
next;
}

$meta = <h>;
chop($meta);
( $len, $time ) = split( /\t/, $meta );

unless ( read( h, $string, $len ) ) {
push( @badFatPos, $id );
next;
}

recFromVector($string);

if ( $rec{'_at'} eq '' ) {

}

if ( $sort eq 'TIME' ) {
$sort{$id} = $rec{'_at'};
}
elsif ( $WBB{"sort;$sort"} ) {
$_ = &evalSafe($sortexp);
s/^\s*//;    # ignore leading spaces!
&evalSafe($lcEval)
if $lcEval;    # do case lowering & other equivalences
tr/[A-Z]/[a-z]/; # lower case
&evalSafe($coEval) if $coEval;    # different collate
$sort{$id} = $_;

}

$print{$id} = &recToRow(@IFields);
}

close(h);


if ( $#badFatPos >= 0 ) {

open( h, ">>$DATADIR/_data/fat.txt" );
flock( h, 2 );
binmode(h);
foreach $id (@badFatPos) {
print h "$id\t-2\n";
}
close(h);
}

logTime("Have new data");

if ( $sort eq 'TIME' ) {
@list = sort { $sort{$b} <=> $sort{$a} } keys(%print);
}
else {
@list = sort { $sort{$a} cmp $sort{$b} } keys(%print);
}

logTime("Sorted");

foreach $id (@list) {
print hhh $print{$id} . "\n";
}
close(hhh);

unlink $file;
rename( "$file.wrk", "$file" )
|| wbFail("Failed rename $file.wrk to $file");

logTime("Table reindexed");

open( h, ">$file.time" );
$x = time - $now;
print h "$x\n";
print h "This is how many seconds the last reindexing took\n";
close(h);
}


sub wbMtime {

local ($file) = @_;
local (@x);

@x = stat($file);
return $x[9];
}


sub wbCollate {

return ( '', '' ) unless $WBB{'intlCollate'};
local ( $x, $c, $rest, $from, $to );

@x = split( /\s/, $WBB{'intlCollate'} );
foreach $x (@x) {
$c = substr( $x, 0, 1 );
$rest = substr( $x, 1 );
$tr{$c} = $rest;
}

$from = $to = '';

$acTo = 97;
for ( $ac = 97 ; $ac <= 122 ; $ac++ ) {
$c = pack( 'c', $ac );


$from .= $c;
$to .= pack( 'c', $acTo++ );

if ( $rest = $tr{$c} ) {
for ( $i = 0 ; $i < length($rest) ; $i++ ) {
$s = substr( $rest, $i, 1 );

$from .= $s;
$to .= pack( 'c', $acTo++ );
}
}
}

return ( $from, $to );
}


sub wbWarn {

local ( $title, $message ) = @_;

if ( !$HttpHeadPrinted ) {
printHead('');
}

print &formatWindow( $title, $message, 'WARNBOX' );
}


sub wbReadRecords {

local ( $table, $sort, $grepPatt ) = @_;
local ($dd);

$dd = &wbTables( 'DIR', $table );
unless ($dd) {
$Log .= "ERROR: No such table $table\n";
return;
}

$sortf = $sort;
$sortf =~ tr/[A-Z]/[a-z]/;

if (   $GREP
&& $WBB{'grepBigger'}
&& $grepPatt ne ''
&& ( -s "$dd/_cache/$sortf.tbl" > $WBB{'grepBigger'} ) )
{

open( h, "$dd/_cache/$sortf.tbl" )
|| wbFail("Open of $sortf.tbl failed for $table");
$records[0] = <h>;    # attn: newlines included !
$records[1] = <h>;    # attn: newlines included !
$records[2] = <h>;    # attn: newlines included !
close(h);
*fieldNames = &wbReadRecordsFnames();
$grepPatt =~ s/"//g;
$grepPatt =~ s/\*$//g;
$grepPatt =~ s/^\*//g;
$grepPatt =~ s/\*/\.\*/g;

if ( $grepPatt =~ m/^\w*$/ ) {
$sw = '-F';
}
elsif ( $grepPatt =~ m/\|/ ) {
$sw = '-E';
}
else {
$sw = '';
}
$g = "$GREP -a -i $sw \"$grepPatt\" $dd/_cache/$sortf.tbl |";
open( h, $g );
@records = <h>;
$Log .= "$g ... $#records + 1\n";
close(h);

}
else {

open( h, "$dd/_cache/$sortf.tbl" )
|| wbFail("Open of $sortf.tbl in $dd failed");
@records = <h>;    # attn: newlines included !
close(h);
$searchProc = "Reading all records from $sortf.tbl\n";
*fieldNames = &wbReadRecordsFnames();
}

return ( *records, *fieldNames );

}


sub wbReadRecordsFnames {

if ( $records[1] =~ m/^\n/ ) {
$x = shift(@records);    # content type
$x = shift(@records);    # blank
}
$x = shift(@records);
chop($x);
@fieldNames = split( /\t/, $x );

return *fieldNames;

}


sub IDS {

local ($table) = @_;
local ( @x, $x );

$x = &ROWS( $table, '_id' );
@x = split( /\n/, $x );

return @x;
}


sub NEXT {

local ( $first, $step ) = @_;

$first = 1 if $first eq '';
$step  = 1 if $step  eq '';

local ( $last, $file );

$file = "$DATADIR/_cache/lastid.txt";
if ( -e $file ) {

}
else {
open( h, ">$file" );
print h ( $first - $step );
close(h);
}

open( h, "+<$file" );
$last = <h>;
$last = $last + $step;

seek( h, 0, 0 );
print h $last . "\n" || wbFail("Cannot get new record ID");
close(h);

return $last;
}


sub mainCmdline {

if ( $ARGV[0] eq '-x' ) {

if ( $WBB{'dataDir'} eq '' ) {
if ( $DATADIRDIR && $ARGV[1] =~ m|^(.+)(/[A-Z].*)| ) {
$DATADIR = "$DATADIRDIR/$1";
}
elsif ( $DATADIRDIR && $ARGV[1] =~ m|^([a-z][^/]*)(.*)| ) {
$DATADIR = "$DATADIRDIR/$1";
}
else {
print '<p class="ERROR">To run from command line, WBB{dataDir} must be defined</p>';
wodaExit();
}
}
else {

$DATADIR = $WBB{'dataDir'};
}

$HTMLFILE = 1;
$CMDLINE  = 1;
( $ENV{'SERVER_PROTOCOL'}, $ENV{'SERVER_NAME'}, $ENV{'SERVER_PORT'}, $ENV{'SCRIPT_NAME'} ) = &admGetEnv();

if ( !$ENV{'SERVER_PROTOCOL'} ) {
print '<p class="ERROR">Cannot access environment of ', $SCRIPTFILE,
' at ', $DATADIR, '. Was it ever accessed through the Web?</p>', "\n";    #UK
wodaExit();
}

$ARGV[1] = "/$ARGV[1]" unless $ARGV[1] =~ m|^/|;                                # one forgets /Search
$ARGV[1] =~ s|//|/|;                                                            # remove a possible double slash
$ENV{'PATH_INFO'}    = $ARGV[1];
$ENV{'QUERY_STRING'} = $ARGV[2];
$ENV{'QUERY_STRING'} =~ s/^'//;                                                 # DOS does not remove this from command line parameters
$ENV{'QUERY_STRING'} =~ s/'$//;                                                 # same here

unless ( $ENV{'REQUEST_METHOD'} ) {                                             # true command line
$COOKIE{_login} = $ARGV[3] || 'admin:';                                     # Group defined in wbLogin
}
$ENV{'REMOTE_ADDR'} = $ENV{'REMOTE_ADDR'} || '127.0.0.1';
$ENV{'REQUEST_METHOD'} = 'GET';
}
}


sub admGetEnv {

local ($otherDataDir) = @_;
local ( $name, $value, $x );

$otherDataDir = &wbTables( 'DIR', $otherDataDir );

open( h, "$otherDataDir/_cache/access3.txt" ) || return ();

while (<h>) {
chop;
$i++;
( $name, $value ) = split(/=/);
if ( $name eq 'UID' ) {
$> = $value if $UNIX;
}
elsif ( $name eq 'URL' ) {
$x = $value;
}
elsif ( $name eq 'SCRIPTNAME' ) {
$sn = $value;
}
}
close h;

return ( $1, $2, $3, $4 ) if $x =~ m|(.*)://([^/]*):(\d*)/(.*)|;
return ( $1, $2, 80, $3 ) if $x =~ m|(.*)://([^/]*)/(.*)|;
}


sub ID {
local ($string) = @_;

return &wbFixId($string);
}

# to use WODA as a package under MOD_PERL
# uncomment the package line below
# beware that this makes life quite complicated for
# any user defined functions !
#
# package WODAUK;	#UK

$VERSION = '4.610';    # set version
wbSetINC();            # add dir of this file to @INC

# all server-wide configuration parameters are in this sub
# to change configuration, edit the file local/woda.conf

# define config file
sub mainConfig {

if ( -e "$WodaFileDir/local/woda.conf" ) {
do "$WodaFileDir/local/woda.conf";
}
elsif ( -e "$WodaFileDir/../en/local/woda.conf" ) {
do "$WodaFileDir/../en/local/woda.conf";
}
else {
wbFail( 'woda.conf not available', "File $WodaFileDir/local/woda.conf not available\n" );    #UK
}

}

sub redirectRobot {

cgiRobotToc();
$Err = 'bot';
printFoot();
wodaExit();


$Err    = "RRD";
$ErrMsg = "Redirect $ENV{'HTTP_USER_AGENT'} to /robots";
wbLog();


if ( &wbExpired( "$HTMLDIR/robots/index.htm", "", 6 ) ) {
admStatic();
}


print "Location:$SCRIPTBASE$WBB{'htmlURL'}/robots/index.htm\n\n";

wodaExit();
}


sub cgiRobotToc {

printHead("TOC for Robots");

recAll();
while ( $id = &recNext() ) {
print "<a href=\"$SCRIPT/Show?$id\">$id</a>, \n";
}
}


sub recNext {

local ( $n, $v ) = each(%IDS);
return $n;
}


sub admStatic {

wbCheckDirectories();

if (1) {
$toc = "";
recAll();
while ( $id = &recNext() ) {
$toc .= "<a href=\"$SCRIPT/Show?$id\">$id</a>, \n";

}


$hp = "$HTMLDIR/robots/index.htm";
open( cache, ">$hp" ) || wbFail("Cannot open file $hp");
binmode(cache);
$selected = select(cache);
$homeURL  = &homeURL();
$HTMLFILE = 1;
printHead("Database Contents");    #UK
print <<EOM;
<p>
$WBB{'about'}
<h3>Index</h3>
<ul>
$toc
</ul>
EOM
close(cache);
select($selected);
}
}


sub wbSetINC {

local ( $package, $filename, $line ) = caller;

$filename =~ m|/[^/]*$|;
unshift( @INC, $` );
}


sub mainError {

wbFail(
"Improper use of WODA.", "The database definition file
should end in a call like <em>do main(*WBB,*WBF)</em> or <em>do WODAUK'run(*WBB,*WBF)</em>
if used under MOD_PERL.
"
);
}
