

sub cgiAdmAgentProcess {

printHead("Processing agent requests");

$pattUser  = $CGI{'users'}  || '.';
$pattEmail = $CGI{'emails'} || '.';
$force     = $CGI{'force'};
$where     = $CGI{'where'};

print "<pre>";

wbCheckDir('_friend');
chdir("$DATADIR/_friend") || wbFail( "ERROR", "Cannot chdir to _friend" );

@agentRecords = &wbDir('.*\.forms$');

@x     = localtime(time);
$dDay  = $x[6];
$dDate = 'm' . $x[3];

foreach $_ (@agentRecords) {

m/(.*).forms$/;
$friend = $1;

if ( $friend =~ m/$pattUser/ ) {
print "\nPROCESSING $friend\n";
}
else {
print "\nSkipping $friend\n";
next;
}

@rows = &hashRead("$DATADIR/_friend/$friend.forms");
@rows = grep( /_form\037AgentAddForm/, @rows );

foreach $row (@rows) {

hashImport( *row, $row );

$email = $row{_email};
next if $email !~ m/$pattEmail/;
next unless &isEmail($email);
next unless &wbCryptPasswd($email) eq $row{_confirm};

print "handling $row{_formid}\n";

unless ( $row{"day:$dday"} eq 'on' || $row{"day:$ddate"} eq 'on' ) {
print "... today no need\n";
next unless $force;
print "... force\n";
}

%CGI = %row;
if ( $force == 2 ) {
$CGI{'since'} = 1;
}
else {
$CGI{'since'} = $row{'since'};
}

$xx = $$;


wbCheckDir($TMPDIR);
$agentFile = "$TMPDIR/agent-process.$xx.htm";
open( AGENTFILE, ">$agentFile" );
binmode(AGENTFILE);
local ($selected);
$selected = select(AGENTFILE);
chdir $DATADIR;
$HTMLFILE = 1;
wbDo("cgiSearch");
print "\n</body></html>";
$HTMLFILE = 0;
chdir '_friend';
select($selected);
close AGENTFILE;

open( h, $agentFile );
$html = join( '', <h> );
$ascii = &formatHtm2Txt($html);
$ascii =~ s/\n\n/\n/g;
close(h);
unlink($agentFile);

$html = "Content-type:text/html\n\n" . $html;


$Group = $agentGroup;

print "... $allHits hits\n";

if ( $where eq 'MAIL' || $where eq 'SCREEN' ) {
$to = $email;
}
else {
$to = $WBB{'managerEmail'};
}

if ( $allHits > 0 ) {
$bo      = rand(10000000);
$bo      = "==========$bo";
$subject = "$allHits new hits in $ap[0]";    #UK
$ascii   = <<EOM;                            #UK
Attached is an HTML file with $allHits new records
from $WBB{'dbTitle'} database.

Here's an ASCII transcript:

$ascii

Regards,

Angie
EOM
$headers = <<EOM;
From: "WODA Aganet" <$WBB{'managerEmail'}>
Reply-to: $WBB{'managerEmail'}
To: $to
Subject: $subject
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary="$bo"
EOM

$message = <<EOM;
$headers

This is a multi-part message in MIME format.

--$bo
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit

$ascii
--$bo
$html
--$bo--
EOM

if ( $where eq 'SCREEN' ) {
$h = &htQuote($headers);
print <<EOM;
</pre>
<table class="DATATABLE" cellspacing="0"><tr><td>
<pre>$h
</pre></td></tr><tr><td>
<pre>$ascii</pre>
</td></tr></table>
<pre>
EOM
}
elsif ( $where ne 'NULL' ) {

if ( !&sendMail($message) ) {
push( @done, "$row{_formid} " . time );
print "... message sent to $to\n";
}
else {
print qq(... <em class="ERROR">ERROR: Sendmail to $to failed</em>\n);
}
}

}    # hits

}    # rows of one user

saveFormUpdateSince( $friend, @done );
print "Updated .forms file for $friend\n";

}    # all users

print "</pre>\n";
}


sub wbDo {

$_ = shift(@_);
"$WodaLibDir/$_.pl" unless defined &$_;    # load
&$_(@_);                                   # execute
}



sub formatHtm2Txt {    # only used by cgiAdmAgentProcess ??

local ($page) = @_;

local ( $row, $tag, $pad, $content, $x, @rows );

$asciiPage = '';

@rows = split( /</m, $page );
foreach $row (@rows) {
$row =~ tr/\n\r/  /;          # can't do multiline here
$row =~ m/^([^>]+)>(.*)$/;    # can't do multiline here
$tag     = "<$1>";
$content = $2;
$content =~ s/\&nbsp\;/ /gm;
$content =~ s/\&gt\;/>/gm;
$content =~ s/\&lt\;/</gm;
$content =~ s/\s+/ /gm;        # multiple space
$content =~ s/^\s//gm;         # leading space
$content =~ s/\s$/ /gm;        # trailing space

if ( $tag =~ /<title>|<option>|<\!\-\-/im ) {
next;
}
else {
}
if ( $tag =~ m/<p|<tr|<h1|<h2|<h3|<h4|<ol|<ul/im ) {
$pad = "\n\n";             # these \n\n will be removed in cgiAdmAgentProcess
}
elsif ( $tag =~ m/<li/m ) {
$pad = "\n\n[] ";          # these \n\n will be removed in cgiAdmAgentProcess
}
elsif ( $tag =~ m/<br/m ) {
$pad = "\n";
}
else {
$pad = "";
}
$asciiPage .= "$pad$content" if $pad || $content;
}
$asciiPage =~ s/ +/ /gm;
return $asciiPage;
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub hashRead {

local ($file) = @_;
local (@rows);
open( h, $file );
while (<h>) {
chop;
push( @rows, $_ );
}
close(h);

return @rows;
}


sub saveFormUpdateSince {

local ( $friend, @records ) = @_;
local ( @rows, $row, $r, $id, $time, %r );

open( h, "$DATADIR/_friend/$friend.forms" )
|| wbFail("Cannot open $DATADIR/_friend/$friend.forms");
@rows = <h>;
close(h);
foreach $row (@rows) {
chop($row);
hashImport( *r, $row );
@d = grep( /^$r{_formid} /, @records );
if (@d) {
( $x, $time ) = split( / /, $d[0] );
$r{since} = $time;
$row = &hashExport(*r);
}
}

open( h, ">$DATADIR/_friend/$friend.forms" );
binmode(h);
print h join( "\n", @rows );
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}
1;
