

sub cgiAdmCrons {

printHead("Required crontab entries");

print <<EOM;
<p><b>WARNING:</b> If you called
this function form a test database, then results are not valid.
You should run it from the real database!
EOM

print <<EOM;
<p>These tasks could be part of your crontab file:
EOM
$prog = &wbCronjob();

print "<pre><b>$prog</b></pre>";

print <<EOM;
<p>On systems that unlike UNIX do not support cron,
you should execute the above command once a day or
have "system agent" run it from time to time.
EOM

$crons = `$CRONTAB -l 2>&1`;
$x     = getpwuid($>);
if ( $crons =~ /allowed/ ) {
print <<EOM;
Cron jobs cannot be set automatically on this system.
You should ask the systm administrator to allow user
$x to run cron and at jobs by adding
<tt>$x</tt> to (usually)
<tt>/usr/lib/cron/cron.allow</tt> and to 
<tt>/usr/lib/cron/at.allow</tt>.
EOM
}
else {
print <<EOM;
<p> More options:
<ul>
<li><a href="$SCRIPT/AdmCronModify?action=add">
Add this to the Cron table now.
</a>
</li><li>
<a href="$SCRIPT/AdmCronModify?action=remove">
Remove this from the Cron table.
</a>
</li><li>
<a href="$SCRIPT/AdmAtNow">
Run this now using command '$AT'.
</a>
</li></ul>
EOM
}
}


sub wbCronjob {

$a = &wbAtjob();
return <<EOM;
0 1 * * * $a
EOM
}
1;
