

sub cgiAdmIndexPDF {

printHead("Converting records to indexable html");

print "<p>This will take some time!\n";

unless ( -x $PDFTOHTML ) {
wbFail( "Converter missing", "pdftohtml program not installed at '$PDFTOHTML'" );
return;
}

print "<pre>\n";

opendir( D, "$DATADIR/att" );
@atts = readdir(D);
closedir(D);

@pdfs = grep( /pdf$/i, @atts );

mkdir( "$DATADIR/_full",  0777 );
mkdir( "$DATADIR/_swish", 0777 );

foreach $pdf (@pdfs) {
$in  = $pdf;
$out = $in;
$out =~ s/\.pdf$//i;

$in  = "$DATADIR/att/$in";
$out = "$DATADIR/_full/$out.html";

print "$pdf ...";
if ( &wbMtime($in) > &wbMtime($out) ) {
print "converting\n";
system "$PDFTOHTML -noframes -i $in $out 2>&1";
}
else {
print "old.";
}
print "\n";
}


recAll();
while ( $id = &recNext() ) {
$hp = "$DATADIR/_full/$id.html";
print "metadata for $id.html";
if (1) {
recRead($id);
$then = $rec{_at};
$now  = ( stat($hp) )[9];
if ( $then < $now ) {
print "is old\n";
next;
}
print "IS NEW!!!\n";
open( cache, ">$hp" ) || wbFail("Cannot open file $hp");
binmode(cache);
$selected     = select(cache);
$HTMLFILE     = 1;
$CGI{_id}     = $id;
$group        = $Group;
$Group        = 'guest';
$IGNOREERRORS = 1;
wbDo("cgiShow");
undef @Toolbar;
delete $CGI{_id};
$Group    = $group;
$HTMLFILE = 0;
close(cache);
select($selected);
}
else {
recRead($id);
open( h, ">$hp" );
binmode(h);
$HTMLFILE     = 1;
$IGNOREERRORS = 1;
print h &wbRecHtml();
close(h);
}
}

print "<HR><B>Indexing ...<BR>\n";
print `$SWISH -i $DATADIR/_full -f $DATADIR/_swish/index`;
print "</pre>Done!";
}


sub wbDo {

$_ = shift(@_);
"$WodaLibDir/$_.pl" unless defined &$_;    # load
&$_(@_);                                   # execute
}
1;
