

sub cgiAdmManyEdit {

if ( $CGI{'format'} =~ m/^RAW|^TAB$|^TBL|^CSV|^RSS/ ) {    # why not XML
wbError("Records cannot be edited in $CGI{'format'} format");
}

if ( $CGI{'efields'} eq '' ) {
wbError("No fields were selected for editing");
}

cgiSearch();
}


sub cgiSearch {

return unless &saveFormToolbar();

local ($how) = @_;

$yh = $yf = 0;
$yh = 1 unless $how =~ m/H/;
$yf = 1 unless $how =~ m/F/;

$CGI{'search'} =~ tr/\n/ /;    # many search fields on line


if ( $CGI{'frames'} =~ /^H|^V/ ) {
printSearchFrames();
}
if ($InFrame) {
$MINIHEAD      = 1;
$TargetDetail  = 'target="woda_detail"';
$SuffixDetail  = "ToFrameD";
$TargetDefault = 'target="woda_detail"';
$SuffixDefault = "ToFrameD";
$TargetParent  = 'target="_parent"';
$SuffixSelf    = "ToFrameL";
$TargetSelf    = 'target="_self"';
}

$time = time;

if ( $CGI{'search'} =~ m/%20/ ) {
$CGI{'search'} = &htUnescape( $CGI{'search'} );
}

if ( $CGI{'cookie'} eq 'NEWS' ) {
$cookie = &htFormatCookie( 'NEWS', $time );
}
else {
$cookie = "";
}

( $isInHtmlFormat, $yh, $yf ) = &printSearchHttpHeader( $CGI{'format'}, $yh, $yf );

$criteria = '';
$op       = $CGI{'grouping'};
for ( $i = 1 ; $i <= $nCriteria ; $i++ ) {
$f = $CGI{"f:$i"};
next if $f eq '';
$e = $CGI{"e:$i"};
$v = $CGI{"v:$i"};

$e =~ s/x/$v/;
$criteria .= " {$f} $e $op";
}

$criteria =~ m/$op$/;
$criteria = $`;

$CGI{'search'} .= $criteria;


wbRememberSearch();

if ($yh) {
local ( $qs, $tt );
$qs = $ENV{'QUERY_STRING'};
$qs =~ s/&/&amp;/g;
$qs =~ s/format=[^&]*//;
$qs .= '&amp;format=RSS';
$qs =~ s/&amp;&amp;/&amp;/;
$MetaFields = <<EOM;
<link rel="alternate" title="This search as RSS feed" href="$SCRIPTBASE$SCRIPT/Search?$qs" type="application/rss+xml">
EOM
printHead( "Search Results", $cookie );    #UK
$MetaFields = '';
print "<div class=SEARCHTITLES>\n";
}


@fields  = split( /\s|,/, $CGI{'fields'} );
@efields = split( /\s|,/, $CGI{'efields'} );


foreach $f (@efields) {
$f{$f} = '?';    # edit ... override display
}


$fields = '';
foreach $f (@fields) {
if ( $f{$f} eq '?' ) {
$fields .= "?$f,";
delete $f{$f};
}
else {
$fields .= "$f,";
}
}


foreach $f ( keys(%f) ) {
$fields .= "?$f," if $f ne '_delete';
$fields = "_delete,$fields" if $f eq '_delete';
}

chop($fields);
$Log .= "Fields=$fields\n";
$CGI{'fields'} = $fields;    # needed in FormFieldItems
undef $f;


if (   $yh
&& $CGI{'search'}
&& $fields !~ /\b_delete\b/
&& $CGI{'noform'} eq '' )
{
$x = &wbSearchForm( $CGI{'search'} );
print $x;
}

$CGI{'first'} = 0                if !$CGI{'first'};
$CGI{'max'}   = $WBB{'dfltHits'} if !$CGI{'max'};
$CGI{'max'}   = $WBB{'maxHits'}  if $CGI{'max'} > $WBB{'maxHits'};


$CGI{'format'} = 'DEFAULT' unless $CGI{'format'};


if ( $CGI{'format'} eq 'DEFAULT' && !$WBB{'format;DEFAULT'} ) {

wbSortFields();

$f = '';
$i = 0;
foreach $x (@PFields) {
next if $x =~ m/^_/;
next if $WBF{ $x, 'type' } =~ m/BREAK|SUBMIT/;
if ( $WBF{ $x, 'type' } !~ /AREA/ ) {
$f .= "\$rec{'$x'} ;";
$i++;
}
last if $i == 5;
}
$f = "\"$f\"";
$WBB{'format;DEFAULT'} = $f;
}

$search = $CGI{'search'};
$sort = join( "\n", $CGI{'sort'}, $CGI{'sort1'}, $CGI{'sort2'}, $CGI{'sort3'} );
$sort =~ s/\n*$//g;

$then = 0;
$then = time - 24 * 3600 * $CGI{'days'} if $CGI{'days'};
$then = $CGI{'since'} if $CGI{'since'};

$search .= " {_at} > $then" if $then > 0;

$niceThen = '';
if ($then) {
$niceThen = "<p>Changes since " . &formatYMDHMS($then);    #UK
}


( $allHits, *list, *fields ) = &recSelect( '', $search, $sort, $CGI{'format'}, $fields, $CGI{'first'}, $CGI{'max'} );

$dataHits = $#list + 1;


$n = $CGI{'first'} + 1;
$m = $CGI{'first'} + $dataHits;


print $niceThen if $yh;
print "<p>" . &filterText() if $yh;

if ($dataHits) {
if ($yh) {
print "<p>Hits $n to $m of $allHits</p>";    #UK
}
}
else {
if ($yh) {
print '<p>No hits.</p>', "\n", '</div><!-- SEARCHTITLES -->';    #UK
wbHelpSearch();
return;
}
else {
if ( $CGI{'format'} =~ m/XML|RSS/ ) {

formatFoundSeparators( $CGI{'format'} );
print $t0;
print $t3;
}
wbLog();
wodaExit() unless $yf;
}
}

$more     = 0;
$newFirst = $CGI{'first'} + $CGI{'max'};
undef @first;

if ( $allHits != $dataHits ) {
$more = 1 if $allHits > $CGI{'first'} + $CGI{'max'};
$j = 0;
for ( $i = 0 ; $i < $allHits ; $i += $CGI{'max'} ) {
$first[$j] = $i;
$j++;
}
}


if ( $dataHits > 0 && $yh && !$InFrame ) {    # disabled

print '<div class="SEARCHREFORMAT">', "\n";
print "<p>Reformat results as: \n";       #UK

@altTexts = (
"short",                              #UK
"short into frame",                   #UK
"detailed",                           #UK
"detailed into frame"                 #UK
);

@formats = ( "DEFAULT", "DEFAULT", "LONG", "LONG" );
@frames  = ( "NONE",    "V33",     "NONE", "V" );

$qs = $ENV{'QUERY_STRING'};
$qs =~ s/\&/&amp;/g;

$qs =~ s/\&amp;format=\w+//;              # erase format info
$qs =~ s/\&amp;frames=\w+//;              # erase frames info
$i = 0;
foreach $x (@altTexts) {
$nqs = $qs . "&amp;format=$formats[$i]&amp;frames=$frames[$i]";

print <<EOM;
<a class="BUTTON" href="$SCRIPT/Search?$nqs" $TargetParent> $x </a>&nbsp;
EOM
$i++;
}

print "</p></div><!-- SEARCHREFORMAT -->\n";    # SEARCHREFORMAT

}

print "</div><!-- SEARCHTITLES -->\n" if $yh;       # SEARCHTITLES


$x    = $CGI{'first'} + 1;
$cgif = $CGI{'format'};
$head = &formatFoundHeader( $cgif, *fields );
formatFoundSeparators( $cgif, $x );

$hasBasketForm = !( $PrintingBasket || $HTMLFILE || !$WBB{'basketName'} );

if ( $#efields >= 0 ) {
$addAction = "AdmStoreMany";
$addMethod = "POST";
$addTarget = "";
$addButton = "Store changes to found records";    #UK
if ( $fields =~ m/^_delete/ ) {
$instr = "Check the leftmost checkbox of each record to mark it for deletion";    #UK
$js2   = &formatCheckAllJavaScript('_delete');
if ($js2) {
$js2 = "<p>$js2 Click here to check all/none for deletion.<br>";              #UK
}
}

}
elsif ($hasBasketForm) {
$addAction = "BasketAdd";
$addMethod = "GET";
$addTarget = <<EOM;
target="woda_basket" 
onSubmit='
a=window.open("","woda_basket","scrollbars=yes,resizable=yes,menubar=no,width=600,height=300");
if (document.images) self.name = "woda_opener";
a.focus();
'
EOM
$addButton = "Add checked items to $WBB{'basketName'}";    #UK
$js2       = '';

}
else {
$addAction = '';

}

$js1 = &formatFormJavaScript();

if ( $dataHits && $isInHtmlFormat ) {
print <<EOM if $addAction;
<p>
$js1
$instr
<form name="main" action="$SCRIPT/$addAction" $addTarget METHOD=$addMethod>
EOM
print '<div class="RECORDS">', $t0, $head;
foreach $_ (@list) {
print "$t1$_$t2";
}
print $t3;
print '</div>';
print <<EOM if $addAction;
$js2 <input class="BUTTON" type="submit" value="$addButton">
</form>
EOM

}
else {
print $t0, $head;    # 4.190
foreach $_ (@list) {
print "$t1$_$t2";
}
print $t3;           # 4.190
}

return unless $yf;       # if footer is required

@Toolbar = grep( /FormSave/, @Toolbar );


if (@first) {

print "<p>For more results click below:";    #UK
$qs = $ENV{'QUERY_STRING'};
unless ($qs) {                               # $qs may be empty because cgiHome sets CGI without passing data via URL
$qs .= "&search=$CGI{'search'}" if $CGI{'search'};
$qs .= "&sort=$CGI{'sort'}"     if $CGI{'sort'};
$qs .= "&max=$CGI{'max'}"       if $CGI{'max'};
}
$qs =~ s/&/&amp;/g;
$qs =~ s/\&amp;first=\d+//;

$tale = -1;
for ( $j = 0 ; $j <= $#first ; $j++ ) {
if ( $first[$j] == $CGI{'first'} ) {
$tale = $j;
last;
}
}

for ( $j = 0 ; $j <= $#first ; $j++ ) {

$newFirst = $first[$j];

if (   $j != 0
&& $j != $#first
&& $j != $tale
&& ( $tale - $j ) * ( $tale - $j ) > 25 )
{
if ( !$pikce ) {
push( @Toolbar, <<EOM);
...
EOM
$pikce = 1;
}
next;
}

$pikce = 0;
$qsn   = $qs . "&amp;first=$newFirst";
$pg    = "show page $j";                 #UK
$pg0   = "this is page $j";              #UK

if ( $j == $tale ) {
push( @Toolbar, <<EOM);
<img $ICONPAR src="$ICONURL/up.gif" title="$pg0" alt="$pg0">
EOM
}
elsif ( $j == 0 ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/first.gif" alt="$pg" title="$pg"></a>
EOM
}
elsif ( $j == $tale - 1 ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/back.gif" alt="$pg" title="$pg"></a>
EOM
}
elsif ( $j == $tale + 1 ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/forward.gif" alt="$pg" title="$pg"></a>
EOM

}
elsif ( $j == $#first ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/last.gif" alt="$pg" title="$pg"></a>
EOM

}
elsif ( $j < $tale ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/backg.gif" alt="$pg" title="$pg"></a>
EOM
}
elsif ( $j > $tale ) {
push( @Toolbar, <<EOM);
<a href="$SCRIPT/Search$SuffixSelf?$qsn" $TargetSelf><img  $ICONPAR  src="$ICONURL/forwardg.gif" alt="$pg" title="$pg"></a>
EOM
}
}
}
else {
if ($dataHits) {
print "<p>No more hits.";    #UK
}
}


local ( $s, $so, $fo );

$s  = &htEscape($search);
$so = &htEscape($sort);
$fo = &htEscape( $CGI{'format'} );

if ( &wbAllowed( $Group, 'AdmManyEditForm' ) && $#editable < 0 ) {

$text = "EDIT/DELETE all these records.";    #UK

push( @Toolbar, <<EOM);
<a href="$SCRIPT/AdmManyEditForm?$qs" $TargetParent>
<img $ICONPAR align="top" src="$ICONURL/editn.gif" alt="$text" title="$text"></a>
EOM
}

if ( &wbAllowed( $Group, 'AdmManySetForm' ) ) {

$text = "Set one field in these records to one value.";    #UK

push( @Toolbar, <<EOM);
<a href="$SCRIPT/AdmManySetForm?search=$s" $TargetParent>
<img $ICONPAR align="top" src="$ICONURL/editnf.gif" alt="$text" title="$text"></a>
EOM
}

if ( &wbAllowed( $Group, 'AdmMailForm' ) && $HasEmailField ) {

$text = "Send serial email to them.";                      #UK

push( @Toolbar, <<EOM);
<a href="$SCRIPT/AdmMailForm?search=$s" $TargetParent>
<img $ICONPAR align="top" src="$ICONURL/serialmail.gif" alt="$text" title="$text"></a>
EOM
}

if ( &wbAllowed( $Group, 'AgentAddForm' ) && !$agentFile ) {

$text     = "I want to subscribe to searches like this.";    #UK
$Formdata = &hashExport(*CGI);
$Formdata = &htEscape($x);

push( @Toolbar, <<EOM);
<a href="$SCRIPT/AgentAddForm?FORM=AgentAddForm&amp;formdata=$Formdata" $TargetParent>
<img $ICONPAR src="$ICONURL/angie.gif" alt="$text" title="$text"></a>
EOM
}

}


sub formatCheckAllJavaScript {

local ($field) = @_;

return '' unless $JS;

local ( $alltext, $nonetext );

$alltext  = "check all";     #UK
$nonetext = "check none";    #UK
return <<EOM;
<a href="javascript:allBoxes('$field',1)"><img src="$ICONURL/check.gif" $ICONPAR alt="$alltext" title="$alltext"></a>&nbsp;
<a href="javascript:allBoxes('$field',0)"><img src="$ICONURL/uncheck.gif" $ICONPAR alt="$nonetext" title="$nonetext"></a>
EOM
}


sub wbHelpSearch {

wbHelps();
print "<ul>\n";
foreach $help (@helps) {
print "<li>$help</li>\n";
}

print <<EOM;    #UK
</ul>
<p>
<b>
<a href="$WodaHelpURL#search">Detailed search help.</a>
</b>
EOM
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub saveFormToolbar {


if ( $CGI{'saveform'} ne '' ) {
delete $CGI{'saveform'};
$CGI{'formdata'} = &hashExport(*CGI);
cgiFormSave();
return 0;    # caller must return too
}


if ( $CGI{'_form'} ) {
$x        = &hashExport(*CGI);
$x        = &htEscape($x);
$Formdata = $x;
push( @Toolbar, <<EOM) if &wbAllowed( $Group, 'FormSave' ) && !$agentFile;
<a href="$SCRIPT/FormSave?formdata=$Formdata"><img $ICONPAR src="$ICONURL/formsave.gif" alt="Save form data" title="Save form data" $TargetParent></a>
EOM
}

return 1;

}


sub cgiFormSave {

printHead("Saving form data");    #UK

$eFormdata = &htQuote( $CGI{'formdata'} );

hashImport( *x, $CGI{'formdata'} );

$x{_formname} = $CGI{'_formname'};

if ( $x{_formname} eq '' ) {

%y = %x;
foreach $key ( keys(%y) ) {
delete $y{$key} if $y{$key} eq '';
}

$h = &formatHash( "Parameters to be saved are:", 1, %y );    #UK

$a = "Define name";                                          #UK
$p = "Save";                                                 #UK
$b = <<EOM;                                                  #UK
<form action="$SCRIPT/FormSave">
Before a form can be saved, it must be named:<br>
<input name="_formname" size="30">
<input type="hidden" name="formdata" value="$eFormdata">
&nbsp;
<input class="BUTTON" type="submit"  value="Save">
</form>
$h
EOM
print &formatWindow( $a, $b );
return;
}
else {
$formdata = &hashExport(*x);


saveFormAppend($formdata);
$dform = $x{_form};

saveFormSavedMessage($dform);
}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub formatHash {

local ( $name, $quote, @hash ) = @_;
local ( $out, $n, $v, %x );

$out .= <<EOM;
<table>
<tr class="DATAH" >
<th COLSPAN=2>$name</th>
</tr>
EOM

%x = @hash;
foreach $n ( sort( keys(%x) ) ) {
$v = $x{$n};
$v = &htQuote($v) if $quote;
$out .= <<EOM;
<tr class="DATA1" >
<td align="right">$n</td>
<td align="left">&nbsp;$v</td>
</tr>
EOM
}

$out .= <<EOM;
</table>
EOM

undef %x;
return $out;
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub formatFoundSeparators {

local ( $format, $n ) = @_;

if ( $format eq 'CSV' || $format eq 'CSVS' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'TAB' ) {
$t0 = "<XMP>\n";
$t1 = "";
$t2 = "\n";
$t3 = "</XMP>\n";
}
elsif ( $format eq 'RAW' ) {
$t0 = "";
$t1 = "";
$t2 = "\n";
$t3 = "";
}
elsif ( $format eq 'XML' || $format eq 'XMLE' ) {
$t0 = "<!DOCTYPE records>\n<records>\n";
$t1 = "";
$t2 = "";
$t3 = "</records>\n";
}
elsif ( $format eq 'RSS' ) {
$x  = &htUntag("$WBB{'apTitle'} - $WBB{'dbTitle'}");
$x  = &htQuote($x);
$y  = &htQuote( $WBB{'about'} );
$t0 = <<EOM;
<rss version="0.91">
<channel>
<title>$x</title>
<link>$SCRIPTBASE$SCRIPT</link>
<description>$y</description>
<language>en-us</language>
EOM
$t1 = "";
$t2 = "";
$t3 = <<EOM;
</channel>
</rss>
EOM
}
elsif ( $format eq 'TABLE' ) {
$t0 = '<table class="DATATABLE" cellspacing="1">"\n"';
$t1 = "";
$t2 = "";
$t3 = "</table><br>\n";
}
elsif ( $format eq 'LONG' || $format eq 'NAMEVAL' ) {
$t0 = "";
$t1 = "";
$t2 = "<hr>\n";
$t3 = "";
}
elsif ( $format eq 'DEFAULT' || $format =~ m/^\d$/ ) {
$t0 = &evalMaybe( $WBB{"formatHead$format"} );
$t1 = '';
$t2 = '';
$t3 = &evalMaybe( $WBB{"formatFoot$format"} );
}
elsif ( $format eq 'PARAGRAPH' ) {
$t0 = '';
$t1 = '';
$t2 = '';
$t3 = '<br><br>';
}
}


sub filterText {

@x = split( /\n/, $WBB{'filterText'} );    # only do it on self
foreach $_ (@x) {
( $group, $text ) = split( /\s+/, $_, 2 );
if ( $group eq $Group ) {
return $text;
}
}
}


sub printSearchHttpHeader {

local ( $format, $yh, $yf ) = @_;
local ( $html, $x );

if ( $format =~ m/^(\d+)$/ && $WBB{"formatHttpHead$1"} ne '' ) {
$x = $WBB{"formatHttpHead$1"};
$x =~ s/\n*$//g;    # remove trailing newlines
print "$x\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head or foot stuff for sure
}
elsif ( $format =~ m/^CSV/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^TAB$/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^RAW$/ ) {
print "Content-type: text/plain\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^XML/ ) {
printXmlHead() if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
elsif ( $format =~ m/^RSS/ ) {
print "Content-type: text/xml\n\n" if $yh;
$html = $yh = $yf = 0;    # no more head of foot stuff for sure
}
else {
$html = 1;
}

return ( $html, $yh, $yf );

}


sub printXmlHead {
$e = $WBB{'intlCharset'} || 'UTF-8';
print $HTTP200OK;
print "Content-type: text/xml\n\n";
print <<EOM;
<?xml version="1.0" encoding="$e" standalone="yes" ?>
EOM
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub formatFoundHeader {

local ( $format, *fields ) = @_;
local ( $f, $hd, $ft );

@fields = &visibleFields(@fields);

if ( $format eq 'TABLE' ) {
$hd = '<tr class="DATAH" ><th>&nbsp;</th>' . "\n";
}
else {
$hd = '';
}

foreach $f (@fields) {
if ( $format eq 'TABLE' ) {
$x = &formatFieldName($f);
$hd .= '<th align="left">' . $x . '</th>';
}
elsif ( $format eq 'TAB' ) {
$hd .= "$f\t";
}
elsif ( $format eq 'CSV' ) {
$hd .= "$f,";
}
elsif ( $format eq 'CSVS' ) {
$hd .= "$f;";
}
}

if (   $format eq 'TAB'
|| $format eq 'CSV'
|| $format eq 'CSVS' )
{
chop($hd);
}

if ( $format eq 'TABLE' ) {
$hd .= "</tr>";
}

$hd .= "\n" if $hd ne '';

return $hd;
}


sub printSearchFrames {

$how = 'COLS' if $CGI{'frames'} =~ m/^V(.*)$/;
$how = 'ROWS' if $CGI{'frames'} =~ m/^H(.*)$/;
$proc = $1 || 50;

$qs = $ENV{'QUERY_STRING'};
$qs =~ s/frames\=.//;

print $HTTP200OK . "Content-type: text/html\n\n";
print <<EOM;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<head>
<title>Search Results in Frames</title>
</head>
<frameset $how="$proc%,*">
<frame src="$SCRIPT/SearchToFrameL?$qs" name="woda_list">
<frame src="$ICONURL/poweredby.gif" name="woda_detail">
</frameset>
<noframes>
EOM

print <<EOM;    #UK
Your browser should support frames to use this type of search.
EOM

print "</noframes>\n";
wodaExit();
}


sub wbRememberSearch {

if ( &wbAllowed( $Group, 'SearchHistory' ) && $CGI{'search'} ne '' ) {
wbSearchHistoryAdd( $CGI{'search'} );
}

}


sub wbSearchHistoryAdd {

local (@s);

@s = &wbSearchHistoryGet();

foreach $s (@s) {
return if ( $s eq $_[0] );
}

unshift( @s, $_[0] );

if ( $#s > 9 ) {
@s = $s[ 0 - 9 ];
}

return if $User =~ m/^_anon/;

open( h, ">$DATADIR/_friend/$User.srch" );
print h join( "\n", @s );
print h "\n";
close(h);
}


sub formatFormJavaScript {

local ($fname) = @_;    # name of the form

return '' unless $JS;

$fname = $fname || 'main';

return <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

// check all or none of the checkboxes
function allBoxes(name,n) {
for (var i=0; i<document.forms['$fname'].elements[name].length; i++) document.forms['$fname'].elements[name][i].checked=n;
}

// validate form element if it is a regular expression
function validText(name,expression,message) {

myRe = expression;
if (myRe.test(name.value)) {
return
} else {
alert(message)
}
}	


// --></script>
EOM
}
1;
