

sub cgiAdmManyEditForm {

return
unless &saveFormCan('AdmManyEditForm');    # sets $SaveFormButton, sets %CGI

printHead('Edit many fields at once');       #UK
wbAdvancedSearchForm('EDIT');
}


sub saveFormCan {

local ($caller) = @_;


if ( $CGI{'formdata'} ne '' ) {
hashImport( *CGI, $CGI{'formdata'} );
delete $CGI{'_formid'};
delete $CGI{'_formname'};
delete $CGI{'_form'};
}

if ( $CGI{'listall'} ne '' ) {
cgiFormsList($caller);
return 0;
}

$sfa            = 'Save form as';    #UK
$SaveFormButton = <<EOM;
<input type="hidden" name="_form" value="$caller"><input class="BUTTON" type="submit"  name="saveform" value="$sfa">
<input name="_formname" size="15">
EOM


@rows = &hashRead("$DATADIR/_friend/$User.forms");
@rows = grep( /_form.$caller/, @rows );

if ( $#rows >= 0 ) {

$select = '<option value="">';
foreach $row (@rows) {
hashImport( *x, $row );
if ( $x{_formid} eq $CGI{'select'} ) {
%CGI = %x;
$d   = 'SELECTED';
}
else {
$d = '';
}
$x = $x{_formname};
$select .= qq(<option value="$x{_formid}" $d>$x);
}

$SaveFormForm = <<EOM;
<form class="FORM" action="$SCRIPT/$caller">
Archived forms: <select name="select">
$select
</select>
<input class="BUTTON" type="submit"  value="Load">
<input class="BUTTON" type="submit"  name="listall" value="List all">
</form>
EOM

}
else {

$SaveFormForm = '';

}

return 1;
}


sub cgiFormsList {

$dform = $CGI{'form'};

if ($dform) {
printHead("Saved forms of user $User related to $dform");    #UK
}
else {
printHead("All saved forms of user $User");                  #UK
}

@rows = &hashProcess("$DATADIR/_friend/$User.forms");

print <<EOM;
<p>Click on delete icons to delete archived form.
<p>
EOM


print '<table class="DATATABLE" cellspacing="1">', "\n";

foreach $row (@rows) {
undef %hash;
hashImport( *hash, $row );
next if $dform && $hash{_form} ne $dform;
$id   = $hash{_formid};
$form = $hash{_form};
$name = $hash{_formname};
print <<EOM;
<tr class="DATA0"  valign="top">
<td>
<a href="$SCRIPT/FormsList?delete=$id">
<img $SMALLICONPAR src="$ICONURL/del.gif" alt="Delete this form" title="Delete this form"></a>
</td>
<td align="right">
$form
</td>
<td>
<a href="$SCRIPT/$form?select=$id">$name</a>
</td>
<td>
EOM

foreach $key ( sort( keys(%hash) ) ) {
next if $key =~ m/^_formid|^_form|^_formname|^_confirm/;
$val = $hash{$key};
$val = &htQuote($val);
print "<b>$key</b>=$val\n" if $val;
}

print "</td></tr>\n";

}

print "</table>";
}


sub hashProcess {

local ($file) = @_;

@rows = &hashRead($file);
@rows = &hashDelete(@rows);
hashWrite( $file, *rows );

return @rows;
}


sub hashDelete {

local (@rows) = @_;
local (@out);

foreach $row (@rows) {
$row =~ m/_formid.(\d+)/;
next if $CGI{'delete'} eq $1;
push( @out, $row );
}
return @out;
}


sub hashRead {

local ($file) = @_;
local (@rows);
open( h, $file );
while (<h>) {
chop;
push( @rows, $_ );
}
close(h);

return @rows;
}


sub hashWrite {

local ( $file, *rows ) = @_;
open( h, ">$file" );
binmode(h);
foreach $_ (@rows) {
print h $_ . "\n";
}
close(h);
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub wbAdvancedSearchForm {

local ($how) = @_;                              # EDIT | SEARCH


@vals = ( "DEFAULT", "TIME" );
@texts = ( "by number of matches", "new items first" );    #UK

@x = keys(%WBB);
@x = grep ( /^sortName;/, @x );
foreach $_ (@x) {
$n = $WBB{$_};
( $s, $text ) = split(/;/);
push( @vals,  $text );
push( @texts, $n );
}

push( @texts, "by fields selected below (A-Z)" );    #UK
push( @vals,  "DYNAMICAZ" );

push( @texts, "by fields selected below (Z-A)" );    #UK
push( @vals,  "DYNAMICZA" );

push( @texts, "by a field selected below (0-9)" );    #UK
push( @vals,  "DYNAMIC09" );

push( @texts, "by a field selected below (9-0)" );    #UK
push( @vals,  "DYNAMIC90" );

$sorts = &wbFormatOptions( *vals, *texts, $CGI{'sort'} );


if ( $CGI{'format'} ) {
$df = $CGI{'format'};
}
elsif ( $how =~ m/EDIT/ ) {
$df = 'TABLE';
}
else {
$df = '';
}

$formats = &formatFormats($df);    # OPTION LIST READY


@vals = ( "NONE", "V", "V66", "V33", "H" );
@texts = (
"no frames",                   #UK
"vertical",                    #UK
"vertical - small detail",     #UK
"vertical - big detail",       #UK
"horizontal"                   #UK
);

$frames = &wbFormatOptions( *vals, *texts, $CGI{'frames'} );


wbSortFields();
undef @flds;
foreach $x (@PFields) {
next if $Hidden{$x};
next if $x eq '_passswd';
$ch = '';
if ( $CGI{'fields'} eq '' ) {
$ch = 'CHECKED' unless $x =~ m/^_/;
}
else {
$ch = 'CHECKED' if $CGI{'fields'} =~ m/\b$x\b/;
}
push( @flds, qq(<input name="fields" value="$x" type="checkbox" $ch>&nbsp;$x \n) );
}
push( @flds, &formatCheckAllJavaScript('fields') );
$flds = &formatColumns( 3, @flds );


undef @flds;
foreach $x (@IFields) {
$ch = '';
next if $x =~ m/^_/;
$ch = '';
if ( $CGI{'efields'} eq '' ) {

}
else {
$ch = 'CHECKED' if $CGI{'efields'} =~ m/\b$x\b/;
}
push( @flds, qq(<input name="efields" value="$x" type="checkbox" $ch>&nbsp;$x \n) );
}

push( @flds, &formatCheckAllJavaScript('efields') );
$eflds = &formatColumns( 3, @flds );


$fieldPull = "<option>\n";
foreach $x (@IFields) {
next if $Hidden{$x};
$fieldPull .= "<option value=\"$x\">$x\n";
}


$x           = $CGI{"sort1"};
$fieldPullS1 = $fieldPull;
$fieldPullS1 =~ s/\"$x\"/$& SELECTED/ if $x ne '';

$x           = $CGI{"sort2"};
$fieldPullS2 = $fieldPull;
$fieldPullS2 =~ s/\"$x\"/$& SELECTED/ if $x ne '';

$x           = $CGI{"sort3"};
$fieldPullS3 = $fieldPull;
$fieldPullS3 =~ s/\"$x\"/$& SELECTED/ if $x ne '';

$opPull = <<EOM;
<option value="&amp;&amp;">and
<option value="||">or
<option value=")&amp;&amp;">)and
<option value=")&amp;&amp;(">)and(
<option value=")">)
EOM

$brPull = <<EOM;
<option>
<option>(
EOM

$grouping = <<EOM;    #UK
<select name="grouping">
<option value="and">satisfy all of the above
<option value="or">satisfy any of the above
</select>
EOM

$grouping =~ s/\"$CGI{'grouping'}\"/$& SELECTED/;

$exprPull = <<EOM;    #UK
<option value="">
<option value="=~ m/x/i">contains
<option value="!~ m/x/i">not contains
<option value="=~ m/^x/i">begins with
<option value="=~ m/x\$/i">ends with
<option value="=~ m/x/i">matches regexp.
<option value="!~ m/x/i">does not match regexp.
<option value=' eq ""'>is blank
<option value=' ne ""'>is not blank
<option value='eq "x"'>as string equal to
<option value='ne "x"'>as string not equal to
<option value='gt "x"'>as string greater than
<option value='lt "x"'>as string lesser than
<option value="=~ x">=~
<option value="== x">==
<option value="!= x">!= 
<option value="&gt; x">&gt; 
<option value="&lt; x">&lt;
<option value="&lt;= x">&lt;=
<option value="&gt;= x">&gt;= 
EOM

$sex = '';
for ( $i = 1 ; $i <= $nCriteria ; $i++ ) {
$x = <<EOM;
<select name="f:$i">
$fieldPull
</select>
<select name="e:$i">
$exprPull
</select>
<input name="v:$i" size="15">
<br>
EOM


$y = $CGI{"f:$i"};
$x =~ s/\"$y\"/$& SELECTED/;

$y = $CGI{"e:$i"};
$x =~ s/\"$y\"/$& SELECTED/;

$y = $CGI{"e:$i"};
$x =~ s/\'$y\'/$& SELECTED/;

$y = $CGI{"v:$i"};
$x =~ s/\"v:$i\"/$& value=\"$y\"/;

$x =~ s/SELECTED SELECTED/SELECTED/g;

$sex .= $x;
}

$sex .= $grouping;

@p = (
"Search for",                                                                                 #UK
"Search!",                                                                                    #UK
"Enter space separated list of words.",                                                       #UK
"Sorting",                                                                                    #UK
"Formatting",                                                                                 #UK
"Frames",                                                                                     #UK
"Results per page",                                                                           #UK
"Where applicable print the following fields",                                                #UK
"Additional search criteria<br>They are applied on records satisfying the list of words.",    #UK
"Fields to edit",                                                                             #UK
"Password to unlock fields to edit",                                                          #UK
"Enable deleting records",                                                                    #UK
"Max age of data in days",                                                                    #UK
"Paint&nbsp;found&nbsp;words"                                                                 #UK
);

$xby  = 'by';                                                                                     #UK
$xand = 'then ';                                                                                  #UK

if ( $how eq 'EDIT' ) {
$action = "AdmManyEdit";
$p[0]   = "Find and edit!";                                                                   #UK
$p[1]   = $p[0];
$pass   = qq(<input type="password" size="20" name="_password");
}
else {
$action = "Search";
}

$s = $CGI{'search'};

if ( $how =~ m/EDIT/ ) {
$paint = '';
}
else {
$paint = 'CHECKED';
}

$js = &formatFormJavaScript('searchForm');
$sf = &wbSearchForm( $CGI{'search'}, 'HISTORY' );

$max = $CGI{'max'} || 20;

print <<EOM;
$SaveFormForm
$js
<form class="FORM" name="searchForm" action="$SCRIPT/$action">
<table cellspacing="0"><tr>
<td align="right" valign="top" width="30%">$p[0]:</td>
<td>$sf
<input class="BUTTON" type="submit" value="$p[1]">
</td></tr>

<tr>
<td align="right" valign="top">$p[13]:</td>
<td><input type="checkbox" name="paint" $paint></td>
</tr>

<tr>
<td align="right" valign="top">$p[8]:</td>
<td>$sex</td>
</tr>

<tr><td align="right" valign="top">$p[12]:</td>
<td><input name="days" size="8" value="$CGI{'days'}">
</td></tr>

<tr><td align="right" valign="top">$p[3]:</td>
<td><select name="sort">
$sorts
</select>

<br><select name="sort1">$fieldPullS1</select>
$xand <select name="sort2">$fieldPullS2</select>
$xand <select name="sort3">$fieldPullS3</select>
</td></tr>

<tr><td align="right" valign="top">$p[4]:</td>
<td><select name="format">
$formats
</select>
</td></tr>

<tr><td align="right" valign="top">$p[5]:</td>
<td><select name="frames">
$frames
</select>
</td></tr>

<tr><td align="right" valign="top">$p[6]:</td>
<td><input name="max" value="$max" size="8">
</td></tr>

<tr><td align="right" valign="top">$p[7]:</td>
<td>$flds</td>
</tr>
EOM

if ( $how eq 'EDIT' ) {
print <<EOM;
<tr><td align="right" valign="top">$p[11]:</td>
<td><input type="checkbox" name="efields" value="_delete" CHECKED></td>
</tr>

<tr><td align="right" valign="top">$p[9]:</td>
<td>$eflds</td>
</tr>

<tr><td align="right" valign="top">$p[10]:</td>
<td>$pass</td>
</tr>
EOM
}

print <<EOM;
<tr><td>&nbsp</td>
<td><input class="BUTTON" type="submit" value='$p[1]'> $SaveFormButton</td>
</tr>
</table>
</form>
EOM

}


sub formatCheckAllJavaScript {

local ($field) = @_;

return '' unless $JS;

local ( $alltext, $nonetext );

$alltext  = "check all";     #UK
$nonetext = "check none";    #UK
return <<EOM;
<a href="javascript:allBoxes('$field',1)"><img src="$ICONURL/check.gif" $ICONPAR alt="$alltext" title="$alltext"></a>&nbsp;
<a href="javascript:allBoxes('$field',0)"><img src="$ICONURL/uncheck.gif" $ICONPAR alt="$nonetext" title="$nonetext"></a>
EOM
}


sub formatFormJavaScript {

local ($fname) = @_;    # name of the form

return '' unless $JS;

$fname = $fname || 'main';

return <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

// check all or none of the checkboxes
function allBoxes(name,n) {
for (var i=0; i<document.forms['$fname'].elements[name].length; i++) document.forms['$fname'].elements[name][i].checked=n;
}

// validate form element if it is a regular expression
function validText(name,expression,message) {

myRe = expression;
if (myRe.test(name.value)) {
return
} else {
alert(message)
}
}	


// --></script>
EOM
}


sub wbSearchForm {

local ( $sstring, $elements ) = @_;
local ( $js, @s );
if ( $elements eq '' ) {
$elements = 'FORM,PROMPT,HELP,HISTORY';
}

local ( $prompt, $help, $button, $size );

$prompt = "Search for:";    #UK
$verb   = "Search";         #UK
$help   = "Tip: ";          #UK

$s = &htEscape( $CGI{'search'} );
$help .= &formatSearchHelp();
$help .= qq(<br>More: <a href="$SCRIPT/HelpSearch">all tips and help</a>);    #UK
$help .= ' ';
if (   &wbAllowed( $Group, 'AdvancedSearchForm' )
|| &wbAllowed( 'friend', 'AdvancedSearchForm' ) )
{
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/AdvancedSearchForm?search=$s">advanced search</a>
EOM
}

if ( &wbAllowed( $Group, 'FullTextSearch' ) && &canFullTextSearch() ) {
$help .= <<EOM;                                                           #UK
<a href="$SCRIPT/FullTextSearch?search=$s">full text search</a>
EOM
}

$size = length($sstring) || 40;
$size = 40 if $size < 40;


$help = '<span class="HINT">' . $help . '</span>';


$help   = '' unless $elements =~ m/HELP/;
$prompt = '' unless $elements =~ m/PROMPT/;
$histjs = '';
$histbut = '';

if ( $elements =~ m/HISTORY/ ) {


@s  = &wbSearchHistoryGet();
$ns = 0;
$js = '';
$n  = 1;
foreach $s (@s) {
next if $s eq '';
$s =~ s/\"/\\\"/g;
$js .= qq(\ts[$n] = "$s";\n);
$ns++;
$n++;
}

if ( $ns > 0 ) {
$histjs = <<EOM;
<script LANGUAGE="JavaScript" type="text/javascript"><!--

ns = $ns;
cs = 0;
s = new Array();
$js

function next () {
cs=cs+1;
if (cs > ns) {
cs = 1;
}
document.searchForm.search.value = s[cs];
}

function prev () {
cs = cs - 1;
if (cs <= 0) {
cs = ns;
}
document.searchForm.search.value = s[cs];
}

//--></script>
EOM

$p = "Previous search";
$n = "Next search";
$a = "All previous searches";
$s = "Saved forms";

$histbut = '';
$histbut = <<EOM if $JS && $ns > 0;
<a href="javascript:prev()"><img src="$ICONURL/back.gif" $ICONPAR align="top" alt="$p" title="$p"></a>
<a href="javascript:next()"><img src="$ICONURL/forward.gif" $ICONPAR align="top" alt="$n" title="$n"></a>
EOM

$histbut .= <<EOM;
<a href="$SCRIPT/SearchHistory"><img src="$ICONURL/last.gif" $ICONPAR align="top" alt="$a" title="$a"></a>
<a href="$SCRIPT/FormsList"><img src="$ICONURL/save.gif" $ICONPAR align="top" alt="$s" title="$s"></a>
EOM

}
}

$ss = &htQuote($sstring);

$x = <<EOM;
$histjs
$prompt
<input name="search" size="$size" value="$ss">
$histbut
EOM

if ( $elements =~ m/FORM/ ) {
return <<EOM;
<form action="$SCRIPT/Search" name="searchForm">
<table class="SEARCHBOX" cellspacing="0" width="100%">
<tr><td>
$x
<input type="hidden" name="paint" value="1">
<input type="hidden" name="_form" value="AdvancedSearchForm">
<input class="BUTTON" type="submit" value="$verb">
</td></tr><tr><td>
$help</td></tr>
</table>
</form>
EOM
}
else {
return $x;
}
}


sub formatSearchHelp {

local ( @helps, $help, $i );
wbHelps();
$i = int( rand(6.99) );
return $helps[$i];
}


sub wbHelps {

if ( $WBB{'searchHelp'} ) {
$help = $WBB{'searchHelp'};
}
else {
$help = <<EOM;    #UK
Type <b>car vehicle automobile</b> to search for any of the words.
Type <b>"New York" car</b> to search for 'New York' or 'car'.
Type <b>new +car</b> to find only records which do contain 'car' and may contain word 'new'.
Type <b>-used car vehicle</b> to find only records which contain words 'car' or 'vehicle' but not 'used'.
Type <b>n?w</b> to find 'now' and 'new'.
Type <b>car*</b> to find 'car' and 'cardinal'.
Type <b>*car</b> to find 'vicar' and 'car'.
Type <b>*car*</b> to find 'vicar', 'cardinal' and 'car'.
Type <b>" car "</b> or "<b>\\scar\\s</b>" to find 'car' and not 'vicar' or 'cardinal'.
Type <b>+email:uni-lj</b> to search for 'uni-lj' in the email field only.
Type <b>-email:edu</b> to find records which do not have word 'edu' in the email field only.
Type <b>=lastName:Turk</b> to find records with lastName field exactly equal to Turk. 
Type <b>/lastName:Turk</b> to find records with one line of lastName field exactly equal to Turk. 
Type <b>{price} < 2000</b> to search for items with price field less than 2000.
EOM
}

@helps = split( /\n/, $help );

}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}


sub canFullTextSearch {

return ( -x $SWISH && -s "$DATADIR/_swish/index" );

}


sub wbFormatOptions {

local ( *v, *t, $default ) = @_;
local ( $nItems, $i );

$nItems = $#v;
$_      = '';
foreach ( $i = 0 ; $i <= $nItems ; $i++ ) {
if ( $default ne '' && $default eq $v[$i] ) {
$_ .= "<option value=\"$v[$i]\" SELECTED>$t[$i]\n";
}
else {
$_ .= "<option value=\"$v[$i]\">$t[$i]\n";
}
}

return $_;
}


sub formatFormats {

local ($selected) = @_;
local ( @vals, @texts, @v, @t );

$selected = 'DEFAULT' unless $selected;

@vals = ( "DEFAULT", "LONG", "PARAGRAPH", "TABLE", "CSV", "CSVS", "TAB", "XML", "XMLE", "RSS" );
@texts = (
"default short format",                 #UK
"default detailed format",              #UK
"paragraph of all selected fields",     #UK
"table format - one record per row",    #UK
"comma delimited format (.csv)",        #UK
"semicolon delimited format (.csv)",    #UK
"tab delimited format",                 #UK
"XML format",                           #UK
"easy to parse XML",                    #UK
"RSS 0.91",                             #UK
);

if ( $WBB{'detail'} ) {
push( @vals,  "NAMEVAL" );
push( @texts, "custom detailed format" );    #UK
}

@x = keys %WBB;
@x = grep ( /^formatName\d+/, @x );
foreach $_ (@x) {
$v = $WBB{$_};
$_ =~ m/^formatName/;
$text = $';
$formats .= qq(<option value="$text">$v\n);
unshift( @vals,  $text );
unshift( @texts, $v );
}


for ( $vi = 0 ; $vi <= $#vals ; $vi++ ) {
$v = $vals[$vi];
if ( &wbAllowed( $Group, 'Search', "format=$v" ) ) {
push( @v, $v );
push( @t, $texts[$vi] );
}
}

$formats = &wbFormatOptions( *v, *t, $selected );

return $formats;
}
1;
