

sub cgiAdmManySet {

printHead("Set field $CGI{'_field'} to new value");

if ( $CGI{'_records'} ) {

$CGI{'_records'} =~ s/\r//g;
@recToChange = split( /\n/, $CGI{'_records'} );
}
elsif ( defined $CGI{'search'} ) {
wbRememberSearch();
( $allHits, *list, *fields ) = &recSelect( '', $CGI{'search'}, '', 'RAW', '_id' );
@recToChange = @list;
}
else {
readBasket();
@recToChange = @BasketID;
}

if ( $#recToChange == -1 ) {
wbError("No records found");
}

$fldToChange{ $CGI{'_field'} } = 1;
foreach $rec (@recToChange) {
$changeTo{ $rec, $CGI{'_field'} } = $CGI{ $CGI{'_field'} };
}

if ( $CGI{'_action'} eq 'Preview' ) {
admStoreMany(1);
}
else {
admStoreMany(0);
}
}


sub admStoreMany {


local ($pretend) = @_;

print '<p class="WARN">Preview only - nothing was actually written.</p>', "\n"
if $pretend;


foreach (@recToChange) {
$oldID = $_;

recRead($oldID);
if ( $rec{'_id'} eq '' ) {
print qq(<p><hr><em class="ERROR">Record $oldID not found!</em>\n);
next;
}
$skipRec = 1;
$x       = qq(<p><hr>Changes in record <a href="$SCRIPT/Show?_id=$oldID">$oldID</a>:);
foreach $key ( keys(%fldToChange) ) {    # each fld to be changed
if ( $rec{$key} ne $changeTo{ $oldID, $key } ) {

$x .= "<br><b>$key</b> from: $rec{$key}\n";
$x .= "<br><b>$key</b> into: $changeTo{$oldID,$key}\n";
$rec{$key} = $changeTo{ $oldID, $key };
$skipRec = 0;                    # yes, there will be a change
}
}

print $x;
next if $skipRec;


wbCheckDir($TMPDIR);
$tmpID = &tmpID();
recWriteFile("$TMPDIR/$tmpID.rec");

$newID = $oldID;
$newID = &evalWBBkey() || $newID;

if ( $newID ne $oldID ) {
print qq(<br><em class="ERROR">ERROR: Edits would cause an ID change to $newID.</em>\n);
next;
}



recReadFile("$TMPDIR/$tmpID.rec");

if ( !%rec ) {
wbError( "Data missing", "The submitted data in $TMPDIR/$tmpID.rec could not be read" );
return;
}

recSetSystem();
$rec{'_id'} = $oldID;
recWrite() unless $pretend;
recRead($oldID);

if ( !%rec ) {
wbError("Database Update Failed") unless $pretend;    #UK
}

unlink("$TMPDIR/$tmpID.rec");
print "<br>stored!\n" unless $pretend;
wbRecordChanged()     unless $pretend;
wbDatabaseChanged()   unless $pretend;
}

print '<hr>';

$CGI{'_delete'} =~ s/\r//g;
@todelete = split( /\n/, $CGI{'_delete'} );
foreach $id (@todelete) {
recRead($id);    # we may need %rec
recDelete($id) unless $pretend;
wbDatabaseChanged();    # here !
print "<br>$id deleted.\n";
}

print qq(<p class="WARN">Preview only - nothing was actually written.</p>\n)
if $pretend;

}



sub recSetSystem {


local ($from);
$from         = $RH;
$from         = $RA if !$from;
$rec{'_from'} = $from;


$rec{'_at'} = time;

}


sub wbDatabaseChanged {

if ( $WBB{'afterTableModify'} ne '' ) {
&evalSafe( $WBB{'afterTableModify'} );
}

}


sub tmpID {

local ($id);
while (1) {
$id = &wbRandKey();
last unless -e "$TMPDIR/$id.rec";
}
return $id;
}


sub wbRandKey {

local ($n) = $_[0];
local (@a) = ( 0 .. 9, 'a' .. 'f' );
local ( $x, $n, $c, $o, $base, @c, $i );
$base = $#a + 1;

$n = $n || 4;
$x = $base**$n;
$x = int( rand($x) );

for ( $i = 1 ; $i <= $n ; $i++ ) {
$o     = $x % $base;
$c[$i] = $a[$o];
$x     = int( $x / $base );
}

return ( join( '', @c ) );
}


sub wbRecordChanged {

if ( $WBB{'afterRecordModify'} ne '' ) {
&evalSafe( $WBB{'afterRecordModify'} );
}
}


sub recDelete {

local ( $id, $keepAttach ) = @_;

if ( $id eq '' || $id =~ m/^[\*\?\.]/ || $id =~ m/\t|\n/ ) {
wbFail( 'Bad id', "Cannot delete record with id='$id'" );
}

wbCheckIdPos( $id, '-1' );

open( h, ">>$DATADIR/_data/fat.txt" );
flock( h, 2 );
binmode(h);
print h "$id\t-1\n";
close(h);

if ($keepAttach) {

}
else {
chdir("$HTMLDIR/att") || wbFail("Cannot chdir to $dir");
local ( @all, $x );
@all = &glob("$id.*");
foreach $x (@all) {
unlink "$x" || wbFail("Could not delete $x");
}
}
}


sub recWriteFile {

local ($file) = @_;

open( h, ">$file" ) || return 0;
binmode(h);
print h &recToVector();
close(h);
return 1;
}


sub evalWBBkey {

local ( $x, $y );

$x = $WBB{'key'};
return '' if $x =~ m/\&NEXT/;

$y = &evalSafe($x);    # setting
return &wbFixId($y);

}


sub wbRememberSearch {

if ( &wbAllowed( $Group, 'SearchHistory' ) && $CGI{'search'} ne '' ) {
wbSearchHistoryAdd( $CGI{'search'} );
}

}


sub wbSearchHistoryAdd {

local (@s);

@s = &wbSearchHistoryGet();

foreach $s (@s) {
return if ( $s eq $_[0] );
}

unshift( @s, $_[0] );

if ( $#s > 9 ) {
@s = $s[ 0 - 9 ];
}

return if $User =~ m/^_anon/;

open( h, ">$DATADIR/_friend/$User.srch" );
print h join( "\n", @s );
print h "\n";
close(h);
}


sub wbSearchHistoryGet {

local ($s);

open( h, "$DATADIR/_friend/$User.srch" );
@s = <h>;
close(h);

foreach $s (@s) {
chop($s);
}

return @s;
}
1;
