

sub cgiAdmModifySettingB {

printFrameHead("Table settings:");
print "<br>";
admMeta();
admPrintWBBs();
}


sub admPrintWBBs {

print '<table width="100%" class="DATATABLE"><tr><td>';

undef @y;
undef @x;
if ( $CGI{'sort'} eq '1' ) {
@MetaB = sort(@MetaB);
}

foreach $fld (@MetaB) {

if ( $MetaB{ $fld, 'what' } eq 'H' ) {
if (@x) {
print &formatMenuTitle(@y) unless $CGI{'titles'} eq '0';
print '<span class="SMALL">', "\n";
while (@x) {
$text = shift(@x);
$url  = shift(@x);
if ( $CGI{'titles'} eq '1' ) {
print ".";
}
else {
print qq(<a href="$url">$text</a><br>\n);
}
}
print "<br></span>";
undef @y;
undef @x;
}
$y[0] = $fld;
$x    = &htEscape($fld);
$y[1] = qq($SCRIPT/AdmModifySettingToFrameX?type=b&amp;name=$x" class="BUTTON" target="woda_right);    # there is no missing quote here
next;
}

next unless &ddAdminCanModify( 'B', $fld );
if ( $CGI{'search'} ne '' ) {
$s = $CGI{'search'};
next unless $fld =~ m/$s/i;
}

if ( substr( $MetaB{ $fld, 'uk' }, 0, 1 ) eq '*' ) {
$mand = "<b>*</b>";
}
else {
$mand = "";
}

if ( $WBB{$fld} ne '' ) {
$set = '<tt>[X]</tt>';
}
else {
$set = '<tt>[&nbsp;]</tt>';
}

push( @x, "$set$fld" );
push( @x, "$SCRIPT/AdmModifySettingToFrameX?type=b&amp;name=$fld\" target=\"woda_right" );

}

print "</td></tr></table>";

}


sub formatMenuTitle {

local ( $text, $url ) = @_;
local ($r);

$r = '';
if ($url) {
$r .= "<a href=\"$url\"><b>$text</b></a>:<br>\n";
}
else {
$r .= '<span class="MENUT"><b>' . $text . ':</b></span><br>' . "\n";
}
return $r;

}


sub ddAdminCanModify {

local ( $type, $name ) = @_;

if ( $type eq 'B' ) {
return 1 if $WBB{ $name, 'config' } eq 'yes';
return 0 if $WBB{ $name, 'config' } eq 'no';
return $name !~ m/$HIDDENWBB/i if $HIDDENWBB ne '';
}
else {
return 1 if $WBF{ $name, 'config' } eq 'yes';
return 0 if $WBF{ $name, 'config' } eq 'no';
return $name !~ m/$HIDDENWBF/i if $HIDDENWBF ne '';
}

return 1;
}


sub admMeta {

return if @MetaB;

setTypes();
$types = join( '|', sort( keys(%FieldType) ) );
$types = '|' . $types;

&admMA( 'H', 'Essentials' );

&admMA( 'B', 'dbTitle', <<EOM, 40 );
* database title. Is displayed linked to this table's main menu.
[members]
EOM

&admMA( 'Bx', 'apTitle', <<EOM, 40 );
application title. Constant or string that will be printed to the left of the ^bdbTitle 
Should be linked to a main menu page of an application dealing with several tables.
Example below (combined with the setting of ^bdbTitle) would create a page supertitle beach club : members 
[beach club : ]
EOM

&admMA( 'Bc', 'about', <<EOM, 100 );
short descriptive text about the table
[This database stores the members of the
Beach Club]
EOM

&admMA( 'B', 'recordTitle', <<EOM);
title of one record. See also ^bdetailTitle.
[Club member] 
EOM

&admMA( 'B', 'manager', <<EOM);
* name of database's manager (see ^bmanagerEmail)
[Joe Smith]
EOM

&admMA( 'B', 'managerEmail', <<'EOM');
* ^bmanager's email
[jsmith@beachclub.com]
EOM

&admMA( 'B', 'dataDir', <<EOM);
* directory where data of the database is stored (without trailing slash!)
[/usr/local/www/wdat/beachclub/members]
EOM

&admMA( 'B', 'htmlDir', <<EOM);
directory within the document path of the server,
where the attachments and other html documents
will be stored. If undefined, it will be set to ^bdataDir
[/usr/local/www/htdocs/beachclub/members]
EOM

&admMA( 'B', 'htmlURL', <<EOM);
A URL which points to the same directory as the ^bhtmlDir.
Usually it can be determined automatically if the server
reports the DOCUMENT_ROOT (e.g. /usr/local/www/htdocs)
variable (try with /AdmDebug) and
it matches ^bhtmlDir. The unmatched part is
what should be written here.
[/beachclub/members]
EOM

&admMA( 'Bs', "sort;DEFAULT", <<'EOM');
string to use for DEFAULT sorting of records.
If undefined records will be sorted
by the first field.
["$rec{'lastName'} $rec{'firstName'}"]
EOM

&admMA( 'Bs', "format;DEFAULT", <<'EOM', 100 );
REPLACED WITH ^bformatRowDEFAULT in WODA 3.4 and higher.
String, which formats DEFAULT
printout of one record in a listing. It will be placed between
&lt;OL&gt; tags. If undefined a table will be printed. 
["$rec{'firstName'} $rec{'initial'} $rec{'lastName'}"]
EOM

&admMA( 'Bs', 'key', <<'EOM');
string using $rec{''} variables, which generates record key.
Default is a random number 4 hex digits long. Set to &NEXT(f,i)
to set the ID of first record to number f and then increment by i.
String &NEXT or NEXT() must be seen in this setting.
["$rec{'lastName'} $rec{'firstName'}"]
EOM

&admMA( 'H', 'Parameters describing Web Services' );

&admMA( 'Bc', 'provider', <<EOM, 40 );
provider of this service; needed only in services such as /Office calls.
[Santa Monica Beach Club Ltd.]
EOM

&admMA( 'Bc', 'license', <<EOM, 100 );
usage license for this service; needed only in services such as /Office calls.
[some legal text]
EOM

&admMA( 'Bc', 'officeCategory', <<EOM, 40 );
Service category for /Office calls.
[RESEARCH_GENERAL]
EOM

&admMA( 'H', 'Change the appearance of every page' );

&admMA( 'B', 'style', <<EOM, 100 );
Stylesheet to apply on pages generated.
Value of this field will
be inserted between &lt;STYLE&gt; tags.
View source to see which CLASSes are used.
If empty, the default style sheet will be applied.
Set to '/* */' to insert an empty style sheet.
EOM

&admMA( 'B', 'styleModify', <<EOM, 100 );
Include content of this style AFTER the standard WODA
style sheet. This gives a possibility to modify some WODA
styles while keeping most of them intact.
EOM

@x = split( /\n/, <<EOM);

Times New Roman,Times,serif
Helvetica,Arial,sans-serif
Albertus,sans-serif
Arial,sans-serif
Balthazar,serif
BankGothis,sans-serif
Bodoni,serif
Book Antigua,serif
Bookman,serif
Century Gothic,sans-serif
Clarendon,serif
Comic,Comic Sans MS,sans-serif
Garamond,serif
Graphos,serif
Letter Gothic,Courier,Courier New
Mistral AV,Comic,Comic Sans MS,sans-serif
Simplex,sans-serif
Stylus BT,Comic,Comic Sans MS,sans-serif
Tahoma,Arial,sans-serif
Technic,Arial,sans-serif
Univers,Universe Condensed,sans-serif
VAG Round,Arial,sans-serif
Verdana,Arial,sans-serif
EOM

&admMA( 'B', 'font', <<EOM, join( '|', @x ) );
Font to be used in pages. This setting override any
font settings in the ^bstyle sheet.
EOM

&admMA( 'B', 'script', <<EOM, 100 );
Reserved.
EOM

&admMA( 'B', 'head', <<EOM, 100 );
Tags to insert into the HEAD section of all generated pages
*after* any HEAD elements that are inserted automatically.
EOM

&admMA( 'B', 'pageBody', <<EOM);
parameters for the HTML's BODY tag;
since 4.3 the use of this setting is discouraged.
[BGCOLOR=#000000 text=#000000 link=#0000FF]
EOM

&admMA( 'B', 'frameBody', <<EOM);
parameters for the BODY tag for 
title and system frames on the few framed pages
[BGCOLOR=#808080]
EOM

&admMA( 'Bx', 'pageHead', <<EOM, 100 );
text to display on every page top above ^bpageTitle and below BODY tag
EOM

&admMA( 'B', 'pageHeadIcon', <<EOM, 100 );
text to display on every page inside the
default generated table for the title.
Good place to put LEFT or RIGHT aligned IMG tags.
EOM

&admMA( 'Bx', 'pageFoot', <<EOM, 100 );
text to display at the end of every page, below
the default generated toolbar.
EOM

&admMA( 'Bs', 'dateFormat', <<'EOM', 30 );
String evaluating to how to display dates.
$yyyy contains year, $mm contains month and $dd the day.
The default behaviour is
["$yyyy/$mm/$dd"]
EOM

&admMA( 'Bs', 'timeFormat', <<'EOM', 30 );
String evaluating to how to display times.
$hh contains hour in 24 hour format,
$mm contains minute and $ss second.
The default behaviour is
["$hh:$mm"]
EOM

&admMA( 'B', 'JavaScript', <<EOM, 4 );
Maximum JavaScript version that should be used
to enhance the generated pages. Set to 0 to disable JavaScript.
Keep empty to let the script determine the JavaScript version
that a browser can support.
EOM

&admMA( 'Bs', 'doctype', <<'EOM', 80 );
The !doctype of pages generated. Leave empty for default. See http://www.w3.org/QA/2002/04/valid-dtd-list.html for a list of valid doctypes.
[<!DOCTYPE HTML>]
[<!-- DOCTYPE HTML this is like not having it -->]
EOM

&admMA( 'H', 'Icons' );

&admMA( 'B', 'iconURL', <<EOM);
URL of a directory where icons are kept. No trailing slash!
Keep empty if a system set of icons is used.
EOM

@x = &getIconSets();
$x = join( '|', @x );

&admMA( 'B', 'iconSet', <<EOM, $x );
name of the set of predefined icons to be used by this application.
This setting will not be used if ^biconURL is defined! You may
<a href="$SCRIPT/IconDocs">display sample icons from the icon sets</a>.
EOM

&admMA( 'B', 'iconOpen', <<EOM);
Base name for the icons that denote found item in a database. The default is 
'open' and icons open1.gif ... open4.gif are used in search listings etc.
You can also set it to floppy, paper, mail, face or any other graphics
where you created a set of four icons.
[face]
[floppy] 
EOM

&admMA( 'H', 'Make big changes to header and footer of every page' );

&admMA( 'B', 'pageTemplate', <<'EOM');
If it starts with http, an URL, otherwise a file (absolute or relative to
^bdataDir) that contains a template how a page should look like.
This template can be created with any HTML design application
(Frontpage, DreamWeaver ...). When you use the 'Apply Page Template'
command on the Admin menu, this template is copied to database definition
settings ^bhead, ^bpageBody, ^bpageTitle and ^bpageEnd like this:
<ul>
<li> everything above string $body is considered ^bpageTitle.
Use $dbTitleLink and $pgTitle.
<li> $body is replaced with the main text of the page
<li> everything below $body is considered to be ^bpageEnd. Use $toolbar
to place icons and $woda to place Woda icon.
<li> BODY parameters are copied to ^bpageBody
<li> The entire HEAD section is
copied to ^bhead. TITLE and BASE are renamed to XTITLE and XBASE!
</ul>
WARNING: Without calling 'Apply Page Template' this setting
has no effect. Also, changes in the template are sensed by this
application only after you manually apply them.
[template.dwt
http://www.what.is/Templates/niceone]
EOM

&admMA( 'Bs', 'pageTitle', <<'EOM', 100 );
string expression to generate on every page top below pageHead
You can use the following variables:
<ul>
<li>$phi - content of ^pageHeadIcon
<li>$pgTitle - the title of the page
<li>$dbTitle - the value in ^bdbTitle
<li>$homeURL - URL of the database's home page
<li>$scriptURL - URL of this script,
<li>$loginBox - a box offering users to log in - only displayed if ^buserTable is set
</ul>
If not set, something like this is printed
as default:
["
<div class="DBTITLE">
<a href="$homeURL">$dbTitle</a>
</div>
<div class="PGTITLE">
$pgTitle
</div>
"]
EOM

&admMA( 'Bx', 'pageEnd', <<'EOM', 100 );
string expression which generates whatever
is printed at the end of every page, just above ^bpageFoot. Variables:
<ul><li>$PageCount contains page count of this application.
<li>@Toolbar contains the elements that should
be placed into the toolbar, 
<li>$toolbar contains the toolbar icons
<li>$woda contains the icon that points to Woda. THIS ONE MUST BE PRESENT.
</ul>
If not set, something
like this is printed as default:
[
$x = join("</td><td>",@Toolbar);
"<table><tr><td>$x</td></table>";
]
EOM

&admMA( 'H', 'Add to toolbars' );

&admMA( 'Bx', 'toolbarText', <<EOM, 60 );
The default toolbar has some system icons on the
left and right.
In between is a wide empty cell. This text will be
printed in it.
[(c) Blinky Bill 1993]
EOM

&admMA( 'B', 'toolbar', <<EOM, 100 );
Contains a table with space-separated 
columns and several rows.
The left column contains a pattern to match against
the action part of the URL (Search, Add, Home ...).
The right contains a string expression (variables can be used!)
to add into one cell of the toolbar table. In the below example, 
the first item is added to Add pages only, the second one to all pages.
Third item calls a subroutine to generate the string.
[Add	"<img src=help.gif> help"
.	"(c) 2001 The Oddisey Group"
Edit	&myEditToolbar()]
EOM

&admMA( 'H', 'Database home page' );

&admMA( 'B', 'homePage', <<EOM);
Name of a HTML file which is the homepage of the database
(in ^bhtmlDir) unless contains a / in which case it is
treated as a URL. If empty, the database's home will
be the /Home main menu page automatically
generated by this script and not a static HTML file.
[home.htm]
[http://www.somesite.com/index.htm]
EOM

&admMA( 'B', 'generatedHomePage', <<EOM);
WODA can automatically generate a .htm file for the database
home page. Define here into which file it should create it (relative to ^bhtmlDir.
Can be the same as ^bhomePage in which case the generated .htm will replace
what you wrote in it. Mainly used to speed up the delivery of the database's
home page.
[home.htm]
EOM

&admMA( 'Bx', 'homePageFormat', <<'EOM', 100 );
HTML that defines the home page / main menu of the
application. Predefined variables are $MENU, $SEARCH, $ABOUT, $LOGIN and $DATA.
$DATA depends on ^bhomePageData. $MENU can be changed by ^buserMenuBrowse and
related settings.
["
<table width="100%">
<tr valign="top">
<td>
$SEARCH
$ABOUT
$DATA
$LOGIN
</td>
<td>
<td bgcolor=#000000>&nbsp;</td>
<td>$MENU</td>
</tr>
</table>
"]
EOM

&admMA( 'B', 'homePageData', <<EOM);
What data from the database should be inserted into the home
or main menu page. Possible values are:
<ul>
<li> (blank) ... last 5 items are displayed
<li> N ... last N items are displayed
<li> fieldName ... browse menu of that field is displayed
</ul>
[8]
EOM

&admMA( 'H', 'Add to menus on the Home page' );

&admMA( 'B', 'userMenuBrowse', <<EOM, 100 );
comma separated list of text,url to add to Browse menu. One per row!
If it does not include // or start with a / assumed to be relative to current application.
EOM

&admMA( 'B', 'userMenuFind', <<EOM, 100 );
comma separated list of text,url to add to Find menu. One per row!
If it does not include // or start with a / assumed to be relative to current application.
[Search websites,http://www.x.com/search
Search here,Search?search=foobar]
EOM

&admMA( 'B', 'userMenuAdd', <<EOM, 100 );
comma separated list of text,url to add to Add menu. One per row!
If it does not include // or start with a / assumed to be relative to current application.
EOM

&admMA( 'B', 'userMenuOther', <<EOM, 100 );
comma separated list of text,url to add to other menu. One per row!
If it does not include // or start with a / assumed to be relative to current application.
EOM

&admMA( 'H', 'Change the look of the data entry form' );

&admMA( 'Bx', 'formFoot', <<EOM, 100 );
text to display at the end of every entry form
EOM

&admMA( 'B', 'verifyEdits', <<EOM, 1 );
If set to non zero, users will need to verify
the records that they enter, before it is submitted.
EOM

&admMA( 'Bs', 'form', <<'EOM', 100 );
What does the main part of the input form look like. Should return a string.
The defined variables for each field are:
<br>$Form{field,name}
<br>$Form{field,prompt}
<br>$Form{field,input}
<br>$Form{field,help}
<br>$Form{field,err}
<br>$Form{field,continue}
EOM

&admMA( 'H', 'Change the look of the Detail page' );

&admMA( 'Bs', "detail", <<EOM, 100 );
how to format a page with one record. If undefined the fields will
be printed in default format - a two column table. See also ^bdetailTitle.
EOM

&admMA( 'Bs', 'detailTitle', <<'EOM', 100 );
string expression to generate as title on the default detail page
Use $phi, $pgTitle, $dbTitle, $homeURL, $scriptURL, which contain site icon (^bpageHeadIcon),
page title (^bpageTitle), database title (^bdbTitle), database's home URL (^bhomePage) 
and script's home URL.
["Full details of $rec{'firstName'} $rec{'lastName'}"]
EOM

&admMA( 'H', 'Change the Look of the Search Results Page' );

&admMA( 'B', 'searchTextLinks', <<'EOM', 2 );
Use text for links to other pages of search results. By default, the links are created with images and placed in the toolbar.
[1]
EOM

&admMA( 'B', 'searchNoHitCount', <<'EOM', 2 );
Do not print hit count or text links. By default, the number of records found and the current record range is printed. <em>Do not use this option with searchTextLinks (^bsearchTextLinks) as it prevents text links from being printed.</em>
[1]
EOM

&admMA( 'B', 'searchNoTools', <<'EOM', 2 );
Turn user tools off. By default, all user tools (format, sort, show, export) are displayed on the search results page. It is a much easier way to say no format tools (^bsearchNoFormat),  no sort tools (^bsearchNoSort),  no show tools (^bsearchNoShow),  no export tools (^searchNoExport).
[1]
EOM
&admMA( 'B', 'searchNoFormat', <<'EOM', 2 );
Turn off format tools. By default, users can choose to display the results in different formats. 
[1]
EOM

&admMA( 'B', 'searchNoSort', <<'EOM', 2 );
Turn off sort tools. By default, users can change the sort order.
[1]
EOM

&admMA( 'B', 'searchNoShow', <<'EOM', 2 );
Turn off Show tools. By default, users can choose to show more or less records per page
[1]
EOM

&admMA( 'B', 'searchNoExport', <<'EOM', 2 );
Turn off export tools. By default, privileged users can export records.
[1]
EOM

&admMA( 'H', 'Speed up searches' );

&admMA( 'B', 'grepBigger', <<EOM);
If nonzero and if \$GREP WODA variable is defined,
UNIX's grep will be used to speed up searches if
the size of data is larger than this number of bytes. Set to
500000 or more. See also ^bsearchCache if you want to
speed up searches.
[300000]
EOM

&admMA( 'B', 'cacheExpire', <<EOM, '0|1|2|3|4|6|8|12|24|48|72|96|168' );
after how many hours after the changes in the database should
the cached files and indexes be rebuilt. Default - 0 (zero)
means 'after each change in the database'.
Since indexing takes some time a value of 0 may
slow down very large databases. This value in fact means
that it may take at most this many hours before an entered record
is found.
EOM

&admMA( 'B', 'onExpire', <<EOM, 100);
Perl code to execute when cache would expire.
This routine can be used to occasionally bring into the
database some data from external sources.
[do myOnExpire]
EOM

&admMA( 'B', 'searchCache', <<EOM);
If nonzero, WODA will cache search results in the _qry
directory. Files will be named *.tbl. This speeds up searches.
EOM

&admMA( 'B', 'searchCacheAge', <<EOM);
How many hours after a cached file was created
it should be deleted. Setting this to 24
would make sure that cached files that have not been used
a day or more will be deleted automatically.
Default is one month (720 hours). Cleaning takes place
at most once an hour.
EOM

&admMA( 'H', 'More ways to sort search results. Searches from U1 to U9' );

foreach $p ( 1 .. 3 ) {    # U1 .. U9

&admMA( 'B', "sortName;U$p", <<EOM, 20 );
name of $p sorting
[by state and town]
EOM

&admMA( 'Bs', "sort;U$p", <<EOM);
string to use for $p sorting of records. See ^bsort;DEFAULT for details.
["\$rec{'state'} \$rec{'town'}"]
EOM
}

&admMA( 'H', 'User defined search result formats from one to nine' );

foreach $p ( 'DEFAULT', 1 .. 9 ) {

&admMA( 'B', "formatName$p", <<EOM, 20 );
This and next settings (ending in digits 1-9)
define how found records are printed out.
Here, the name of this format is
defined and will be used in menus and pull-downs.
[a very detailed format]
EOM

&admMA( 'Bx', "formatHttpHead$p", <<EOM, 100 );
Http Header to be printed for this particular format.
Specify only if the setting is not text/html!
WARNING: Currently it can not provide correct Content-length!
[Content-type: text/xml]
EOM

&admMA( 'Bx', "formatHead$p", <<EOM, 100 );
Next settings define how a list of found
records is laid out. First the formatHead
is printed, then, for each record, formatRow,
and finally, ^bformatFoot.
[<table>]
EOM

&admMA( 'Bx', "formatRow$p", <<'EOM', 100 );
See ^bformatHead for details. The following variables
can be used:
<ul>
<li>$ID ... ID of this record
<li>$ThisRecordNo ... serial number of this found record
<li>$ThisRecordURL ... URL of the found record.
<li>$ThisRecordDate ... date when the record was last modified.
<li>$ThisRecordIcons ... system action actions for this record.
<li>$ThisRecordBasket ... checkbox for the shopping basket.
<li>$ThisRecordMatches ... numeric value of the relevance of this record.
</ul>
["<tr>
<td><a href="$ThisRecordURL">$rec{'firstName'}</a></td>
<td>$rec{'lastName'}</td>
</tr>
"]
EOM

&admMA( 'Bx', "formatFoot$p", <<EOM, 100 );
What is printed after all found records.
[</table>]
EOM
}

&admMA( 'H', 'Custom browse options' );

&admMA( 'Bs', 'tree', <<'EOM');
expression which creates database subtitles for browsing. It takes
some time to create this index therefore all 'trees' are cached. Changing this value
will not require a cache update. After change manually clear the *.3.* files from _cache!
For most applications, ^btree is an overkill. See TREE as ^ftypePar if
tree data comes from one field only.
WARNING: this tag is not obsolete, but it is no more implemented since Woda 4.000. Might be in future.
["$rec{'category'};$rec{'subcategory'}"]
EOM

&admMA( 'Br', 'treeSplit', <<EOM);
pattern which splits '^btree' into category and subcategory.
WARNING: this tag is not obsolete, but it is no more implemented since Woda 4.000. Might be in future.
[;]
EOM

&admMA( 'B', 'AZindex', <<EOM, 100 );
Table, which defines how A-Z indexes of the database are defined.
Each row defines one A-Z index. The columns are (1) ID (a word which defines
a name of the A-Z index, (2) the comma separated list of field names which are used to
provide the words for the A-Z index and (3) the rest is a nice textual description of
the A-Z index.
[byname	lastName,firstName	Index of member names.
bystate	state	Index of members by state]
EOM

&admMA( 'B', 'AZindexMethod', <<EOM, 100 );
Table, which defines how A-Z indexes of the database are computed.
The columns are (1) ID (a word which defines
a name of the A-Z index, as in ^bAZindex. (2) the comma separated list of methods to
apply. Methods ASCII,UPPER,LOWER,TITLE,STEM translate found text. STEM is rather primitive. Any combination may be
applied. Methods to split text into words are SPACE,COMMA,SEMICOLON and COLON. Only one can be used.
[bystate	UPPER,SPACE
byname	LOWER]
EOM

&admMA( 'B', 'AZnot', <<EOM, 100 );
List of words which should not be included in the ^bAZindex. 
The words should be white-space separated. Regular expressions may be used.
[a the is at]
EOM

&admMA( 'B', 'ringField', <<EOM, 100 );
The name of a field to be used by BrowseRing. 
If more than one field has been defined as a URL then ringField can be used to specify which field to use. 
If ringField is empty the first field that is defined as URL is used.
[publicUrl]
EOM

&admMA( 'H', 'Changing headers and footers on some pages' );

foreach $p ( 'Home', 'Search', 'Add', 'Changed', 'Show', 'Store', 'Edit', 'NewForm', 'AdvancedSearchForm', 'SearchIDForm', 'AdmMenu' ) {

&admMA( 'Bx', "title;$p", <<EOM, 100 );
text to display on top of page $p
EOM

&admMA( 'Bx', "head;$p", <<EOM, 100 );
text to display on top of page $p
EOM

&admMA( 'Bx', "foot;$p", <<EOM, 100 );
text to display at the end of page $p
EOM
}
&admMA( 'H', 'Shopping basket' );

&admMA( 'B', 'basketName', <<EOM, 100 );
If defined, WODA will allow adding to a shopping basket in all
search and similar pages. This is not only useful for shopping but
for compiling a list of relevant found records. These can later be 
printed out together etc. The value entered should fit nicely after
"add to " ... e.g. "favourites","shopping list","your personal selection"
etc. Baskets related to user's ID. Files named like Userid.bskt are in the
_friend directory. Expired baskets are deleted as a part of maintenance procedure.
[local favourite members]
EOM

&admMA( 'B', 'basketExpire', <<EOM, 5 );
How many hours after a basket was created it should be deleted. By default Baskets expire in after 24 hours.
EOM

&admMA( 'H', 'Automated maintenance' );

&admMA( 'Bs', 'afterRecordModify', <<EOM);
Expression (Perl statement or program) that is
executed after a record has been modified and written to disk.
%rec still contains field values.
EOM

&admMA( 'Bs', 'afterTableModify', <<EOM);
Expression (Perl statement or program) that is
executed after a table is modified.
[`/usr/local/bin/execHtm whatsnew.htm`]
EOM

&admMA( 'B', 'maintenancePeriod', <<EOM);
Every how many hours should the automatic
maintenance of the database take place (or 0 to disable). HTTPD must be
allowed to use UNIX's 'at' command. 
If you set up Angie, this should be once a day. If the database 
is little used, use cron instead.
[24]
EOM

&admMA( 'Bs', 'deleteAfter', <<EOM, 2 );
delete records older than this many days (0=never)
EOM

&admMA( 'H', 'Relational features' );

&admMA( 'B', 'tables', <<EOM, 100 );
<p>In functions such as ROWS, QRY etc. and
some filed settings, one needs to refer to
another table. This setting defines where that
table is. The definition is only needed if
it is not possible to guess, where the table is.
<p>
If the related table is laid out like this one, there is no need to
define it in this field. If table 'products' is handled by 
/cgi/products with data in /www/wdat/products and if 'people' are handled by
/cgi/people with data in /www/wdat/people there is no need
to mention them here!
<p>
(since version 4.400) If the related table is on another server
it is defined by a row consisting of an ALIAS and URL. Some operations on such
tables will be much slower than on local tables.
<ol>
<li>ALIAS is the logical name to be used in the program.
<li>URL is the URL of the script handling this table. Starts with http.
<li>DIR (optional). If defined it is assumed this is the data directory 
on this server. Could speed things up. However, it the table is really on another server,
this field should be empty!
</ol>
<p>
(for backward compatibility) If the related table is on the same server and its location
is different then a row in this setting defines it. The row has three whitespace
separated fields:ALIAS PROGRAM DATADIR.
<ol>
<li>ALIAS is the logical name to be used in the program.
<li>PROGRAM program is the name of the database definition file. This will be used
to guess the URL so that any part of the path before /cgi or /db will be
discarded and the remaining part used after server URL.
<li>DATADIR is the name of the database's data directory.
</ol>
[members	/www/cgi-bin/members /www/wdat/members
states	/www/cgi-bin/states /www/wdat/states
users	http://users.scix.net/cgi-bin/users]
EOM

&admMA( 'B', 'requireFile', <<EOM);
file with add-in subroutines and settings to be require-ed by Perl. If
path
<ol>
<li>starts with / it is absolute
<li>starts with letter of digit it should be stored in \$TEMPLATEDIR/lib
<li>otherwise it is relative to ^bdataDir of this table.
</ol>
Typically used to store the ^btables and other settings to ensure consistent
formatting of several tables of a relational application. First the original table definition is loaded,
then the require file, then the common.pl file at ^bdataDir/../common.pl
[/usr/www/cgi-bin/common.pl]
EOM

&admMA( 'H', 'Group based security' );

&admMA( 'B', 'groups', <<EOM, 100, $ADMUSER );
New in 4.105! What groups of users does this application support. Setting contains
a table with three tab or whitespace separated columns: (1)group-name, (2)host-pattern, (3)password.
During login, this table will be scanned so that for the given login parameters
both password AND host pattern would match. 
See below: 'ziga' can be only a person coming from 193.2.92.14 AND supplying the password 'turk'.
Ziga can be also a person coming from other places but knowing password 'secret'.
Slovenians are all that come from 193.2.92. To become Italian or English or German
(# are translated to . for compatibility reasons) one must supply a password. You cant become french,
no such IP is possible! System defined groups are guest, admin, friend, owner and client.
[
ziga	193.2.92.14	turk
ziga	.	secret
slovene	193.2.92.*
italian	.	milano
english	.	london
french  !	paris
german	#	berlin
]	
EOM

&admMA( 'B', 'rights', <<EOM, 100 );
Who is allowed to do what. Also see manual.
Table with with four space
separated columns (1) allow/deny, (2) group (from ^bgroups) or group pattern, (3) action-pattern, (4-optional) parameter-pattern.
By default, guests cannot use Basket and SearchHistory and nobody is
allowed to use Agent* and Admin* actions. Any other actions are
allowed by default. See manual. See ^bownerField for definition of
two magic groups. Below, we deny guests to search - they will need
to register as friend first! Friends can Add or Edit stuff.
Special can subscribe to Agent searches. Enemies are denied everything.
We also deny anyone search for 'sex!' (note that there is no need to escape the '!')
and guest to set max parameter to start
with 3.  
[deny	guest	Search
allow	friend	Add|Edit
allow	special Agent.*
deny	enemies	.*
deny	.	Search	sex!
deny	guest	Search	max=3]
EOM

&admMA( 'Bs', 'userScope', <<EOM, 10 );
To pass usernames and passwords, cookies are used. By default,
cookies are only set for one table at a time and as a result
a user must log in to several related tables separately. This
string should be set to the local part of the URL for which
cookies should be valid, starting with a slash. E.g. /cgi below will
pass username and password to all cgi programs on the same server. 
[/cgi]
EOM

&admMA( 'H', 'User based security' );

&admMA( 'B', 'userTable', <<EOM, 10 );
An alias of a table from ^btables field that
contains information about the users of this table.
Username will be the ^bkey as defined in the ^buserTable.
Password of the user will be the same as the password
used lock a record in the ^buserTable. The user will
belong to a group given in ^buserTable's field called 'group', or
to the default group given in the ^buserTableGroup field
here or to group 'guest' (in that order).
See manual.
[members]
EOM

&admMA( 'B', 'userTableGroup', <<EOM, 10 );
Group (from ^bgroups) to which all users
defined in table ^buserTable belong, unless
the ^buserTable contains field named 'group' which
overrides this default. If undefined, the users defined
in ^buserTable default to group 'user'.
[friends]
EOM

&admMA( 'B', 'ownerGroup', <<EOM, 10 );
Name of group that gets record owner status
(can edit, modify,delete record) even if
does not know the password of the record.
Users from this group in effect get admin's
rights in the record.
[editor]
EOM

&admMA( 'Bl', 'userAllow', <<EOM);
Logical expression, based on data in table pointed to by ^buserTable
that evaluates to true, if a given user is allowed to log into
this database or to false, if not. If empty or equal to 1
anyone is allowed to login. Otherwise admin can check applicants
before letting them use the database for example (below),
by setting the status field to OK. It would make sense to set 
^fmodifies of status to 'admin'.
[\$rec{'status'} eq "OK"]
EOM

&admMA( 'B', 'recordLock', <<EOM, 60, 'password|user' );
How a person entering some data may lock it. The options are:
<ul>
<li>password ... record will be locked with a password
<li>user ... record will be locked to a user (option is not avalaible to guests)
<li>group ... record is locked to a group from ^bgroups
<li>host ... record is locked to an IP number
<li>none ... record can not be locked at all
</ul>
These words most be entered using | as a delimiter. The default is:
[password|user]
EOM

&admMA( 'B', 'ownerField', <<EOM, 10 );
Name of field that contains the
username of the owner of this record.
If the value in this field is the same as
the username of the logged in user (one from ^buserTable)
the ^frights, ^fsees and ^fmodifies for a magic group 
'owner' will apply in the context of this record.
If the value of this field is '0' or ''
the rights for magic group 'public' will apply. This setting lets you
build databases where records are protected by user,
not by password, and a combination of both.
[recordOwner]
EOM

&admMA( 'H', 'Special protection of records' );

&admMA( 'B', 'filter', <<EOM, 100 );
Hide some records from some ^bgroups. Table with two tab separated columns. In the first is
a name of a group as defined in the ^bgroups attribute. In the second is the
search condition which will be silently added to any search any user from this group 
performs. The example below only records that contain the word "abracadabra" will
be found. WARNING: without the + the search below would behave exactly the same way!
See also ^bfilterText
[guest	+abracadabra]
EOM

&admMA( 'B', 'filterText', <<EOM, 100 );
Used to define explanations of filters defined in ^ffilter.
[guest	Filtered to abracadabra]
EOM

&admMA( 'Bl', 'hideUnless', <<'EOM', 100 );
^ffilter prevents record to be found. hideUnless prevents them
to be shown if someone happens to know the id and keys in
the URL. Only records for which this expression evaluates
to TRUE will be displayed.
[$Group eq "user" && $rec{'_id'} eq $User]
EOM

&admMA( 'B', 'hideUnderscore', <<EOM, 1 );
Obsolete in versions above 4.300
EOM

&admMA( 'H', 'Limiting number of found records' );

&admMA( 'B', 'dfltHits', <<EOM, 5, $WBB{'dfltHits'} );
default number hits per page in searches
EOM

&admMA( 'B', 'maxHits', <<EOM, 5, $WBB{'maxHits'} );
maximum allowed hits per page in searches. On the advanced search page,
users may ask for up to this many hits per page.
EOM

&admMA( 'H', 'Support for non-english languages' );

&admMA( 'B', 'language', <<EOM, 2, 'uk' );
* User interface language. Enter a two letter language code (English=UK, Slovenian=SI ...).
You must have the appropriate woda-xx.pl library installed, to support your language.
[UK]
EOM

&admMA( 'B', 'intlCharset', <<EOM, 10 );
character set used in pages of the database
[ISO-8859-1]
[WINDOWS-1250]
EOM

&admMA( 'B', 'intlCollate', <<EOM);
how to sort international characters. Many space separated strings like
e&#234;&#233; o&#246;&#244; which mean that &#234;&#233; should be sorted after
e, &#246;&#244; after o ... Define on lower case only!
EOM

&admMA( 'B', 'intlLower', <<EOM);
how to convert uppercase international letters into lower case
or other character equivalencies in sorting.
Two space separated strings must be defined - the first are upper case letters, 
the second corresponding lower case ones: like &#201;&#202;&#218;&#219; eeuu 
In this case they will be sorted as if they were equivalent to e-s and u-s
EOM

&admMA( 'B', 'intlAscii', <<EOM);
how to convert lower case international letters into corresponding ASCII ones
(eg. &egrave; into e).
Two space separated strings must be defined - the first are the non-ascii
characters, then are the corresponding ascii ones. Both strings must be equal size!
EOM

&admMA( 'H', 'Other options' );

&admMA( 'B', 'logLevel', <<EOM, 1, 3 );
Log level. The default is 3.
<ul>
<li>0 - no logging
<li>1 - logging fatal errors only
<li>2 - logging all errors
<li>3 - logging all actions
<li>4 - logging all actions with comments
</ul>
[1]
EOM

&admMA( 'B', 'logFile', <<EOM, 10 );
Name of logfile. Defaults to $yyyy$mm.log 
File will be in the ^bdataDir/_log unless name starts with a /, assuming
an absolute path. Name may include variables $yyyy
for year, $mm for month and $dd for day.
Note that this is not the server's log or error log file.
Errors which prevented WODA to start will not show up here.
The columns in the log file
are separated with tabs and are (left to right):
<ol>
<li>ok|ER|FA to denote ERror or FAtal error
<li>time in seconds used to process the request
<li>date and time when request was made in ISO format
<li>host or IP number from which request was made
<li>username of the user
<li>group to which the user belonged
<li>request method
<li>script executed
<li>page requested
<li>query string (encoded)
<li>any WODA error messages
</ol>
This will create a new log file every day:
[$yyyy-$mm-$dd.log]
EOM

&admMA( 'B', 'robots', <<EOM, 1 );
Setting is obsolete since version 4.596 (automatic handling of robots). This setting is no more implemented.
EOM

&admMA( 'B', 'adFile', <<EOM);
Obsolete. This setting is no more implemented.
EOM

&admMA( 'B', 'searchHelp', <<EOM, 100 );
several rows of help messages that will be displayed below the
search form. Each row should contain one, self contained help message.
In the example below are the built-in help messages. Note that some rows may be wrapped in your browser - in fact there is one
sentence per row!
[Sorry, no help example available.]
EOM

&admMA( 'B', 'quotaText', <<EOM, 10, 0 );
Maximum allowed size (in megabytes) for the data in the text part of the table.
After that size is reached, the modifications of the table will not be allowed.
Unlimited if 0.
[0.5]
EOM

&admMA( 'B', 'quotaBin', <<EOM, 10, 0 );
Maximum allowed size (in megabytes) for all binary attachments the data in the table.
After that size is reached, the modifications of the table will not be allowed.
Unlimited if 0.
[2]
EOM

&admMA( 'B', 'quotaLoad', <<EOM, 100, 0 );
What operations are allowed at what server load.
A table with two tab separated columns. Left=load
above which operation is denied. Right=pattern
of actions, like in the ^brights setting.
[10	Search
5	Show]
EOM

&admMA( 'H', 'z End' );


&admMA( 'F', 'type', <<EOM, $types );
* Field type.
[OPTION]
EOM

&admMA( 'F', 'typePar', <<EOM);
Additional field parameters. By default these are added to the INPUT (e.g. size="n"),
TEXTAREA (e.g. rows="x" cols="y") or SELECT tags (MULTIPLE).
Special values are:
<ul>
<li> size="n" ... as in HTML
<li> CONTINUE (does not work since 3.5),
<li> HIDDEN (makes an INPUT field hidden),
<li> OWNER says that if this field is one of the many EMAIL TYPE fields, it should be used to reset the password.
<li> RICH enables rich text editing of HTMLAREA fields.
</ul>
These apply to OPTION or LINKOPTION fields where a selection
of many values is possible:
<ul>
<li> cols="n" puts CHECKBOXES in n columns
<li> RADIO - options should be presented as radio buttons.
<li> CHECKBOX - options should be presented as checkboxes (the default is a pulldown list)
<li> TREE - field should be used for hierarchical browsing of
the database. ^foptions must be like europe:italy:rome, that is,
categories and subcategories separated by colons.
<li> NOID hides IDs in OPTION fields, where display and stored values are different.
<li> HEADING="xxxxx" will display items starting with x as headings of OPTION fields, not as values to be selected. "xxxxx" can be 1 to 5 characters.
</ul>
[CHECKBOX MULTIPLE]
EOM

&admMA( 'F', 'p', <<EOM);
Short prompt for field, shown above field.
[Check all operating systems on which your software works]
EOM

&admMA( 'F', 'help', <<EOM, 100 );
Help text on field input, shown below field. Usually much longer than prompt text.
[Do not check all systems if
it is a Java program.
Just click next to Java,
you dummy.]
EOM

&admMA( 'Fl', '', <<EOM, '', '1;' );
* Unnamed attribute. Expression which validates the field value in \$_. 
Keep 1; if anything goes. In BREAK fields text of the break. In USERFILE fields, \$_
is the name of the temp version of the file. Good enough to check for
extension or existence. length(\$CGI{'FieldName'}) gives the length of the
uploaded file. Note that you can write your own subroutine
to validate record as a whole, the subroutine must be named myRecVerify.
[length($_)>20;]
EOM

&admMA( 'F', 'cond', <<EOM);
The above validation expression but written in plain English (or another language).
[Text should be at least 20 characters!]
EOM

&admMA( 'F', 'head', <<EOM);
Name of the field for table headings. If undefined, field name is used.
[Supported operating system]
EOM

&admMA( 'F', 'options', <<EOM, 100 );
* Possible options for OPTION typed fields in the following formats:
<ul>
<li> one the same line separated by |
<li> one per line. If the options are in one-per row format, then the row 
can have several columns separated with TABs. The first column is used as
a value to be stored in the database. All others are shown on screen to make
the selection clearer. 
<li>Value starts with & or # it will be evaluated as a Perl program
which should return rows as described above.
</ul>
Several ^ftypePar options provide details.

[yes|no|maybe]
[&ROWS('people','_id,givenName,lastName')]
[	(unknown)
WIN3.1
WIN95
WIN98	(also includes WIN2000)
WINNT
MAC
LINUX
FreeBSD
HP-UX
Java
Excel
Word]
EOM

&admMA( 'Fx', 'd', <<EOM);
Default value. Constant string or a perl expression returning a default value. 
[WIN98]
[
$User;
]
EOM

&admMA( 'F', 'into', <<EOM);
DO NOT USE ... WILL BE OBSOLETE SOON! Defines that the data in this field point(s) to record(s) in table defined as parameter here.
(1) dataDir or alias of the related database.
Keys of this database will be extracted in forms if field type is LINKOPTION.
(2) If this field starts with an & character it will be evaluated.
The result of the program should be formatted as the ^foptions setting above.
This lets you add more information about the selection. Typically you would use
&ROWS function.
[platforms] # (1)
[&ROWS("platforms","_id,name")] # (2)
EOM

&admMA( 'Fs', 'picture', <<'EOM', 100 );
expression which nicely formats field value. Expression may use variables
$_ (raw value of field) and $_id (ID of the current record).
Use &ROWS(), &QRY() and &FLD() functions to relate to other databases.
Below we display an icon instead of text.
["&lt;IMG src=/imgs/platforms/$_.gif&gt;"]
["&lt;B&gt;$_&lt/B&gt;"]
EOM

&admMA( 'Fs', 'change', <<'EOM', 100 );
expression which changes the value after it was entered in the form and before
it is validated or written into the database. Make sure that repeated 'changes'
not keep changing the value. The value to be changes is in $_. The field is changed to
whatever this code returns. The example removes any newlines.
[$_=~s/\n/ /g;
return $_;]
EOM

&admMA( 'F', 'sticky', <<EOM);
Leave empty (default) or set to 1 to make the value entered here
default next time the same user enters this form.
E.g. email addresses could be made sticky.
Set to any value including a / to set the path= variable in HTTPD-COOKIE header.
[1]
[/]	
[/cgi/data]
EOM

&admMA( 'F', 'meta', <<EOM);
Value of the field should map to a meta tag in the html head
section on appropriate pages (e.g. /Show).
[DC.TITLE]
EOM

&admMA( 'Fr', 'modifies', <<EOM);
| separated list of ^bgroups allowed to modify this field (or empty for all)
[friend|special]
EOM

&admMA( 'Fr', 'adds', <<EOM);
| separated list of ^bgroups allowed to enter data into this field on the Add page (or empty for all)
[friend|special]
EOM

&admMA( 'Fr', 'sees', <<EOM);
| separated list of ^bgroups allowed to see the value of the field (or empty for all)
[user|friend]
EOM

&admMA( 'F', 'srt', <<EOM, 4 );
order of field in forms. The higher the number, the more at the top!
EOM

}


sub getIconSets {

local (@all);

return () if $ICONDIR eq '';
opendir( D, $ICONDIR )
|| wbWarn( "Cannot open icon directory",
"Setting \$ICONDIR=$ICONDIR sucks! This error will prevent you from choosing alternate sets of icons!" );
@all = readdir(D);
closedir(D);

@all = grep( !/\./, @all );
@all = sort(@all);

return @all;
}


sub admMA {

local ( $what, $name, $uk, $size, $deflt ) = @_;

"$what " =~ m/^(.)(.)/;
$what = $1;
$type = $2;

if ( $uk =~ s/^\*// ) {
$mandatory = 1;
}
else {
$mandatory = 0;
}

if ( $what eq 'B' || $what eq 'H' ) {

$uk = &formatBaseDocs( $uk, $name );

push( @MetaB, $name );
$MetaB{ $name, 'what' } = $what;
$MetaB{ $name, 'uk' }   = $uk;
$MetaB{ $name, 'size' } = $size;
$MetaB{ $name, 'dflt' } = $deflt;
$MetaB{ $name, 'type' } = $type;
$MetaB{ $name, 'mand' } = $mandatory;

}
elsif ( $what eq 'F' ) {

$uk = &formatFldDocs( $uk, $name );

push( @MetaF, $name );
$MetaF{ $name, 'what' } = $what;
$MetaF{ $name, 'uk' }   = $uk;
$MetaF{ $name, 'size' } = $size;
$MetaF{ $name, 'dflt' } = $deflt;
$MetaF{ $name, 'type' } = $type;
$MetaF{ $name, 'mand' } = $mandatory;
}
}


sub formatFldDocs {

local ( $uk, $wbb ) = @_;

$uk =~ s|manual\b|<a href="$WodaHomeURL/man.htm">manual</a>|g;			# \b: word limit because we are greedy (g)
$uk =~ s/\^(b|f)([a-zA-Z;]+)/<a href="#_$1$2" $TargetSelf><em>$2<\/em><\/a>/g;

$x = '<table width="62%" class="DATA1" ><tr><td><pre>';
$y = '</pre></td></tr></table>';

$uk =~ s/\[/<br>Example:$x/g;
$uk =~ s/\]/$y/g;

return $uk;
}


sub formatBaseDocs {

local ( $uk, $wbb ) = @_;

$uk =~ s|manual\b|<a href="$WodaHomeURL/man.htm">manual</a>|g;			# \b: word limit because we are greedy (g)
$uk =~ s/\^(b|f)([a-zA-Z;]+)/<a href="#_$1$2" $TargetSelf><em>$2<\/em><\/a>/g;

$x = '<table width="62%" class="DATATABLE" ><tr><td><pre>';
$y = '</pre></td></tr></table>';

$uk =~ s/\[([^\]]*)\]/$x . &htQuote($1) . $y/ge;

return $uk;
}


sub setTypes {

return if defined %FieldType;

$FieldType{'INPUT'}    = "The defaul  field type. A line  of text.";
$FieldType{'TEXTAREA'} = "Several rows of preformatted text. Adjust  the
size with rows=n cols=m. Will be tagged as &lt;PRE&gt; unless P or BR tags  are
present";

$FieldType{'HTMLAREA'} = "A paragraph  of text  or a  whole tagged HTML
document. Any formatting should be done  in HTML. If HTML tags are  not present
two newlines  will be  replaced by  P tag.  Adjust size  with rows=n  cols=m in
typePar. Enable rich editing with RICH in typePar";

$FieldType{'OPTION'} = "An option list. Define options in the  'options'
attribute. 'typePar' may include RADIO, SIZE, MULTIPLE and TREE. In the  second
case field will be offered for hierarchical browsing.";

$FieldType{'LINKOPTION'} = "(obsolete) An option list where the options are keys from another table.
Define table's alias or dataDir in the 'into' attribute";

$FieldType{'LIST'} = "A list of values. Values should be entered one per row.
Formatting and verification applies one per each item";

$FieldType{'DATE'} = "Date type. Internally represented as yyyy/mm/dd.";

$FieldType{'EMAIL'} = "An email address. By default rendered as mailto: HREF, checked to include '\@a'.";

$FieldType{'URL'} = "A URL. By default rendered as A HREF";

$FieldType{'FILE'} = "A file somewhere on the server, relative to htmlURL.
E.g. picture, full text document ... By default rendered as link to that file.";

$FieldType{'USERFILE'} = "Like FILE but database users can upload it to the server using the Netscape 2+ or Explorer 4+.";

$FieldType{'IMAGE'} = "Like USERFILE but will be rendered on screen as an IMG.";

$FieldType{'COMPUTE'} = "A field which is not stored in the database but is computed on the fly when record is read.";

$FieldType{'BREAK'} = "A horizontal line to separate fields in forms and tabular output";

$FieldType{'SUBMIT'} = "Link to submit buttons. Use if you want an extra section in the middle of the form.";
}


sub printFrameHead {

$MINIHEAD      = 1;
$FRAMEHEAD     = 0;
$TargetDefault = 'target="_parent"';

printHead(@_);
}
1;
