

sub cgiAdmRebuildFat {

if ( $CGI{'go'} ) {

printHead("Rebuilding fat.txt ...");
print "<pre>";
print &rebuildFat();
print "</pre>";

}
else {

printHead("Rebuild fat");

( $n, $r, $d, $m ) = &checkIntegrity();

if ($m) {
wbWarn( "Fat is corrupt:", "<pre>$m</pre>" );
}

$text = <<EOM;
Shall I try to rebuild the fat.txt? <b>Some deleted records will
re-appear.</b>
<p>If the records.txt is corrupt as well, this will fail.
However,you can still try to
rebuild the table by deleting *.txt in _data directory and
then using the 'rebuild from tbl' command.
<form action="$SCRIPT/AdmRebuildFat">
<input class="BUTTON" type="submit" value="YES">
<input type="hidden" value="1" name="go">
</form>
EOM

print &formatWindow( "Continue?", $text );

}

}


sub checkIntegrity {

open( h, "$DATADIR/_data/fat.txt" )
|| return ( '?', '?', '?', "fat.txt does not exist" );
$r = $n = $d = '0';
while (<h>) {
$r++;
chop;
( $id, $pos ) = split( /\t/, $_ );
if ( $pos{$id} ne '' ) {
$n++;
}
$pos{$id} = $pos;
}
close(h);

@keys = sort { $pos{"$a"} <=> $pos{"$b"} } keys(%pos);

openFile( h, "$DATADIR/_data/records.txt" );

foreach $id (@keys) {
$pos = $pos{$id};

if ( $pos < 0 ) {
$d++;
next;
}

seek( h, $pos, 0 ) || ( $ret .= "Cannot seek $pos for $id\n" );
$meta = <h>;
chop($meta);
( $len, $time ) = split( /\t/, $meta, 2 );
if ( $len =~ /^\d+$/ && $time =~ /^\d+$/ ) {

}
else {
$ret .= "Bad fat entry for $id\n";
}
}
close(h);

return ( $n, $r, $d, $ret );
}


sub openFile {
open( $_[0], $_[1] ) || $_[2] || wbFail("Cannot open $_[1]");
binmode( $_[0] );
}


sub rebuildFat {

$file = "$DATADIR/_data/fat.txt";
rename( $file, &wbBackupFile($file) );

openFile( H, "$DATADIR/_data/records.txt" );
openFile( F, ">$DATADIR/_data/fat.txt" );

$pos = 0;
while (<H>) {
chop;
( $len, $time ) = split( /\t/, $_ );
if ( $len !~ m/\d+/ || $time !~ m/\d+/ ) {
wbFail( "records.txt is corrupt", "Try rebuilding the table from .tbl files. Contents of _data is corrupt." );
}
read( H, $string, $len )
|| wbFail( "Cannot read", "$l bytes from $file" );
recFromVector($string);
$id = $rec{'_id'};

print F $rec{'_id'} . "\t" . $pos . "\n";

$pos = tell(H);
}
close(H);
close(F);

return;
}



sub wbBackupFile {

local ($file) = @_;
local ($add);
@x   = &fixDate(time);
$add = $x[5] . $x[4] . $x[3] . $x[2] . $x[1] . $x[0];
return "$file.at.$add";
}
1;
