

sub cgiAdmWodaStatus {

printHead('WODA Status');

print "<h3>Can we execute another Perl program?</h3>";

$!    = '';
$perl = "$PERL -v";

$out = `$perl`;

if ( $out eq '' ) {
print <<EOM;
<p class="ERROR">
Looks like it will not be possible to run external Perl programs.
Relational features such as &QRY function will not work!
Maype just <br>\$PERL=$PERL<br>was not set up right!
This is the error reported: <b>$!</b>
</p>
EOM
}
else {
print <<EOM;
<p>
Command <b>$perl</b> produced:
<pre>
$out
</pre>
<p>
EOM
}

print <<EOM;
<h3>Directories related to this application</h3>
<p>Note that only <b>$TMPDIR</b> and <b>$DATADIR</b> must exist.
<p>
EOM
@x = &wbCheckDirectories();
push( @x, $TESTCGIDIR );

$testFile = "_test.xxx";
$textText = "This is some test text";
$close    = "</em></td></tr>\n";
$et       = '<em class="ERROR">';
print '<table border="1">';

foreach $x (@x) {
$x = $DISK . $x unless $x =~ m/^[A-Z]\:/;
print '<tr align="left" valign="top"><th>', $x, '</th><td><em class="ERROR">', "\n";

unless ( -e "$x" ) {
print "Does not exist!\n";
print $close;
next;
}

unless ( chdir($x) ) {
print "Cannot chdir to $x!\n";
}

unless ( open( h, ">$x/$testFile" ) ) {
print "Cannot open file $testFile for writing. Check permissions!\n";
print $close;
next;
}
else {
print h $testText;
close(h);
}

unless ( open( h, "$x/$testFile" ) ) {
print "Cannot open file $testFile for reading!\n";
}
else {
$xx = <h>;
if ( $xx ne $testText ) {
print "Read text not equal to written text!\n";
}
close(h);
}

if ($MV) {
`$MV $testFile $testFile.zzz`;
unless ( -e "$testFile.zzz" ) {
print "Could not MV $testFile\n";
}
else {
`$MV $testFile.zzz $testFile`;
}
}

unless ( unlink("$x/$testFile") ) {
print "Cannot delete file $testFile\n";
print $close;
next;
}

print "</em>OK<em>\n";
print $close;
}
print "</table>\n";

print "<h3>External programs</h3> Essential functions work without them! <table>";

@progs = ( '$SENDMAIL', '$AT', '$GREP', '$DUMPABLEPERL', '$UNDUMP' );
foreach $prog (@progs) {
$xprog = eval($prog);
print "<tr><td>$prog</td><td>$xprog</td><td>\n";

if ( !$xprog ) {
print '<em class="WARN">not defined</em>';
}
elsif ( -x $xprog ) {
print "executable";
next;
}
elsif ( -e $xprog && !UNIX ) {
print "exists";
next;
}
else {
print '<em class="WARN">does not exist</em>';
}

}

print "</table>";

if ( $SCRIPTPACKAGE ne $WodaPackage ) {
print "<h3>Subroutines defined in package '$SCRIPTPACKAGE'</h3>\n";

@subs = @MYSubs;
foreach $sub (@MYSubs) {
print "$SCRIPTPACKAGE'$sub()<br>\n";
}
}

print <<EOM;
<h3>Can we use FETCH to get a Webpage into application?</h3>
EOM

$pg   = 'http://woda.sourceforge.net/index.html';
$back = &FETCH($pg);

print <<EOM;
<p>Tried &FETCH(<a href="$pg">$pg</a>). This is what I got back:
<table border="1"><tr><td>
$back
</td></tr></table>
EOM
}
1;
