

sub cgiAgentSave {

printHead("Saving order for searches");    #UK

hashImport( *x, &htUnescape( $CGI{'formdata'} ) );

foreach $key ( keys(%CGI) ) {
next if $key eq 'formdata';
$x{$key} = $CGI{$key};
}
unless ( &isEmail( $x{_email} ) ) {
wbError( "Error", "$x{_email} is not a valid email address" );    #UK
return;
}

$x{_confirm} = &wbCryptPasswd( $x{_email} );
$dform       = $x{_form};
$formdata    = &hashExport(*x);

if ( $COOKIE{_email} && $COOKIE{_email} eq $x{_email} ) {


saveFormAppend($formdata);
saveFormSavedMessage($dform);

}
else {

$r1 = int( rand(100000000) );

open( h, ">>$DATADIR/_tmp/$r1.form" );
binmode(h);
print h $formdata;
print h "\n";
close(h);

$message = <<EOM;    #UK
From: $WBB{'managerEmail'}
To: $x{_email}
Reply-to: $WBB{'managerEmail'}
Subject: Your request in $WBB{'dbTitle'}

Hi,

someone (you) order an agent at
$WBB{'dbTitle'} at $homeURL
to periodically search the database
and send you the results by email to
the address $x{_email}.

To confirm this order, please open this
URL:

$SCRIPTBASE$SCRIPT/AgentConfirm?key=$r1

or enter this value:

$r1

into the form shown at

$SCRIPTBASE$SCRIPT/AgentConfirm

If you don't want to subscribe to the
search just ignore this message.

Automatically,

$WBB{manager},
manager.
EOM

if ( &sendMail($message) ) {
wbError( "Error sending email", "Error was $message" );
}
else {
print <<EOM;    #UK
You will need to <a href="$SCRIPT/AgentConfirm">confirm</a> your request by email.
A message with instructions was sent to $x{_email}.
EOM
}

}
}


sub saveFormSavedMessage {

local ($dform) = @_;

print <<EOM;
<p>Form data saved.
<ul>
<li>Here are <a href="$SCRIPT/FormsList?form=$dform">forms related to $dform</a>.
</li><li>Here are <a href="$SCRIPT/FormsList">all forms</a>
</li></ul>
EOM
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}


sub hashImport {

local ( *hash, $value ) = @_;
local (@x);

@x = split( /\037/, $value );
foreach (@x) {
tr|\034|\012|;
}
%hash = @x;
}


sub hashExport {

local (*hash) = @_;
local ( $key, $val, $out );

$out = '';
foreach $key ( sort( keys(%hash) ) ) {
$val = $hash{$key};

$key =~ tr|\012|\034|;
$val =~ tr|\034| |;      # not 100% simetric!
$val =~ tr|\012|\034|;
$out .= "$key\037$val\037";
}
chop($out);
return $out;
}


sub saveFormAppend {

local ($formdata) = @_;

open( h, ">>$DATADIR/_friend/$User.forms" );
flock( h, 2 );
binmode(h);
print h "_formid\037" . time . "\037";
print h $formdata;
print h "\n";
close(h);
}
1;
