

sub cgiBrowseMatrix {

$field  = $CGI{'row'};
$field2 = $CGI{'col'};

$label  = $WBF{ $field,  'head' } || $field;
$label2 = $WBF{ $field2, 'head' } || $field2;

printHead("Browse Matrix by $label and $label2");    #UK
print <<EOM;                                         #UK
<p>Click on row or column headers to search for records belonging to that
category <em>or</em>
Click on the search icons to search for
a combination of row and column values.
EOM

if ( $CGI{'count'} ne '' ) {
readCatCount( $field, $field2 );
}

@rowWords  = &wbParseOptions($field);
@rowLabels = @optionText;
@colWords  = &wbParseOptions($field2);
@colLabels = @optionText;
$rowTit    = &formatFieldName($field);
$colTit    = &formatFieldName($field2);

$nrows = $#rowWords + 1 + 1 + 1;    # legend,title
$ncols = $#colWords + 1 + 1;
$nc1   = $ncols - 1;

print <<EOM;
<p><table border="1">
<tr>
<th><br></th>
<th COLSPAN=$nc1>
$colTit
</th>
</tr>
<tr>
<th align="right">$rowTit</th>
EOM

$dSearch = 0;

foreach $colWord (@colWords) {
$x = &wbOptionWordSearch( $field2, $colWord );
$s = $colLabels[$dSearch] || $colWord;
print qq(<th><a href="$SCRIPT/Search?search=$x">$s</a></th>\n);
$dSearch++;
}

print "</tr>\n";


$dSearch = 0;
my $iconimage = 'search';
foreach $rowWord (@rowWords) {
$x = &wbOptionWordSearch( $field, $rowWord );
$s = $rowLabels[$dSearch] || $rowWord;
print qq(<tr><th align=RIGHT><a href="$SCRIPT/Search?search=$x">$s</a></th>\n);
foreach $colWord (@colWords) {
$search = "+$field2:\"$colWord\" +$field:\"$rowWord\"";
$search = &htEscape($search);
$surl   = "$SCRIPT/Search?search=$search";
$count  = '';
if ( $CGI{'count'} ) {
$count = $catCount{"$rowWord,$colWord"};
$count = '0' if $count eq '';
$iconimage =
$count
? qq(<img $ICONPAR src="$ICONURL/search.gif" alt="search" title=search>)
: '';
}
print <<EOM;
<td align="CENTER" valign=MIDDLE>
<a href="$surl">$iconimage</a> $count
</td>
EOM
}
print "</tr>\n";
$dSearch++;
}

print "</table>\n";
}


sub wbOptionWordSearch {

local ( $field, $word ) = @_;

$word =~ s|[/()]|\\$&|g;    # escape ( ) and / in search words
return &htEscape("+$field:\"$word\"");
}


sub readCatCount {

local ( $field, $field2 ) = @_;
local ($file) = "_cache/count-$field-$field2.txt";
local (@rows);
if ( &wbExpired($file) ) {
$Log .= "Rebuilding count file $file\n";
$counts = &countCat( $field, $field2 );
open( H, ">$file" ) || wbFail("Cannot open $file for writing\n");    #UK
binmode(H);
print H $counts;
close(H);
}

open( H, $file );
@rows = <H>;
close(H);
foreach $row (@rows) {
chop($row);                                                          # newline
( $cat, $count ) = split( /\t/, $row );
$catCount{$cat} = $count;
}
}


sub countCat {

local ( $field, $field2 ) = @_;
local ($ret);

if ( $field2 eq '' ) {
$all = &ROWS( '', "$field" );
}
else {
$all = &ROWS( '', "$field,$field2" );
}

chop($all);
$all =~ tr/\034/\n/;    # multiple value
@list = split( /\n/, $all );

undef %cat;

foreach $x (@list) {
$x =~ tr/\t/,/;
$cat{$x}++;
}

foreach $cat ( sort( keys(%cat) ) ) {
next if $cat eq '';
$ret .= "$cat\t$cat{$cat}\n";
}

return $ret;
}
1;
