

sub cgiBrowseMatrixForm {

printHead("Define Browse Matrix");    #UK

print <<EOM;                          #UK
<p>This page lets you define a browse matrix. Select 
one field name to display in rows and one to display in colums.
Search matrix will be generated so that you will be able to search for items
with row and column value.<p>
Note that matrices which would include fields marked with a * may take longer to generate.

<p>You can also select a browse matrix using <a href="$SCRIPT/BrowseMatrixList">predefined lists</a>.

<form class="FORM" action="$SCRIPT/BrowseMatrix">
EOM

wbSortFields();
foreach $field (@Fields) {
if ( $WBF{ $field, 'type' } =~ m/OPTION$/ ) {
push( @fields, $field );
$nice = &formatFieldName( $field, 1 );
$nice .= " *" if $WBF{ $field, 'type' } eq 'LINKOPTION';
push( @niceFields, $nice );
}
}

$opts = '';
for ( $i = 0 ; $i <= $#fields ; $i++ ) {
$n = $fields[$i];
$v = $niceFields[$i];
$opts .= "<option value=\"$n\">$v\n";
}

$c  = "Field to use for columns";    #UK
$r  = "Field to use for rows";       #UK
$cm = "Count matching records?";     #UK
print <<EOM;
<table border="1">
<tr>
<td><br></td>
<td align="CENTER">
$c<br>
<select name="col">
$opts
</select>
</td>
</tr>

<tr>
<td align="CENTER">
$r<br>
<select name="row">
$opts
</select>
</td>
<td><br></td>
</tr></table>
<p>
<input name="count" type="checkbox"> $cm
</p>
<input class="BUTTON" type="submit" value="   OK   ">
</form>
EOM
}
1;
