

sub cgiReg2 {

wbCanCookie();

$to   = $CGI{'email'};
$name = $CGI{'name'};

unless ( &isEmail($to) ) {
$to = &htQuote($to);
wbError( "Bad email address", "'$to' is not a valid email address." );    #UK
}


$key = &getRegisteredKey($to);
if ($key) {
( $to, $name ) = &getRegisteredData($key);
loginRegistered( $key, $to, $name );
printHead("Registration renewed");                                        #UK
print <<EOM;                                                              #UK
<p>$to registered before. The registration will be
remembered (using a cookie) in this browser as well. 
EOM
return;
}

printHead("Registration: Step 2/3");                                          #UK

$from = $WBB{'managerEmail'};
$key  = int( rand(100000000) );
$url  = "$SCRIPTBASE$SCRIPT/Reg3?key=$key";

$subject = "REGISTRATION: " . $WBB{'dbTitle'};                                #UK

$headers = <<EOM;
From: $from
Reply-to: $from
To: $to
Subject: $subject
EOM

$message = <<EOM;                                                             #UK
Hi,

To conclude the registration,
please open this URL:

$url

or enter this value:

$key

into the form shown at

$SCRIPTBASE$SCRIPT/Reg3

Automatically,

$WBB{'manager'},
manager.
EOM


open( h, ">$TMPDIR/$key.reg" );
binmode(h);
print h "$to\t$name\n" || wbFail("Could not write .reg file");
close(h);


$message = "$headers\n$message";

wbFail( "Error sending mail", "Email could not be sent. <br />Check the -f flag, eg, -f postmaster@xyz.net" ) if &sendMail($message);

print <<EOM;    #UK
<p>Soon you will receive an email with these headers:
<pre>$headers
</pre>
<p>In the email, you will learn a key,
so that you will be able to complete your
registration at <a href="$SCRIPT/Reg3">$SCRIPTBASE$SCRIPT/Reg3</a>.

<p>Until then you can continue to use
this application just as before.
EOM
}


sub sendMail {

if ( $SENDMAIL eq '' ) {
$Log .= "Sent mail via Sockets\n";
return &sendMailSock(@_);
}
else {
$Log .= "Sent mail via $SENDMAIL\n";
return &sendMailProg(@_);
}
}


sub sendMailProg {

local ($message) = @_;

$| = 1;

findSendmail();


open( MAIL, "|$SENDMAIL -t -i $SENDMAILFLAGS 2>&1" ) || return 1;
print MAIL $message || return 1;
close(MAIL) || return 1;

$Log .= "$SENDMAIL -t -i $SENDMAILFLAGS 2>&1\n";

return '';
}


sub sendMailSock {

local ($message) = @_;

$message =~ m/From:\s*([^\n]*)/;
$from = $1;
$from =~ s/\s//g;

$message =~ m/To:\s*([^\n]*)/;
$to = $1;
$to =~ s/\s//g;

unless ( &isEmail($to) ) {
$to = &htQuote($to);
return "ERROR: '$to' is not a valid email address";
}

$message =~ s/^\./\.\./gm;    # . as first character m=treat string as multiple lines
$message =~ s/\r//g;          # remove CR
$message =~ s/\n/\r\n/gm;     # CR-LF always


$port = ( getservbyname( 'smtp', 'tcp' ) )[2];
$e = &wbOpenS( $SMTPHOST, $port );
if ( $e ne '' ) {
return "ERROR: connecting to $SMTPHOST port $port; $e.";
}


print S "helo woda\r\n";
$i = <S>;

if ( $i !~ m/^[45]/ ) {
$i = &smtpSend( $from, $to, $message );
}

if ( $i =~ m/^[45]/ ) {
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tError to $to\n";
close(h);
return ("Sending mail to $to failed Error was: $i");
}
else {
print S "quit\r\n";
$_ = <S>;
close(S);
open( h, ">>$DATADIR/_log/sockMail" );
print h time, "\tSent to $to\n";
close(h);
return '';
}

}


sub isEmail {

local ($chr);

return $_[0] =~ m/^[\w\-\+\.]+\@[\w\-\+\.]+\.[a-z]{2,4}$/i;    # something@something.com|si

}


sub smtpSend {

local ( $from, $to, $message ) = @_;

print S "mail from: $from\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "rcpt to: $to\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "data\r\n";
$_ = <S>;
if (/^[45]/) { return $_; }

print S "X-Mailer: Woda http://woda.sourceforge.net/\r\n";
print S "$message";
print S "\r\n.\r\n";

$_ = <S>;
if (/^[45]/) { return $_; }

return '';
}


sub wbCanCookie {

if ( $ENV{'HTTP_COOKIE'} eq '' ) {
$x = <<EOM;    #UK
It seems that you are not letting this application
to set cookies or your browser is not supporting
them at all.
<p>
Please enable cookies and reload this page.
<p>
Cookie is a small piece of information
stored <b>in your PC</b>. Your browser sends it
to us whenever you use this application, so that
we can maintain who you are.This is quite
essential for some operations.
<p>
We let you review and/or delete any cookies this application set
in the 'AboutUser' page.
EOM

wbError( "Cookies disabled", $x );

}
}


sub getRegisteredData {

local ($k) = @_;

open( h, "$DATADIR/_cache/register.txt" );
while (<h>) {
if (m/^$k\t/) {
( $key, $email, $name ) = split( /\t/, $_, 3 );
chop($name);
return $email;
}
}
return '';
}


sub getRegisteredKey {

local ($e) = @_;    # email address

open( h, "$DATADIR/_cache/register.txt" );
while (<h>) {
if (m/\t$e\t/) {
return $`;
}
}
return '';
}


sub loginRegistered {

local ( $key, $email, $name ) = @_;

$COOKIE{_user}  = "_$key";
$COOKIE{_email} = $email;
$COOKIE{_name}  = $name;

wbLogin();

$cscope = $WBB{'userScope'} || $COOKIESCOPE;
$uc = &htFormatCookie( '_user',  "_$key",  $cscope );
$ec = &htFormatCookie( '_email', "$email", $cscope );
$nc = &htFormatCookie( '_name',  "$name",  $cscope );
&htDemandCookie( $uc, $ec, $nc );
}
1;
