

sub cgiShow {

&PIC() if 0;       # may need to have it compiled in, so call it, but don't use it

$id = $CGI{'_id'} || $CGI{'_isindex'};

$sort   = $CGI{'sort'};
$format = $CGI{'format'};
@fields = split( /,/, $CGI{'fields'} );

recRead($id);

if ( $rec{'_id'} eq '' ) {
wbError( 'Error:No such record', "Record with id=$id does not exist or it has been recently deleted" );    #UK
}

if ( $format eq 'XML' ) {
@fields = &visibleFields() unless $#fields >= 0;
printXmlHead();
print "<!DOCTYPE rec>\n";
print &rec2xml(@fields);
}
elsif ( $format eq 'XMLE' ) {
wbSortFields();

@fields = @IFields unless $#fields >= 0;
printXmlHead();
print "<!DOCTYPE rec>\n";
print &rec2xmle(@fields);
}
else {

wbSetOwner();

if (   $Group ne 'admin'
&& $WBB{'hideUnless'}
&& !&evalSafe( $WBB{'hideUnless'} ) )
{    # setting
wbError( "This record is not available", "User '$User' from group '$Group' is not allowed to see it" );    #UK
}

$MetaFields = '';
@fields     = &visibleFields();
foreach $field (@fields) {
$meta = $WBF{ $field, 'meta' };
if ( $meta ne '' ) {
$val = &htQuote( $rec{$field} );
$MetaFields .= qq(<meta name="$meta" content="$val">\n);
}
}

$x = &evalSafe( $WBB{'detailTitle'} )
|| "$WBB{'recordTitle'} $id <!-- see WBB{'detailTitle'} and WBB{'recordTitle'} -->";
printHead("$x");

$html = &wbRecHtml();

paintFoundRec(*html);
print $html;

$allHits = $CGI{'hits'};
setShowToolbar();

$idq = &htEscape($id);

print <<EOM if $WBB{'similar'};    #UK
<ul>
<li>Users who put this record into basket also <a href="$SCRIPT/SimilarBasket?id=$idq">placed into basket these records</a>.</li>
<li>Users who displayed this record <a href="$SCRIPT/SimilarShow?id=$idq">also displayed these records</a>.</li>
</ul>
EOM

}
}


sub printXmlHead {
$e = $WBB{'intlCharset'} || 'UTF-8';
print $HTTP200OK;
print "Content-type: text/xml\n\n";
print <<EOM;
<?xml version="1.0" encoding="$e" standalone="yes" ?>
EOM
}


sub setShowToolbar {

@hlps = (
"pick and add to $WBB{'basketName'}",        #UK
'modify the information',                    #UK
'delete entire record',                      #UK
'delete password',                           #UK
'explain the meaning of the fields',         #UK
'view how record was changing over time',    #UK
'',                                          #UK
'',                                          #UK
'',                                          #UK
''                                           #UK
);
@butts = ( 'PICK',         'EDIT', 'DELETE', 'DELETE PASSWORD', 'LEGEND',           'HISTORY',          'FIRST', 'PREVIOUS', 'NEXT', 'LAST' ); #UK
@acts  = ( 'BasketAddOne', 'Edit', 'Delete', 'AdmDelPass',      'DisplayStructure', 'AdmRecordHistory', 'Go',    'Go',       'Go',   'Go' );
@to    = ( '',             '',     '',       '',                '',                 '',                 'first', 'previous', 'next', 'last' );
@icons = ( 'basket', 'edit', 'del', 'delpass', 'info', 'history', 'first', 'back', 'forward', 'last' );

if ( !$WBB{'basketName'} ) {
shift @hlps;
shift @butts;
shift @acts;
shift @to;
shift @icons;
}

$ret = "";

$i = 0;
foreach $act (@acts) {
if ( &wbDenied( $Group, $act ) ) {
$i++;
next;
}
if ($InFrame) {
$act .= "ToFrameD";
$target = 'target="_self"';
}
else {
$target = '';
}
$x = &htEscape($id);
if ( $icons[$i] =~ m/edit|del|back|forward|basket|history/ ) {
$params = "_id=$x";
}
else {
$params = "";
}
$extra = '';
if ( $act =~ m/^Go/ ) {
$params = $params . '&' if $params;
$params .= "sort=$sort&amp;to=$to[$i]";
if ( $CGI{'search'} ne '' ) {
$s = &htEscape( $CGI{'search'} );
$params .= "&amp;search=$s";
}
next
if $allHits > 100;    # only allow browsing if less than 100 results
next unless $sort;
next if $CGI{'search'} eq '';
}

if ( $act =~ m/^Basket/ ) {
$target = 'target="woda_basket"';
}

$h = $hlps[$i] || $butts[$i];

$params = "?" . $params if $params;

push( @Toolbar, <<EOM);    #xxx
<a href="$SCRIPT/$act$params" $target><img 
$ICONPAR src="$ICONURL/$icons[$i].gif" alt="$h" title="$h"></a>
EOM
$i++;
}
}
1;
